2023-04-03 15:47 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.17.1 Released.

2023-03-29 13:49 +0000 [2227bfbb2b]  Mike Bradeen <mbradeen@sangoma.com>

	* res_pjsip_pubsub: subscription cleanup changes

	  There are two main parts of the change associated with this
	  commit. These are driven by the change in call order of
	  pubsub_on_rx_refresh and pubsub_on_evsub_state by pjproject
	  when an in-dialog SUBSCRIBE is received.

	  First, the previous behavior was for pjproject to call
	  pubsub_on_rx_refresh before calling pubsub_on_evsub_state
	  when an in-dialog SUBSCRIBE was received that changes the
	  subscription state.

	  If that change was a termination due to a re-SUBSCRIBE with
	  an expires of 0, we used to use the call to pubsub_on_rx_refresh
	  to set the substate of the evsub to TERMINATE_PENDING before
	  pjproject could call pubsub_on_evsub_state.

	  This substate let pubsub_on_evsub_state know that the
	  subscription TERMINATED event could be ignored as there was
	  still a subsequent NOTIFY that needed to be generated and
	  another call to pubsub_on_evsub_state to come with it.

	  That NOTIFY was sent via serialized_pubsub_on_refresh_timeout
	  which would see the TERMINATE_PENDING state and transition it
	  to TERMINATE_IN_PROGRESS before triggering another call to
	  pubsub_on_evsub_state (which now would clean up the evsub.)

	  The new pjproject behavior is to call pubsub_on_evsub_state
	  before pubsub_on_rx_refresh. This means we no longer can set
	  the state to TERMINATE_PENDING to tell pubsub_on_evsub_state
	  that it can ignore the first TERMINATED event.

	  To handle this, we now look directly at the event type,
	  method type and the expires value to determine whether we
	  want to ignore the event or use it to trigger the evsub
	  cleanup.

	  Second, pjproject now expects the NOTIFY to actually be sent
	  during pubsub_on_rx_refresh and avoids the protocol violation
	  inherent in sending a NOTIFY before the SUBSCRIBE is
	  acknowledged by caching the sent NOTIFY then sending it
	  after responding to the SUBSCRIBE.

	  This requires we send the NOTIFY using the non-serialized
	  pubsub_on_refresh_timeout directly and let pjproject handle
	  the protocol violation.

	  ASTERISK-30469

	  Change-Id: I05c1d91a44fe28244ae93faa4a2268a3332b5fd7

2023-03-19 16:30 +0000 [c740de44f2]  Sean Bright <sean@seanbright.com>

	* Revert "pbx_ael: Global variables are not expanded."

	  This reverts commit f67258d17283f245b0d8a34c2288ca290fe679bf.

	  Reason for revert: Behavior change that breaks existing dialplan.

	  ASTERISK-30472 #close

	  Change-Id: Ia03fa7f049f964ed396f6bf6d7ca096b665aa6b3

2023-03-09 17:12 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.17.0 Released.

2023-03-02 16:41 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.17.0-rc1 Released.

2023-03-02 10:35 +0000 [69297b59df]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.17.0
2023-02-16 10:05 +0000 [1ddfb7551a]  George Joseph <gjoseph@sangoma.com>

	* res_pjsip: Replace invalid UTF-8 sequences in callerid name

	  * Added a new function ast_utf8_replace_invalid_chars() to
	    utf8.c that copies a string replacing any invalid UTF-8
	    sequences with the Unicode specified U+FFFD replacement
	    character.  For example:  "abc\xffdef" becomes "abc\uFFFDdef".
	    Any UTF-8 compliant implementation will show that character
	    as a � character.

	  * Updated res_pjsip:set_id_from_hdr() to use
	    ast_utf8_replace_invalid_chars and print a warning if any
	    invalid sequences were found during the copy.

	  * Updated stasis_channels:ast_channel_publish_varset to use
	    ast_utf8_replace_invalid_chars and print a warning if any
	    invalid sequences were found during the copy.

	  ASTERISK-27830

	  Change-Id: I4ffbdb19c80bf0efc675d40078a3ca4f85c567d8

2023-02-27 18:35 +0000 [a724298da9]  Sean Bright <sean@seanbright.com>

	* test.c: Avoid passing -1 to FD_* family of functions.

	  This avoids buffer overflow errors when running tests that capture
	  output from child processes.

	  This also corrects a copypasta in an off-nominal error message.

	  Change-Id: Ib482847a3515364f14c7e7a0c0a4213851ddb10d

2023-02-27 15:35 +0000 [f4965b9430]  Sean Bright <sean@seanbright.com>

	* test_crypto.c: Fix getcwd(…) build error.

	  `getcwd(…)` is decorated with the `warn_unused_result` attribute and
	  therefore needs its return value checked.

	  Change-Id: Idcccb20a0abf293202c28633d0e9ee0f6a9dbe93

2022-12-14 10:00 +0000 [6aa28346cf]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Fix jitterbuffer regression prior to receiving audio.

	  ASTERISK_29392 (a security fix) introduced a regression by
	  not processing frames when we don't have an audio format.

	  Currently, chan_iax2 only calls jb_get to read frames from
	  the jitterbuffer when the voiceformat has been set on the pvt.
	  However, this only happens when we receive a voice frame, which
	  means that prior to receiving voice frames, other types of frames
	  get stalled completely in the jitterbuffer.

	  To fix this, we now fallback to using the format negotiated during
	  call setup until we've actually received a voice frame with a format.
	  This ensures we're always able to read from the jitterbuffer.

	  ASTERISK-30354 #close
	  ASTERISK-30162 #close

	  Change-Id: Ie4fd1e8e088a145ad89e0427c2100a530e964fe9

2023-02-11 06:58 +0000 [7196eb524b]  Nick French <nickfrench@gmail.com>

	* pjproject_bundled: Fix cross-compilation with SSL libs.

	  Asterisk makefiles auto-detect SSL library availability,
	  then they assume that pjproject makefiles will also autodetect
	  an SSL library at the same time, so they do not pass on the
	  autodetection result to pjproject.

	  This normally works, except the pjproject makefiles disables
	  autodetection when cross-compiling.

	  Fix by explicitly configuring pjproject to use SSL if we
	  have been told to use it or it was autodetected

	  ASTERISK-30424 #close

	  Change-Id: I8fe2999ea46710e21d1d55a1bed92769c6ebded9

2023-01-30 17:14 +0000 [fc5b7ab459]  Mike Bradeen <mbradeen@sangoma.com>

	* app_read: Add an option to return terminator on empty digits.

	  Adds 'e' option to allow Read() to return the terminator as the
	  dialed digits in the case where only the terminator is entered.

	  ie; if "#" is entered, return "#" if the 'e' option is set and ""
	  if it is not.

	  ASTERISK-30411

	  Change-Id: I49f3221824330a193a20c660f99da0f1fc2cbbc5

2023-01-07 23:04 +0000 [66f6d9113e]  cmaj <chris@penguinpbx.com>

	* res_phoneprov.c: Multihomed SERVER cache prevention

	  Phones moving between subnets on multi-homed server have their
	  initially connected interface IP cached in the SERVER variable,
	  even when it is not specified in the configuration files. This
	  prevents phones from obtaining the correct SERVER variable value
	  when they move to another subnet.

	  ASTERISK-30388 #close
	  Reported-by: cmaj

	  Change-Id: I1d18987a9d58e85556b4c4a6814ce7006524cc92

2023-01-27 14:23 +0000 [3b75e6d45e]  Mike Bradeen <mbradeen@sangoma.com>

	* app_directory: Add a 'skip call' option.

	  Adds 's' option to skip calling the extension and instead set the
	  extension as DIRECTORY_EXTEN channel variable.

	  ASTERISK-30405

	  Change-Id: Ib9d9db1ba5b7524594c640461b4aa8f752db8299

2023-02-21 14:25 +0000 [114630279d]  Mike Bradeen <mbradeen@sangoma.com>

	* res_pjsip: Prevent SEGV in pjsip_evsub_send_request

	  contributed pjproject - patch to check sub->pending_notify
	  in evsub.c:on_tsx_state before calling
	  pjsip_evsub_send_request()

	  res_pjsip_pubsub - change post pjsip 2.13 behavior to use
	  pubsub_on_refresh_timeout to avoid the ao2_cleanup call on
	  the sub_tree. This is is because the final NOTIFY send is no
	  longer the last place the sub_tree is referenced.

	  ASTERISK-30419

	  Change-Id: Ib5cc662ce578e9adcda312e16c58a10b6453e438

2023-02-06 09:54 +0000 [f015d3e0cc]  Mike Bradeen <mbradeen@sangoma.com>

	* app_senddtmf: Add option to answer target channel.

	  Adds a new option to SendDTMF() which will answer the specified
	  channel if it is not already up. If no channel is specified, the
	  current channel will be answered instead.

	  ASTERISK-30422

	  Change-Id: Iddcbd501fcdf9fef0f453b7a8115a90b11f1d085

2023-02-02 08:19 +0000 [603675f285]  Sean Bright <sean@seanbright.com>

	* app_queue: Minor docs and logging fixes for UnpauseQueueMember.

	  ASTERISK-30417 #close

	  Change-Id: I7534e7a925bf92a7b5a5347f5f54225768c162fe

2023-01-31 08:40 +0000 [7687c75cb6]  Sean Bright <sean@seanbright.com>

	* app_queue: Reset all queue defaults before reload.

	  Several queue fields were not being set to their default value during
	  a reload.

	  Additionally added some sample configuration options that were missing
	  from queues.conf.sample.

	  Change-Id: I3a88c7877af91752b1b46a0c087384f7eb9c47e4

2023-01-20 16:50 +0000 [24e27a3c6e]  Mike Bradeen <mbradeen@sangoma.com>

	* res_pjsip: Upgraded bundled pjsip to 2.13

	  Removed multiple patches.

	  Code chages in res_pjsip_pubsub due to changes in evsub.

	  Pjsip now calls on_evsub_state() before on_rx_refresh(),
	  so the sub tree deletion that used to take place in
	  on_evsub_state() now must take place in on_rx_refresh().

	  Additionally, pjsip now requires that you send the NOTIFY
	  from within on_rx_refresh(), otherwise it will assert
	  when going to send the 200 OK. The idea is that it will
	  look for this NOTIFY and cache it until after sending the
	  response in order to deal with the self-imposed message
	  mis-order. Asterisk previously dealt with this by pushing
	  the NOTIFY in on_rx_refresh(), but pjsip now forces us
	  to use it's method.

	  Changes were required to configure in order to detect
	  which way pjsip handles this as the two are not
	  compatible for the reasons mentioned above.

	  A corresponding change in testsuite is required in order
	  to deal with the small interal timing changes caused by
	  moving the NOTIFY send.

	  ASTERISK-30325

	  Change-Id: I50b00cac89d950d3511d7b250a1c641965d9fe7f

2022-01-06 16:11 +0000 [d53c8fc4dc]  Naveen Albert <asterisk@phreaknet.org>

	* app_signal: Add signaling applications

	  Adds the Signal and WaitForSignal
	  applications, which can be used for inter-channel
	  signaling in the dialplan.

	  Signal supports sending a signal to other channels
	  listening for a signal of the same name, with an
	  optional data payload. The signal is received by
	  all channels waiting for that named signal.

	  ASTERISK-29810 #close

	  Change-Id: Ic34439de3d60f8609357666a465c354d81f5fef3

2023-01-30 15:17 +0000 [41d3a57627]  Sean Bright <sean@seanbright.com>

	* doxygen: Fix doxygen errors.

	  Change-Id: Ic50e95b4fc10f74ab15416d908e8a87ee8ec2f85

2023-01-25 16:27 +0000 [ef6901e137]  Mike Bradeen <mbradeen@sangoma.com>

	* app_directory: add ability to specify configuration file

	  Adds option to app_directory to specify a filename from which to
	  read configuration instead of voicemail.conf ie;

	  same => n,Directory(,,c(directory.conf))

	  This configuration should contain a list of extensions using the
	  voicemail.conf format, ie;

	  2020=2020,Dog Dog,,,,attach=no|saycid=no|envelope=no|delete=no

	  ASTERISK-30404

	  Change-Id: Id58ccb1344ad1e563fa10db12f172fbd104a9d13

2023-01-26 14:18 +0000 [f67258d172]  Sean Bright <sean@seanbright.com>

	* pbx_ael: Global variables are not expanded.

	  Variable references within global variable assignments are now
	  expanded rather than being included literally.

	  ASTERISK-30406 #close

	  Change-Id: I136e8d6395e90a4c92d9777a46a7bc3edb08d05d

2022-02-12 15:59 +0000 [7b9ef96173]  Naveen Albert <asterisk@phreaknet.org>

	* func_json: Enhance parsing capabilities of JSON_DECODE

	  Adds support for arrays to JSON_DECODE by allowing the
	  user to print out entire arrays or index a particular
	  key or print the number of keys in a JSON array.

	  Additionally, adds support for recursively iterating a
	  JSON tree in a single function call, making it easier
	  to parse JSON results with multiple levels. A maximum
	  depth is imposed to prevent potentially blowing
	  the stack.

	  Also fixes a bug with the unit tests causing an empty
	  string to be printed instead of the actual test result.

	  ASTERISK-29913 #close

	  Change-Id: I603940b216a3911b498fc6583b18934011ef5d5b

2022-10-13 08:45 +0000 [ec0ca7dcbc]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_session: Add overlap_context option.

	  Adds the overlap_context option, which can be used
	  to explicitly specify a context to use for overlap
	  dialing extension matches, rather than forcibly
	  using the context configured for the endpoint.

	  ASTERISK-30262 #close

	  Change-Id: Ibbcd4a8b11402428a187fb56b8d4e7408774a0db

2023-01-04 06:35 +0000 [2f36ab7978]  sungtae kim <sungtae.kim@avoxi.com>

	* res_stasis_snoop: Fix snoop crash

	  Added NULL pointer check and channel lock to prevent resource release
	  while the chanspy is processing.

	  ASTERISK-29604

	  Change-Id: Ibdc675f98052da32333b19685b1708a3751b6d24

2023-01-05 10:41 +0000 [07a850c6dd]  Sean Bright <sean@seanbright.com>

	* app_playback.c: Fix PLAYBACKSTATUS regression.

	  In Asterisk 11, if a channel was redirected away during Playback(),
	  the PLAYBACKSTATUS variable would be set to SUCCESS. In Asterisk 12
	  (specifically commit 7d9871b3940fa50e85039aef6a8fb9870a7615b9) that
	  behavior was inadvertently changed and the same operation would result
	  in the PLAYBACKSTATUS variable being set to FAILED. The Asterisk 11
	  behavior has been restored.

	  Partial fix for ASTERISK~25661.

	  Change-Id: I53f54e56b59b61c99403a481b6cb8d88b5a559ff

2023-01-11 11:17 +0000 [6c75383fd5]  George Joseph <gjoseph@digium.com>

	* res_rtp_asterisk: Don't use double math to generate timestamps

	  Rounding issues with double math were causing rtp timestamp
	  slips in outgoing packets.  We're now back to integer math
	  and are getting no more slips.

	  ASTERISK-30391

	  Change-Id: I6ba992b49ffdf9ebea074581dfa784a188c661a4

2022-11-17 20:16 +0000 [de745157ca]  Igor Goncharovsky <igorg@iqtek.ru>

	* res_pjsip_rfc3326: Add SIP causes support for RFC3326

	  Add ability to set HANGUPCAUSE when SIP causecode received in BYE (in addition to currently supported Q.850).

	  ASTERISK-30319 #close

	  Change-Id: I3f55622dc680ce713a2ffb5a458ef5dd39fcf645

2023-01-06 10:06 +0000 [462133e5e4]  Alexei Gradinari <alex2grad@gmail.com>

	* format_wav: replace ast_log(LOG_DEBUG, ...) by ast_debug(1, ...)

	  Each playback of WAV files results in logging
	  "Skipping unknown block 'LIST'".

	  To prevent unnecessary flooding of this DEBUG log this patch replaces
	  ast_log(LOG_DEBUG, ...) by ast_debug(1, ...).

	  Change-Id: Iaa09cf19c5348a05385518fdb8cb181b45fe05f0

2022-10-28 05:57 +0000 [345ff2d8ee]  George Joseph <gjoseph@digium.com>

	* res_rtp_asterisk: Asterisk Media Experience Score (MES)

	  -----------------

	  This commit reinstates MES with some casting fixes to the
	  functions in time.h that convert between doubles and timeval
	  structures.  The casting issues were causing incorrect
	  timestamps to be calculated which caused transcoding from/to
	  G722 to produce bad or no audio.

	  ASTERISK-30391

	  -----------------

	  This module has been updated to provide additional
	  quality statistics in the form of an Asterisk
	  Media Experience Score.  The score is avilable using
	  the same mechanisms you'd use to retrieve jitter, loss,
	  and rtt statistics.  For more information about the
	  score and how to retrieve it, see
	  https://wiki.asterisk.org/wiki/display/AST/Media+Experience+Score

	  * Updated chan_pjsip to set quality channel variables when a
	    call ends.
	  * Updated channels/pjsip/dialplan_functions.c to add the ability
	    to retrieve the MES along with the existing rtcp stats when
	    using the CHANNEL dialplan function.
	  * Added the ast_debug_rtp_is_allowed and ast_debug_rtcp_is_allowed
	    checks for debugging purposes.
	  * Added several function to time.h for manipulating time-in-samples
	    and times represented as double seconds.
	  * Updated rtp_engine.c to pass through the MES when stats are
	    requested.  Also debug output that dumps the stats when an
	    rtp instance is destroyed.
	  * Updated res_rtp_asterisk.c to implement the calculation of the
	    MES.  In the process, also had to update the calculation of
	    jitter.  Many debugging statements were also changed to be
	    more informative.
	  * Added a unit test for internal testing.  The test should not be
	    run during normal operation and is disabled by default.

	  Change-Id: I4fce265965e68c3fdfeca55e614371ee69c65038

2023-01-09 07:20 +0000 [8067229418]  George Joseph <gjoseph@digium.com>

	* Revert "res_rtp_asterisk: Asterisk Media Experience Score (MES)"

	  This reverts commit 62745013a4de9bafeda8dad6cab2b98c050ff69d.

	  Reason for revert: Issue when transcoding to/from g722

	  Change-Id: I1665a5442bfb6d7bfa06fdcea3374f4581395b4a

2022-12-08 15:44 +0000 [bde2689e1b]  Naveen Albert <asterisk@phreaknet.org>

	* loader: Allow declined modules to be unloaded.

	  Currently, if a module declines to load, dlopen is called
	  to register the module but dlclose never gets called.
	  Furthermore, loader.c currently doesn't allow dlclose
	  to ever get called on the module, since it declined to
	  load and the unload function bails early in this case.

	  This can be problematic if a module is updated, since the
	  new module cannot be loaded into memory since we haven't
	  closed all references to it. To fix this, we now allow
	  modules to be unloaded, even if they never "loaded" in
	  Asterisk itself, so that dlclose is called and the module
	  can be properly cleaned up, allowing the updated module
	  to be loaded from scratch next time.

	  ASTERISK-30345 #close

	  Change-Id: Ifc743aadfa85ebe3284e02a63e124dafa64988d5

2022-08-15 15:04 +0000 [0dc3d8c655]  Naveen Albert <asterisk@phreaknet.org>

	* app_broadcast: Add Broadcast application

	  Adds a new application, Broadcast, which can be used for
	  one-to-many transmission and many-to-one reception of
	  channel audio in Asterisk. This is similar to ChanSpy,
	  except it is designed for multiple channel targets instead
	  of a single one. This can make certain kinds of audio
	  manipulation more efficient and streamlined. New kinds
	  of audio injection impossible with ChanSpy are also made
	  possible.

	  ASTERISK-30180 #close

	  Change-Id: I7ba72f765dbab9b58deeae028baca3f4f8377726

2022-12-13 14:35 +0000 [3e4c012215]  Naveen Albert <asterisk@phreaknet.org>

	* func_frame_trace: Print text for text frames.

	  Since text frames contain a text body, make FRAME_TRACE
	  more useful for text frames by actually printing the text.

	  ASTERISK-30353 #close

	  Change-Id: Ia6ce3d15cecd7a673a528d34faac86854a2bab50

2022-12-28 13:33 +0000 [e85f23e6e5]  Boris P. Korzun <drtr0jan@yandex.ru>

	* http.c: Fix NULL pointer dereference bug

	  If native HTTP is disabled but HTTPS is enabled and status page enabled
	  too, Core/HTTP crashes while loading. 'global_http_server' references
	  to NULL, but the status page tries to dereference it.

	  The patch adds a check for HTTP is enabled.

	  ASTERISK-30379 #close

	  Change-Id: I11b02fc920b72aaed9c809fc43210523ccfdc249

2022-12-16 12:25 +0000 [811584ded3]  Naveen Albert <asterisk@phreaknet.org>

	* json.h: Add ast_json_object_real_get.

	  json.h contains macros to get a string and an integer
	  from a JSON object. However, the macro to do this for
	  JSON reals is missing. This adds that.

	  ASTERISK-30361 #close

	  Change-Id: I8d0e28d763febf27b05801cdc83b73282aa6ee7a

2022-12-16 01:00 +0000 [6dcb908025]  Holger Hans Peter Freyther <holger@moiji-mobile.com>

	* res_http_media_cache: Do not crash when there is no extension

	  Do not crash when a URL has no path component as in this case the
	  ast_uri_path function will return NULL. Make the code cope with not
	  having a path.

	  The below would crash
	  > media cache create http://google.com /tmp/foo.wav

	  Thread 1 "asterisk" received signal SIGSEGV, Segmentation fault.
	  0x0000ffff836616cc in strrchr () from /lib/aarch64-linux-gnu/libc.so.6
	  (gdb) bt
	   #0  0x0000ffff836616cc in strrchr () from /lib/aarch64-linux-gnu/libc.so.6
	   #1  0x0000ffff43d43a78 in file_extension_from_string (str=<optimized out>, buffer=buffer@entry=0xffffca9973c0 "",
	      capacity=capacity@entry=64) at res_http_media_cache.c:288
	   #2  0x0000ffff43d43bac in file_extension_from_url_path (bucket_file=bucket_file@entry=0x3bf96568,
	      buffer=buffer@entry=0xffffca9973c0 "", capacity=capacity@entry=64) at res_http_media_cache.c:378
	   #3  0x0000ffff43d43c74 in bucket_file_set_extension (bucket_file=bucket_file@entry=0x3bf96568) at res_http_media_cache.c:392
	   #4  0x0000ffff43d43d10 in bucket_file_run_curl (bucket_file=0x3bf96568) at res_http_media_cache.c:555
	   #5  0x0000ffff43d43f74 in bucket_http_wizard_create (sorcery=<optimized out>, data=<optimized out>, object=<optimized out>)
	      at res_http_media_cache.c:613
	   #6  0x0000000000487638 in bucket_file_wizard_create (sorcery=<optimized out>, data=<optimized out>, object=<optimized out>)
	      at bucket.c:191
	   #7  0x0000000000554408 in sorcery_wizard_create (object_wizard=object_wizard@entry=0x3b9f0718,
	      details=details@entry=0xffffca9974a8) at sorcery.c:2027
	   #8  0x0000000000559698 in ast_sorcery_create (sorcery=<optimized out>, object=object@entry=0x3bf96568) at sorcery.c:2077
	   #9  0x00000000004893a4 in ast_bucket_file_create (file=file@entry=0x3bf96568) at bucket.c:727
	   #10 0x00000000004f877c in ast_media_cache_create_or_update (uri=0x3bfa1103 "https://google.com",
	      file_path=0x3bfa1116 "/tmp/foo.wav", metadata=metadata@entry=0x0) at media_cache.c:335
	   #11 0x00000000004f88ec in media_cache_handle_create_item (e=<optimized out>, cmd=<optimized out>, a=0xffffca9976b8)
	      at media_cache.c:640

	  ASTERISK-30375 #close

	  Change-Id: I6a9433688cb5d3d4be8758b7642d923bdde6c273

2022-12-21 19:01 +0000 [9ede683f4e]  Naveen Albert <asterisk@phreaknet.org>

	* manager: Fix appending variables.

	  The if statement here is always false after the for
	  loop finishes, so variables are never appended.
	  This removes that to properly append to the end
	  of the variable list.

	  ASTERISK-30351 #close
	  Reported by: Sebastian Gutierrez

	  Change-Id: I1b7f8b85a8918f6a814cb933a479d4278cf16199

2022-12-23 06:02 +0000 [db6e9c4e50]  George Joseph <gjoseph@digium.com>

	* res_pjsip_transport_websocket: Add remote port to transport

	  When Asterisk receives a new websocket conenction, it creates a new
	  pjsip transport for it and copies connection data into it.  The
	  transport manager then uses the remote IP address and port on the
	  transport to create a monitor for each connection.  However, the
	  remote port wasn't being copied, only the IP address which meant
	  that the transport manager was creating only 1 monitoring entry for
	  all websocket connections from the same IP address. Therefore, if
	  one of those connections failed, it deleted the transport taking
	  all the the connections from that same IP address with it.

	  * We now copy the remote port into the created transport and the
	    transport manager behaves correctly.

	  ASTERISK-30369

	  Change-Id: Ib506d40897ea6286455ac0be4dfbb0ed43b727e1

2022-12-21 09:01 +0000 [a29f3f864d]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_app: Update outdated pbx_exec channel snapshots.

	  pbx_exec makes a channel snapshot before executing applications.
	  This doesn't cause an issue during normal dialplan execution
	  where pbx_exec is called over and over again in succession.
	  However, if pbx_exec is called "one off", e.g. using
	  ast_pbx_exec_application, then a channel snapshot never ends
	  up getting made after the executed application returns, and
	  inaccurate snapshot information will linger for a while, causing
	  "core show channels", etc. to show erroneous info.

	  This is fixed by manually making a channel snapshot at the end
	  of ast_pbx_exec_application, since we anticipate that pbx_exec
	  might not get called again immediately.

	  ASTERISK-30367 #close

	  Change-Id: I2a5131053aa9d11badbc0ef2ef40b1f83d0af086

2022-10-28 05:57 +0000 [62745013a4]  George Joseph <gjoseph@digium.com>

	* res_rtp_asterisk: Asterisk Media Experience Score (MES)

	  This module has been updated to provide additional
	  quality statistics in the form of an Asterisk
	  Media Experience Score.  The score is avilable using
	  the same mechanisms you'd use to retrieve jitter, loss,
	  and rtt statistics.  For more information about the
	  score and how to retrieve it, see
	  https://wiki.asterisk.org/wiki/display/AST/Media+Experience+Score

	  * Updated chan_pjsip to set quality channel variables when a
	    call ends.
	  * Updated channels/pjsip/dialplan_functions.c to add the ability
	    to retrieve the MES along with the existing rtcp stats when
	    using the CHANNEL dialplan function.
	  * Added the ast_debug_rtp_is_allowed and ast_debug_rtcp_is_allowed
	    checks for debugging purposes.
	  * Added several function to time.h for manipulating time-in-samples
	    and times represented as double seconds.
	  * Updated rtp_engine.c to pass through the MES when stats are
	    requested.  Also debug output that dumps the stats when an
	    rtp instance is destroyed.
	  * Updated res_rtp_asterisk.c to implement the calculation of the
	    MES.  In the process, also had to update the calculation of
	    jitter.  Many debugging statements were also changed to be
	    more informative.
	  * Added a unit test for internal testing.  The test should not be
	    run during normal operation and is disabled by default.

	  ASTERISK-30280

	  Change-Id: I458cb9a311e8e5dc1db769b8babbcf2e093f107a

2022-11-26 06:54 +0000 [40ed776c40]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_session: Use Caller ID for extension matching.

	  Currently, there is no Caller ID available to us when
	  checking for an extension match when handling INVITEs.
	  As a result, extension patterns that depend on the Caller ID
	  are not matched and calls may be incorrectly rejected.

	  The Caller ID is not available because the supplement that
	  adds Caller ID to the session does not execute until after
	  this check. Supplement callbacks cannot yet be executed
	  at this point since the session is not yet in the appropriate
	  state.

	  To fix this without impacting existing behavior, the Caller ID
	  number is now retrieved before attempting to pattern match.
	  This ensures pattern matching works correctly and there is
	  no behavior change to the way supplements are called.

	  ASTERISK-28767 #close

	  Change-Id: Iec7f5a3b90e51b65ccf74342f96bf80314b7cfc7

2022-12-12 12:42 +0000 [cec98b5f0c]  Ben Ford <bford@digium.com>

	* res_pjsip_sdp_rtp.c: Use correct timeout when put on hold.

	  When a call is put on hold and it has moh_passthrough and rtp_timeout
	  set on the endpoint, the wrong timeout will be used. rtp_timeout_hold is
	  expected to be used, but rtp_timeout is used instead. This change adds a
	  couple of checks for locally_held to determine if rtp_timeout_hold needs
	  to be used instead of rtp_timeout.

	  ASTERISK-30350

	  Change-Id: I7b106fc244332014216d12bba851cefe884cc25f

2022-11-14 07:12 +0000 [1974ebe109]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail_odbc: Fix string overflow warning.

	  Fixes a negative offset warning by initializing
	  the buffer to empty.

	  Additionally, although it doesn't currently complain
	  about it, the size of a buffer is increased to
	  accomodate the maximum size contents it could have.

	  ASTERISK-30240 #close

	  Change-Id: I8eecedf14d3f2a75864797f802277cac89a32877

2022-11-04 05:11 +0000 [997a2d70b9]  Igor Goncharovsky <igorg@iqtek.ru>

	* res_pjsip: Fix path usage in case dialing with '@'

	  Fix aor lookup on sip path addition. Issue happens in case of dialing
	  with @ and overriding user part of RURI.

	  ASTERISK-30100 #close
	  Reported-by: Yury Kirsanov

	  Change-Id: I3f2c42a583578c94397b113e32ca3ebf2d600e13

2022-11-21 21:37 +0000 [b1f1556922]  Peter Fern <asterisk@obfusc8.org>

	* streams:  Ensure that stream is closed in ast_stream_and_wait on error

	  When ast_stream_and_wait returns an error (for example, when attempting
	  to stream to a channel after hangup) the stream is not closed, and
	  callers typically do not check the return code. This results in leaking
	  file descriptors, leading to resource exhaustion.

	  This change ensures that the stream is closed in case of error.

	  ASTERISK-30198 #close
	  Reported-by: Julien Alie

	  Change-Id: Ie46b67314590ad75154595a3d34d461060b2e803

2022-11-25 18:03 +0000 [914c8e28c1]  Naveen Albert <asterisk@phreaknet.org>

	* func_callerid: Warn about invalid redirecting reason.

	  Currently, if a user attempts to set a Caller ID related
	  function to an invalid value, a warning is emitted,
	  except for when setting the redirecting reason.
	  We now emit a warning if we were unable to successfully
	  parse the user-provided reason.

	  ASTERISK-30332 #close

	  Change-Id: Ic341f5d5f7303b6f1115549be64db58a85944f5a

2022-12-15 12:54 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.16.0-rc1 Released.

2022-12-15 06:37 +0000 [d141f3a821]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.16.0
2022-12-09 13:37 +0000 [70c650751e]  Alexandre Fournier <afournier@wazo.io>

	* res_geoloc: fix NULL pointer dereference bug

	  The `ast_geoloc_datastore_add_eprofile` function does not return 0 on
	  success, it returns the size of the underlying datastore. This means
	  that the datastore will be freed and its pointer set to NULL when no
	  error occured at all.

	  ASTERISK-30346

	  Change-Id: Iea9b209bd1244cc57b903b9496cb680c356e4bb9

2022-12-13 09:25 +0000 [b65aa359c4]  Joshua C. Colp <jcolp@sangoma.com>

	* res_pjsip_aoc: Don't assume a body exists on responses.

	  When adding AOC to an outgoing response the code
	  assumed that a body would exist for comparing the
	  Content-Type. This isn't always true.

	  The code now checks to make sure the response has
	  a body before checking the Content-Type.

	  ASTERISK-21502

	  Change-Id: Iaead371434fc3bc693dad487228106a7d7a5ac76

2022-12-12 09:16 +0000 [462461870d]  Naveen Albert <asterisk@phreaknet.org>

	* app_if: Fix format truncation errors.

	  Fixes format truncation warnings in gcc 12.2.1.

	  ASTERISK-30349 #close

	  Change-Id: I42be4edf0284358b906e765d1966b6b9d66e1d3c

2022-07-21 14:07 +0000 [91a12a5cd4]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_header_funcs: Add custom parameter support.

	  Adds support for custom URI and header parameters
	  in the From header in PJSIP. Parameters can be
	  both set and read using this function.

	  ASTERISK-30150 #close

	  Change-Id: Ifb1bc3c512ad5f6faeaebd7817f004a2ecbd6428

2022-11-01 15:37 +0000 [63c36ed9c4]  Michael Kuron <m.kuron@gmx.de>

	* manager: AOC-S support for AOCMessage

	  ASTERISK-21502

	  Change-Id: I051b778f8c862d3b4794d28f2f3d782316707b08

2022-10-23 04:42 +0000 [d73f22268f]  Michael Kuron <m.kuron@gmx.de>

	* res_pjsip_aoc: New module for sending advice-of-charge with chan_pjsip

	  chan_sip supported sending AOC-D and AOC-E information in SIP INFO
	  messages in an "AOC" header in a format that was originally defined by
	  Snom. In the meantime, ETSI TS 124 647 introduced an XML-based AOC
	  format that is supported by devices from multiple vendors, including
	  Snom phones with firmware >= 8.4.2 (released in 2010).

	  This commit adds a new res_pjsip_aoc module that inserts AOC information
	  into outgoing messages or sends SIP INFO messages as described below.
	  It also fixes a small issue in res_pjsip_session which didn't always
	  call session supplements on outgoing_response.

	  * AOC-S in the 180/183/200 responses to an INVITE request
	  * AOC-S in SIP INFO (if a 200 response has already been sent or if the
	    INVITE was sent by Asterisk)
	  * AOC-D in SIP INFO
	  * AOC-D in the 200 response to a BYE request (if the client hangs up)
	  * AOC-D in a BYE request (if Asterisk hangs up)
	  * AOC-E in the 200 response to a BYE request (if the client hangs up)
	  * AOC-E in a BYE request (if Asterisk hangs up)

	  The specification defines one more, AOC-S in an INVITE request, which
	  is not implemented here because it is not currently possible in
	  Asterisk to have AOC data ready at this point in call setup. Once
	  specifying AOC-S via the dialplan or passing it through from another
	  SIP channel's INVITE is possible, that might be added.

	  The SIP INFO requests are sent out immediately when the AOC indication
	  is received. The others are inserted into an appropriate outgoing
	  message whenever that is ready to be sent. In the latter case, the XML
	  is stored in a channel variable at the time the AOC indication is
	  received. Depending on where the AOC indications are coming from (e.g.
	  PRI or AMI), it may not always be possible to guarantee that the AOC-E
	  is available in time for the BYE.

	  Successfully tested AOC-D and both variants of AOC-E with a Snom D735
	  running firmware 10.1.127.10. It does not appear to properly support
	  AOC-S however, so that could only be tested by inspecting SIP traces.

	  ASTERISK-21502 #close
	  Reported-by: Matt Jordan <mjordan@digium.com>

	  Change-Id: Iebb7ad0d5f88526bc6629d3a1f9f11665434d333

2022-10-16 19:33 +0000 [833f2af3da]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_session.c: Map empty extensions in INVITEs to s.

	  Some SIP devices use an empty extension for PLAR functionality.

	  Rather than rejecting these empty extensions, we now use the s
	  extension for such calls to mirror the existing PLAR functionality
	  in Asterisk (e.g. chan_dahdi).

	  ASTERISK-30265 #close

	  Change-Id: I0861a405cd49bbbf532b52f7b47f0e2810832590

2022-11-25 03:59 +0000 [fb281c48e2]  Marcel Wagner <mwagner@sipgate.de>

	* res_pjsip: Fix typo in from_domain documentation

	  This fixes a small typo in the from_domain documentation on the endpoint documentation

	  ASTERISK-30328 #close

	  Change-Id: Ia6f0897c3f5cab899ef2cde6b3ac07265b8beb21

2022-11-21 12:53 +0000 [3babc68099]  Naveen Albert <asterisk@phreaknet.org>

	* res_hep: Add support for named capture agents.

	  Adds support for the capture agent name field
	  of the Homer protocol to Asterisk by allowing
	  users to specify a name that will be sent to
	  the HEP server.

	  ASTERISK-30322 #close

	  Change-Id: I6136583017f9dd08daeb8be02f60fb8df4639a2b

2022-11-03 15:28 +0000 [5a78ce5a1f]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail: Fix missing email in msg_create_from_file.

	  msg_create_from_file currently does not dispatch emails,
	  which means that applications using this function, such
	  as MixMonitor, will not trigger notifications to users
	  (only AMI events are sent our currently). This is inconsistent
	  with other ways users can receive voicemail.

	  This is fixed by adding an option that attempts to send
	  an email and falling back to just the notifications as
	  done now if that fails. The existing behavior remains
	  the default.

	  ASTERISK-30283 #close

	  Change-Id: I597cbb9cf971a18d8776172b26ab187dc096a5c7

2021-06-28 11:56 +0000 [a7cd9ce26f]  Naveen Albert <asterisk@phreaknet.org>

	* app_if: Adds conditional branch applications

	  Adds the If, ElseIf, Else, ExitIf, and EndIf
	  applications for conditional execution
	  of a block of dialplan, similar to the While,
	  EndWhile, and ExitWhile applications. The
	  appropriate branch is executed at most once
	  if available and may be broken out of while
	  inside.

	  ASTERISK-29497

	  Change-Id: I3aa3bd35a5add82465c6ee9bd86b64601f0e1f49

2022-11-17 13:30 +0000 [32be12e045]  Marcel Wagner <mwagner@sipgate.de>

	* res_pjsip: Update contact_user to point out default

	  Updates the documentation for the 'contact_user' field to point out the
	  default outbound contact if no contact_user is specified 's'

	  ASTERISK-30316 #close

	  Change-Id: I61f24fb9164e4d07e05908a2511805281874c876

2022-11-23 16:59 +0000 [3d4162af44]  Naveen Albert <asterisk@phreaknet.org>

	* res_adsi: Fix major regression caused by media format rearchitecture.

	  The commit that rearchitected media formats,
	  a2c912e9972c91973ea66902d217746133f96026 (ASTERISK_23114)
	  introduced a regression by improperly translating code in res_adsi.c.
	  In particular, the pointer to the frame buffer was initialized
	  at the top of adsi_careful_send, rather than dynamically updating it
	  for each frame, as is required.

	  This resulted in the first frame being repeatedly sent,
	  rather than advancing through the frames.
	  This corrupted the transmission of the CAS to the CPE,
	  which meant that CPE would never respond with the DTMF acknowledgment,
	  effectively completely breaking ADSI functionality.

	  This issue is now fixed, and ADSI now works properly again.

	  ASTERISK-29793 #close

	  Change-Id: Icdeddf733eda2981c98712d1ac9cddc0db507dbe

2022-12-08 04:33 +0000 [f5a7efb963]  Joshua C. Colp <jcolp@sangoma.com>

	* ari: Destroy body variables in channel create.

	  When passing a JSON body to the 'create' channel route
	  it would be converted into Asterisk variables, but never
	  freed resulting in a memory leak.

	  This change makes it so that the variables are freed in
	  all cases.

	  ASTERISK-30344

	  Change-Id: I924dbd866a01c6073e2d6fb846ccaa27ef72d49d

2022-11-13 16:15 +0000 [30b4dc9bbb]  Naveen Albert <asterisk@phreaknet.org>

	* func_presencestate: Fix invalid memory access.

	  When parsing information from AstDB while loading,
	  it is possible that certain pointers are never
	  set, which leads to invalid memory access and
	  then, fatally, invalid free attempts on this memory.
	  We now initialize to NULL to prevent this.

	  ASTERISK-30311 #close

	  Change-Id: I6120681d04fd2c12a9473f35ce95a1f8e74e3929

2022-12-01 05:54 +0000 [f5ead740f3]  Naveen Albert <asterisk@phreaknet.org>

	* sig_analog: Fix no timeout duration.

	  ASTERISK_28702 previously attempted to fix an
	  issue with flash hook hold timing out after
	  just under 17 minutes, when it should have never
	  been timing out. It fixed this by changing 999999
	  to INT_MAX, but it did so in chan_dahdi, which
	  is the wrong place since ss_thread is now in
	  sig_analog and the one in chan_dahdi is mostly
	  dead code.

	  This fixes this by porting the fix to sig_analog.

	  ASTERISK-30336 #close

	  Change-Id: I05eb69cc0b5319d357842a70bd26ef64d145cb15

2022-11-05 07:11 +0000 [86a40686e4]  Naveen Albert <asterisk@phreaknet.org>

	* xmldoc: Allow XML docs to be reloaded.

	  The XML docs are currently only loaded on
	  startup with no way to update them during runtime.
	  This makes it impossible to load modules that
	  use ACO/Sorcery (which require documentation)
	  if they are added to the source tree and built while
	  Asterisk is running (e.g. external modules).

	  This adds a CLI command to reload the XML docs
	  during runtime so that documentation can be updated
	  without a full restart of Asterisk.

	  ASTERISK-30289 #close

	  Change-Id: I4f265b0e5517e757c5453a0f241201a5788d3a07

2022-11-24 09:56 +0000 [0fb48fb751]  Naveen Albert <asterisk@phreaknet.org>

	* rtp_engine.h: Update examples using ast_format_set.

	  This file includes some doxygen comments referencing
	  ast_format_set. This is an obsolete API that was
	  removed years back, but documentation was not fully
	  updated to reflect that. These examples are
	  updated to the current way of doing things
	  (using the format cache).

	  ASTERISK-30327 #close

	  Change-Id: I570f3b8007fa17ba470cc7117f44bfe7c555d2f7

2022-11-04 06:04 +0000 [3cdc280cad]  Naveen Albert <asterisk@phreaknet.org>

	* app_mixmonitor: Add option to use real Caller ID for voicemail.

	  MixMonitor currently uses the Connected Line as the Caller ID
	  for voicemails. This is due to the implementation being written
	  this way for use with Digium phones. However, in general this
	  is not correct for generic usage in the dialplan, and people
	  may need the real Caller ID instead. This adds an option to do that.

	  ASTERISK-30286 #close

	  Change-Id: I3d0ce76dfe75e2a614e0f709ab27acbd2478267c

2022-11-29 14:02 +0000 [cbb7585e7d]  Ben Ford <bford@digium.com>

	* pjproject: 2.13 security fixes

	  Backports two security fixes (c4d3498 and 450baca) from pjproject 2.13.

	  ASTERISK-30338

	  Change-Id: I86fdc003d5d22cb66e7cc6dc3313a8194f27eb69

2022-10-10 09:35 +0000 [5741569c5e]  George Joseph <gjoseph@digium.com>

	* pjsip_transport_events: Fix possible use after free on transport

	  It was possible for a module that registered for transport monitor
	  events to pass in a pjsip_transport that had already been freed.
	  This caused pjsip_transport_events to crash when looking up the
	  monitor for the transport.  The fix is a two pronged approach.

	  1. We now increment the reference count on pjsip_transports when we
	  create monitors for them, then decrement the count when the
	  transport is going to be destroyed.

	  2. There are now APIs to register and unregister monitor callbacks
	  by "transport key" which is a string concatenation of the remote ip
	  address and port.  This way the module needing to monitor the
	  transport doesn't have to hold on to the transport object itself to
	  unregister.  It just has to save the transport_key.

	  * Added the pjsip_transport reference increment and decrement.

	  * Changed the internal transport monitor container key from the
	    transport->obj_name (which may not be unique anyway) to the
	    transport_key.

	  * Added a helper macro AST_SIP_MAKE_REMOTE_IPADDR_PORT_STR() that
	    fills a buffer with the transport_key using a passed-in
	    pjsip_transport.

	  * Added the following functions:
	    ast_sip_transport_monitor_register_key
	    ast_sip_transport_monitor_register_replace_key
	    ast_sip_transport_monitor_unregister_key
	    and marked their non-key counterparts as deprecated.

	  * Updated res_pjsip_pubsub and res_pjsip_outbound_register to use
	    the new "key" monitor functions.

	  NOTE: res_pjsip_registrar also uses the transport monitor
	  functionality but doesn't have a persistent object other than
	  contact to store a transport key.  At this time, it continues to
	  use the non-key monitor functions.

	  ASTERISK-30244

	  Change-Id: I1a20baf2a8643c272dcf819871d6c395f148f00b

2022-10-03 13:54 +0000 [76d10ea668]  Mike Bradeen <mbradeen@sangoma.com>

	* manager: prevent file access outside of config dir

	  Add live_dangerously flag to manager and use this flag to
	  determine if a configuation file outside of AST_CONFIG_DIR
	  should be read.

	  ASTERISK-30176

	  Change-Id: I46b26af4047433b49ae5c8a85cb8cda806a07404

2022-06-06 18:11 +0000 [16a7a98643]  Mike Bradeen <mbradeen@sangoma.com>

	* ooh323c: not checking for IE minimum length

	  When decoding q.931 encoded calling/called number
	  now checking for length being less than minimum required.

	  ASTERISK-30103

	  Change-Id: I3dcfce0f35eca258dc450f87c92d4d7af402c2e7

2022-09-07 07:06 +0000 [37b0727288]  Maximilian Fridrich <m.fridrich@commend.com>

	* core & res_pjsip: Improve topology change handling.

	  This PR contains two relatively separate changes in channel.c and
	  res_pjsip_session.c which ensure that topology changes are not ignored
	  in cases where they should be handled.

	  For channel.c:

	  The function ast_channel_request_stream_topology_change only triggers a
	  stream topology request change indication, if the channel's topology
	  does not equal the requested topology. However, a channel could be in a
	  state where it is currently "negotiating" a new topology but hasn't
	  updated it yet, so the topology request change would be lost. Channels
	  need to be able to handle such situations internally and stream
	  topology requests should therefore always be passed on.

	  In the case of chan_pjsip for example, it queues a session refresh
	  (re-INVITE) if it is currently in the middle of a transaction or has
	  pending requests (among other reasons).

	  Now, ast_channel_request_stream_topology_change always indicates a
	  stream topology request change even if the requested topology equals the
	  channel's topology.

	  For res_pjsip_session.c:

	  The function resolve_refresh_media_states does not process stream state
	  changes if the delayed active state differs from the current active
	  state. I.e. if the currently active stream state has changed between the
	  time the sip session refresh request was queued and the time it is being
	  processed, the session refresh is ignored. However, res_pjsip_session
	  contains logic that ensures that session refreshes are queued and
	  re-queued correctly if a session refresh is currently not possible. So
	  this check is not necessary and led to some session refreshes being
	  lost.

	  Now, a session refresh is done even if the delayed active state differs
	  from the current active state and it is checked whether the delayed
	  pending state differs from the current active - because that means a
	  refresh is necessary.

	  Further, the unit test of resolve_refresh_media_states was adapted to
	  reflect the new behavior. I.e. the changes to delayed pending are
	  prioritized over the changes to current active because we want to
	  preserve the original intention of the pending state.

	  ASTERISK-30184

	  Change-Id: Icd0703295271089057717006730b555b9a1d4e5a

2022-11-11 14:30 +0000 [84eb579052]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_builtins: Allow Answer to return immediately.

	  The Answer application currently waits for up to 500ms
	  for media, even if users specify a different timeout.

	  This adds an option to not wait for media on the channel
	  by doing a raw answer instead. The default 500ms threshold
	  is also documented.

	  ASTERISK-30308 #close

	  Change-Id: Id59cd340c44b8b8b2384c479e17e5123e917cba4

2022-11-10 18:47 +0000 [0bbcda3040]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Allow FXO channels to start immediately.

	  Currently, chan_dahdi will wait for at least one
	  ring before an incoming call can enter the dialplan.
	  This is generally necessary in order to receive
	  the Caller ID spill and/or distinctive ringing
	  detection.

	  However, if neither of these is required, then there
	  is nothing gained by waiting for one ring and this
	  unnecessarily delays call setup. Users can now
	  use immediate=yes to make FXO channels (FXS signaled)
	  begin processing dialplan as soon as Asterisk receives
	  the call.

	  ASTERISK-30305 #close

	  Change-Id: I20818b370b2e4892c7f40c8a8753fa06a81750b5

2022-09-24 05:15 +0000 [3c7dde3bf6]  Naveen Albert <asterisk@phreaknet.org>

	* sla: Prevent deadlock and crash due to autoservicing.

	  SLAStation currently autoservices the station channel before
	  creating a thread to actually dial the trunk. This leads
	  to duplicate servicing of the channel which causes assertions,
	  deadlocks, crashes, and moreover not the correct behavior.

	  Removing the autoservice prevents the crash, but if the station
	  hangs up before the trunk answers, the call hangs since the hangup
	  was never serviced on the channel.

	  This is fixed by not autoservicing the channel, but instead
	  servicing it in the thread dialing the trunk, since it is doing
	  so synchronously to begin with. Instead of sleeping for 100ms
	  in a loop, we simply use the channel for timing, and abort
	  if it disappears.

	  The same issue also occurs with SLATrunk when a call is answered,
	  because ast_answer invokes ast_waitfor_nandfds. Thus, we use
	  ast_raw_answer instead which does not cause any conflict and allows
	  the call to be answered normally without thread blocking issues.

	  ASTERISK-29998 #close

	  Change-Id: Icc237d50354b5910000d2305901e86d2c87bb9d8

2022-11-07 09:30 +0000 [9827ccd473]  Jaco Kroon <jaco@uls.co.za>

	* Build system: Avoid executable stack.

	  Found in res_geolocation, but I believe others may have similar issues,
	  thus not linking to a specific issue.

	  Essentially gcc doesn't mark the stack for being non-executable unless
	  it's compiling the source, this informs ld via gcc to mark the object as
	  not requiring an executable stack (which a binary blob obviously
	  doesn't).

	  ASTERISK-30321

	  Change-Id: I71bcc2fd1fe0c82a28b3257405d6f2b566fd9bfc
	  Signed-off-by: Jaco Kroon <jaco@uls.co.za>

2022-11-10 06:11 +0000 [4ff29ce8dd]  Naveen Albert <asterisk@phreaknet.org>

	* func_json: Fix memory leak.

	  A memory leak was present in func_json due to
	  using ast_json_free, which just calls ast_free,
	  as opposed to recursively freeing the JSON
	  object as needed. This is now fixed to use the
	  right free functions.

	  ASTERISK-30293 #close

	  Change-Id: I982324dde841dc9147c8d8ad35c8719daf418b49

2022-11-10 06:20 +0000 [c9ee73fea8]  Naveen Albert <asterisk@phreaknet.org>

	* test_json: Remove duplicated static function.

	  Removes the function mkstemp_file and uses
	  ast_file_mkftemp from file.h instead.

	  ASTERISK-30295 #close

	  Change-Id: I7412ec06f88c39ee353bcdb8c976c2fcac546609

2022-11-16 05:40 +0000 [5223b941b8]  Joshua C. Colp <jcolp@sangoma.com>

	* res_agi: Respect "transmit_silence" option for "RECORD FILE".

	  The "RECORD FILE" command in res_agi has its own
	  implementation for actually doing the recording. This
	  has resulted in it not actually obeying the option
	  "transmit_silence" when recording.

	  This change causes it to now send silence if the
	  option is enabled.

	  ASTERISK-30314

	  Change-Id: Ib3a85601ff35d1b904f836691bad8a4b7e957174

2022-11-03 17:01 +0000 [d085d7d5f9]  Naveen Albert <asterisk@phreaknet.org>

	* manager: Update ModuleCheck documentation.

	  The ModuleCheck XML documentation falsely
	  claims that the module's version number is returned.
	  This has not been the case since 14, since the version
	  number is not available anymore, but the documentation
	  was not changed at the time. It is now updated to
	  reflect this.

	  ASTERISK-30285 #close

	  Change-Id: Idde2d1205a11f2623fa1ddab192faa3dc4081e91

2022-11-03 15:56 +0000 [60232365ab]  Naveen Albert <asterisk@phreaknet.org>

	* app_mixmonitor: Add option to delete files on exit.

	  Adds an option that allows MixMonitor to delete
	  its copy of any recording files before exiting.

	  This can be handy in conjunction with options
	  like m, which copy the file elsewhere, and the
	  original files may no longer be needed.

	  ASTERISK-30284 #close

	  Change-Id: Ida093679c67e300efc154a97b6d8ec0f104e581e

2022-11-06 10:39 +0000 [07a40a5e1b]  Naveen Albert <asterisk@phreaknet.org>

	* file.c: Don't emit warnings on winks.

	  Adds an ignore case for wink since it should
	  pass through with no warning.

	  ASTERISK-30290 #close

	  Change-Id: Ieb7e34daa717357ac5c93efb0059f6c2321f16ad

2022-10-01 14:49 +0000 [617dad4cba]  Naveen Albert <asterisk@phreaknet.org>

	* app_stack: Print proper exit location for PBXless channels.

	  When gosub is executed on channels without a PBX, the context,
	  extension, and priority are initialized to the channel driver's
	  default location for that endpoint. As a result, the last Return
	  will restore this location and the Gosub logs will print out bogus
	  information about our exit point.

	  To fix this, on channels that don't have a PBX, the execution
	  location is left intact on the last return if there are no
	  further stack frames left. This allows the correct location
	  to be printed out to the user, rather than the bogus default
	  context.

	  ASTERISK-30076 #close

	  Change-Id: I1d42a99c9aa9e3708d32718863175158a894e414
	  (cherry picked from commit 12d18b0a40381eb90145e352bf144a71f8dd2555)

2022-11-02 09:24 +0000 [1b5b4cf681]  George Joseph <gjoseph@digium.com>

	* runUnittests.sh:  Save coredumps to proper directory

	  Fixed the specification of "outputdir" when calling ast_coredumper
	  so the txt files are saved in the correct place.

	  ASTERISK-30282

	  Change-Id: Ic631cb90c1e4c29d970c982dff45fda5e0eb15b6

2022-11-02 07:41 +0000 [9de862242f]  George Joseph <gjoseph@digium.com>

	* chan_rtp: Make usage of ast_rtp_instance_get_local_address clearer

	  unicast_rtp_request() was setting the channel variables like this:

	  pbx_builtin_setvar_helper(chan, "UNICASTRTP_LOCAL_ADDRESS",
	      ast_sockaddr_stringify_addr(&local_address));
	  ast_rtp_instance_get_local_address(instance, &local_address);
	  pbx_builtin_setvar_helper(chan, "UNICASTRTP_LOCAL_PORT",
	      ast_sockaddr_stringify_port(&local_address));

	  ...which made it appear that UNICASTRTP_LOCAL_ADDRESS was being
	  set before local_address was set.  In fact, the address part of
	  local_address was set earlier in the function, just not the port.
	  This was confusing however so ast_rtp_instance_get_local_address()
	  is now being called before setting UNICASTRTP_LOCAL_ADDRESS.

	  ASTERISK-30281

	  Change-Id: I872ac49477100f4eb33891d46efc6ca21ec81aa4

2022-10-13 11:19 +0000 [40ce434512]  Mike Bradeen <mbradeen@sangoma.com>

	* res_pjsip: prevent crash on websocket disconnect

	  When a websocket (or potentially any stateful connection) is quickly
	  created then destroyed, it is possible that the qualify thread will
	  destroy the transaction before the initialzing thread is finished
	  with it.

	  Depending on the timing, this can cause an assertion within pjsip.

	  To prevent this, ast_send_stateful_response will now create the group
	  lock and add a reference to it before creating the transaction.

	  While this should resolve the crash, there is still the potential that
	  the contact will not be cleaned up properly, see:ASTERISK~29286. As a
	  result, the contact has to 'time out' before it will be removed.

	  ASTERISK-28689

	  Change-Id: Id050fded2247a04d8f0fc5b8a2cf3e5482cb8cee

2022-09-09 12:20 +0000 [628551bb14]  Igor Goncharovsky <igor.goncharovsky@gmail.com>

	* res_pjsip_outbound_registration: Allow to use multiple proxies for registration

	  Current registration code use pjsip_parse_uri to verify outbound_proxy
	  that is different from the reading this option for the endpoint. This
	  made value with multiple proxies invalid for registration pjsip settings.
	  Removing URI validation helps to use registration through multiple proxies.

	  ASTERISK-30217 #close

	  Change-Id: I064558e66f04b9f3260c46181812a01349761357

2022-10-27 06:32 +0000 [2e75f2c845]  Naveen Albert <asterisk@phreaknet.org>

	* tcptls: Prevent crash when freeing OpenSSL errors.

	  write_openssl_error_to_log has been erroneously
	  using ast_free instead of free, which will
	  cause a crash when MALLOC_DEBUG is enabled since
	  the memory was not allocated by Asterisk's memory
	  manager. This changes it to use the actual free
	  function directly to avoid this.

	  ASTERISK-30278 #close

	  Change-Id: Iac8b6468b718075809c45d8ad16b101af21a474d

2022-10-23 10:16 +0000 [3989977402]  Naveen Albert <asterisk@phreaknet.org>

	* tests: Fix compilation errors on 32-bit.

	  Fix compilation errors caused by using size_t
	  instead of uintmax_t and non-portable format
	  specifiers.

	  ASTERISK-30273 #close

	  Change-Id: I363e6057ef84d54b88af80d23ad6147eef9216ee

2022-08-26 03:59 +0000 [093593a7c8]  Henning Westerholt <hw@gilawa.com>

	* res_pjsip: return all codecs on a re-INVITE without SDP

	  Currently chan_pjsip on receiving a re-INVITE without SDP will only
	  return the codecs that are previously negotiated and not offering
	  all enabled codecs.

	  This causes interoperability issues with different equipment (e.g.
	  from Cisco) for some of our customers and probably also in other
	  scenarios involving 3PCC infrastructure.

	  According to RFC 3261, section 14.2 we SHOULD return all codecs
	  on a re-INVITE without SDP

	  The PR proposes a new parameter to configure this behaviour:
	  all_codecs_on_empty_reinvite. It includes the code, documentation,
	  alembic migrations, CHANGES file and example configuration additions.

	  ASTERISK-30193 #close

	  Change-Id: I69763708d5039d512f391e296ee8a4d43a1e2148

2022-07-20 19:03 +0000 [46650361ea]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_logger: Add method-based logging option.

	  Expands the pjsip logger to support the ability to filter
	  by SIP message method. This can make certain types of SIP debugging
	  easier by only logging messages of particular method(s).

	  ASTERISK-30146 #close

	  Co-authored-by: Sean Bright <sean@seanbright.com>
	  Change-Id: I9c8cbb6fc8686ef21190eb42e08bc9a9b147707f

2022-10-14 17:24 +0000 [5076faa0df]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_notify: Add option support for AMI.

	  The PJSIP notify CLI commands allow for using
	  "options" configured in pjsip_notify.conf.

	  This allows these same options to be used in
	  AMI actions as well.

	  Additionally, as part of this improvement,
	  some repetitive common code is refactored.

	  ASTERISK-30263 #close

	  Change-Id: Ie4496b322b63b61eaf9672183a959ab99a04b6b5

2022-10-06 11:51 +0000 [8da870fe1e]  Frederic LE FOLL <frederic.lefoll@c-s.fr>

	* Dialing API: Cancel a running async thread, may not cancel all calls

	  race condition: ast_dial_join() may not cancel outgoing call, if
	  function is called just after called party answer and before
	  application execution (bit is_running_app not yet set).

	  This fix adds ast_softhangup() calls in addition to existing
	  pthread_kill() when is_running_app is not set.

	  ASTERISK-30258

	  Change-Id: Idbdd5c15122159661aa8e996a42d5800083131e4

2022-10-23 17:46 +0000 [d41694350f]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Fix unavailable channels returning busy.

	  This fixes dahdi_request to properly set the cause
	  code to CONGESTION instead of BUSY if no channels
	  were actually available.

	  Currently, the cause is erroneously set to busy
	  if the channel itself is found, regardless of its
	  current state. However, if the channel is not available
	  (e.g. T1 down, card not operable, etc.), then the
	  channel itself may not be in a functional state,
	  in which case CHANUNAVAIL is the correct cause to use.

	  This adds a simple check to ensure that busy tone
	  is only returned if a channel is encountered that
	  has an owner, since that is the only possible way
	  that a channel could actually be busy.

	  ASTERISK-30274 #close

	  Change-Id: Iad5870223c081240c925b19df8d6af136953b994

2022-09-28 07:38 +0000 [bf6194be45]  Naveen Albert <asterisk@phreaknet.org>

	* say: Don't prepend ampersand erroneously.

	  Some logic in say.c for determining if we need
	  to also add an ampersand for file seperation was faulty,
	  as non-successful files would increment the count, causing
	  a leading ampersand to be added improperly.

	  This is fixed, and a unit test that captures this regression
	  is also added.

	  ASTERISK-30248 #close

	  Change-Id: I02c1d3a11d82fe4ea8b462070cbd1effb5834d2b

2022-10-16 15:35 +0000 [85ae67f387]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_pubsub: Prevent removing subscriptions.

	  pjproject does not provide any mechanism of removing
	  event packages, which means that once a subscription
	  handler is registered, it is effectively permanent.

	  pjproject will assert if the same event package is
	  ever registered again, so currently unloading and
	  loading any Asterisk modules that use subscriptions
	  will cause a crash that is beyond our control.

	  For that reason, we now prevent users from being
	  able to unload these modules, to prevent them
	  from ever being loaded twice.

	  ASTERISK-30264 #close

	  Change-Id: I7fdcb1a5e44d38b7ba10c44259fe98f0ae9bc12c

2022-09-16 13:45 +0000 [0655d5f83e]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: handle unsafe private key files

	  ASTERISK-30213 #close

	  Change-Id: I4a77143d41615b7c4fc25bb1251c0a9cb87b417a

2022-09-29 15:55 +0000 [4fd2f07ff9]  Mike Bradeen <mbradeen@sangoma.com>

	* audiohook: add directional awareness

	  Add enum to allow setting optional direction. If set to only one
	  direction, only feed matching-direction frames to the associated
	  slin factory.

	  This prevents mangling the transcoder on non-mixed frames when the
	  READ and WRITE frames would have otherwise required it.  Also
	  removes the need to mute or discard the un-wanted frames as they
	  are no longer added in the first place.

	  res_stasis_snoop is changed to use this addition to set direction
	  on audiohook based on spy direction.

	  If no direction is set, the ast_audiohook_init will init this enum
	  to BOTH which maintains existing functionality.

	  ASTERISK-30252

	  Change-Id: If8716bad334562a5d812be4eeb2a92e4f3be28eb

2022-09-30 06:24 +0000 [0234b2b9be]  Naveen Albert <asterisk@phreaknet.org>

	* res_tonedetect: Add ringback support to TONE_DETECT.

	  Adds support for detecting audible ringback tone
	  to the TONE_DETECT function using the p option.

	  ASTERISK-30254 #close

	  Change-Id: Ie2329ff245248768367d26749c285fbe823f6414

2022-10-01 17:08 +0000 [6c88400b3d]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Resolve format truncation warning.

	  Fixes a format truncation warning in notify_message.

	  ASTERISK-30256 #close

	  Change-Id: I983a423c0214641ca4f8c9dfe0b19c47448fdee1

2022-06-01 11:06 +0000 [faca1fcfd3]  Naveen Albert <asterisk@phreaknet.org>

	* cdr: Allow bridging and dial state changes to be ignored.

	  Allows bridging, parking, and dial messages to be globally
	  ignored for all CDRs such that only a single CDR record
	  is generated per channel.

	  This is useful when CDRs should endure for the lifetime of
	  an entire channel and bridging and dial updates in the
	  dialplan should not result in multiple CDR records being
	  created for the call. With the ignore bridging option,
	  bridging changes have no impact on the channel's CDRs.
	  With the ignore dial state option, multiple Dials and their
	  outcomes have no impact on the channel's CDRs. The
	  last disposition on the channel is preserved in the CDR,
	  so the actual disposition of the call remains available.

	  These two options can reduce the amount of "CDR hacks" that
	  have hitherto been necessary to ensure that CDR was not
	  "spoiled" by these messages if that was undesired, such as
	  putting a dummy optimization-disabled local channel between
	  the caller and the actual call and putting the CDR on the channel
	  in the middle to ensure that CDR would persist for the entire
	  call and properly record start, answer, and end times.
	  Enabling these options is desirable when calls correspond
	  to the entire lifetime of channels and the CDR should
	  reflect that.

	  Current default behavior remains unchanged.

	  ASTERISK-30091 #close

	  Change-Id: I393981af42732ec5ac3ff9266444abb453b7c832

2022-09-16 18:29 +0000 [a8a62c7ff7]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: don't modify fname in try_load_key()

	  "fname" is passed in as a const char *, but strstr() mangles that
	  into a char *, and we were attempting to modify the string in place.
	  This is an unwanted (and undocumented) side-effect.

	  ASTERISK-30213

	  Change-Id: Ifa36d352aafeb7f9beec3f746332865c7d21e629

2022-09-15 22:45 +0000 [df5d117256]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: use ast_file_read_dirs() to iterate

	  ASTERISK-30213

	  Change-Id: I115f5f8942ffcfb23cd2559a55bac8a2eba081e0

2022-09-27 09:35 +0000 [7e79d93ed3]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Update wiki documentation

	  Also added a note to the geolocation.conf.sample file
	  and added a README to the res/res_geolocation/wiki
	  directory.

	  Change-Id: I89c3c5db8c0701b33127993622d5e4f904bddfbc

2022-07-26 07:01 +0000 [675bed5f2c]  Maximilian Fridrich <m.fridrich@commend.com>

	* res_pjsip: Add mediasec capabilities.

	  This patch adds support for mediasec SIP headers and SDP attributes.
	  These are defined in RFC 3329, 3GPP TS 24.229 and
	  draft-dawes-sipcore-mediasec-parameter. The new features are
	  implemented so that a backbone for RFC 3329 is present to streamline
	  future work on RFC 3329.

	  With this patch, Asterisk can communicate with Deutsche Telekom trunks
	  which require these fields.

	  ASTERISK-30032

	  Change-Id: Ia7f5b5ba42db18074fdd5428c4e1838728586be2

2022-09-28 07:40 +0000 [7507271375]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.15.0
2022-09-28 06:58 +0000 [96bf50b146]  George Joseph <gjoseph@digium.com>

	* manager.h: Bump version to 7.0.3

	  Change-Id: I5c365e141769f8ce2a1aeb4ae2cdb9842dd2fd5b

2022-09-19 19:53 +0000 [a1b372441f]  Holger Hans Peter Freyther <holger@moiji-mobile.com>

	* res_prometheus: Do not crash on invisible bridges

	  Avoid crashing by skipping invisible bridges and checking the
	  snapshot for a null pointer. In effect this is how the bridges
	  are enumerated in res/ari/resource_bridges.c already.

	  ASTERISK-30239
	  ASTERISK-30237

	  Change-Id: I58ef9f44036feded5966b5fc70ae754f8182883d

2022-09-19 12:35 +0000 [fb603e58b5]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_geolocation: Change some notices to debugs.

	  If geolocation is not in use for an endpoint, the NOTICE
	  log level is currently spammed with messages about this,
	  even though nothing is wrong and these messages provide
	  no real value. These log messages are therefore changed
	  to debugs.

	  ASTERISK-30241 #close

	  Change-Id: I656b355d812f67cc0f0fdf09b00b0e1458598bb4

2022-09-24 07:08 +0000 [00c17a6008]  Birger Harzenetter (license 5870)

	* db: Fix incorrect DB tree count for AMI.

	  The DBGetTree AMI action's ListItem previously
	  always reported 1, regardless of the count. This
	  is corrected to report the actual count.

	  ASTERISK-30245 #close
	  patches:
	    gettreecount.diff submitted by Birger Harzenetter (license 5870)

	  Change-Id: I46d8992710f1b8524426b1255f57d1ef4a4934d4

2022-09-21 18:17 +0000 [6d8308ad75]  Naveen Albert <asterisk@phreaknet.org>

	* func_logic: Don't emit warning if both IF branches are empty.

	  The IF function currently emits warnings if both IF branches
	  are empty. However, there is no actual necessity that either
	  branch be non-empty as, unlike other conditional applications/
	  functions, nothing is inherently done with IF, and both
	  sides could legitimately be empty. The warning is thus turned
	  into a debug message.

	  ASTERISK-30243 #close

	  Change-Id: I5250625dd720f95e1859b5dfb933905d7e7a730e

2022-09-11 17:13 +0000 [a2e418e495]  Naveen Albert <asterisk@phreaknet.org>

	* features: Add no answer option to Bridge.

	  Adds the n "no answer" option to the Bridge application
	  so that answer supervision can not automatically
	  be provided when Bridge is executed.

	  Additionally, a mechanism (dialplan variable)
	  is added to prevent bridge targets (typically the
	  target of a masquerade) from answering the channel
	  when they enter the bridge.

	  ASTERISK-30223 #close

	  Change-Id: I76f73fcd8e403bcd18f2abb40c658f537ac1ba6d

2022-09-08 19:12 +0000 [062cef0a85]  Naveen Albert <asterisk@phreaknet.org>

	* app_bridgewait: Add option to not answer channel.

	  Adds the n option to not answer the channel when calling
	  BridgeWait, so the application can be used without
	  forcing answer supervision.

	  ASTERISK-30216 #close

	  Change-Id: I6b85ef300b1f7b5170f8537e2b10889cc2e6605a

2022-08-15 14:59 +0000 [fdac31f279]  Naveen Albert <asterisk@phreaknet.org>

	* app_amd: Add option to play audio during AMD.

	  Adds an option that will play an audio file
	  to the party while AMD is running on the
	  channel, so the called party does not just
	  hear silence.

	  ASTERISK-30179 #close

	  Change-Id: I4af306274552b61b3d9f0883c33f698abd4699b6

2022-09-15 22:35 +0000 [ddc8f6967f]  Philip Prindeville <philipp@redfish-solutions.com>

	* test: initialize capture structure before freeing

	  ASTERISK-30232 #close

	  Change-Id: I2603e2cef8f93f6b0a6ef39f7eac744251bb3902

2021-05-17 09:19 +0000 [0736c55a96]  Naveen Albert <mail@interlinked.x10host.com>

	* func_export: Add EXPORT function

	  Adds the EXPORT function, which allows write
	  access to variables and functions on other
	  channels.

	  ASTERISK-29432 #close

	  Change-Id: I7492645ae4307553d0f586d78e13a4f586231fdf

2022-07-26 08:40 +0000 [479ce16eba]  Maximilian Fridrich <m.fridrich@commend.com>

	* res_pjsip: Add 100rel option "peer_supported".

	  This patch adds a new option to the 100rel parameter for pjsip
	  endpoints called "peer_supported". When an endpoint with this option
	  receives an incoming request and the request indicated support for the
	  100rel extension, then Asterisk will send 1xx responses reliably. If
	  the request did not indicate 100rel support, Asterisk sends 1xx
	  responses normally.

	  ASTERISK-30158

	  Change-Id: Id6d95ffa8f00dab118e0b386146e99f254f287ad

2022-09-05 01:59 +0000 [3e01be4600]  Jaco Kroon <jaco@uls.co.za>

	* manager: be more aggressive about purging http sessions.

	  If we find that n_max (currently hard wired to 1) sessions were purged,
	  schedule the next purge for 1ms into the future rather than 5000ms (as
	  per current).  This way we will purge up to 1000 sessions per second
	  rather than 1 every 5 seconds.

	  This mitigates a build-up of sessions should http sessions gets
	  established faster than 1 per 5 seconds.

	  Change-Id: I9820d39aa080109df44fe98c1325cafae48d54f5
	  Signed-off-by: Jaco Kroon <jaco@uls.co.za>

2022-09-10 10:15 +0000 [22b46f2a15]  Naveen Albert <asterisk@phreaknet.org>

	* func_scramble: Fix null pointer dereference.

	  Fix segfault due to null pointer dereference
	  inside the audiohook callback.

	  ASTERISK-30220 #close

	  Change-Id: Ideb80f606974366e89d619d908744230b5a5a259

2022-09-11 15:40 +0000 [0b47641005]  Naveen Albert <asterisk@phreaknet.org>

	* func_strings: Add trim functions.

	  Adds TRIM, LTRIM, and RTRIM, which can be used
	  for trimming leading and trailing whitespace
	  from strings.

	  ASTERISK-30222 #close

	  Change-Id: I50fb0c40726d044a7a41939fa9026f3da4872554

2022-09-16 09:58 +0000 [589c941c9a]  George Joseph <gjoseph@digium.com>

	* res_crypto: Memory issues and uninitialized variable errors

	  ASTERISK-30235

	  Change-Id: Ia1e326e7b52cd06fd5e6c9009e3e63193c92f6cd

2022-09-16 08:43 +0000 [951f99c8b1]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Fix issues exposed by compiling with -O2

	  Fixed "may be used uninitialized" errors in geoloc_config.c.

	  ASTERISK-30234

	  Change-Id: I1ea336bf7abbc16fa59b75720f0db8f1d960b3d4

2022-09-13 14:41 +0000 [4fd75c718d]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: don't complain about directories

	  ASTERISK-30226 #close

	  Change-Id: I5695fb0c9521f112f754b8362cff2a8f3eff05c5

2022-09-14 14:32 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.15.0-rc1 Released.

2022-09-14 09:10 +0000 [a7f29e8d1a]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.15.0
2022-08-15 14:30 +0000 [23933c6242]  Mike Bradeen <mbradeen@sangoma.com>

	* res_pjsip: Add user=phone on From and PAID for usereqphone=yes

	  Adding user=phone to local-side uri's when user_eq_phone=yes is set for
	  an endpoint. Previously this would only add the header to the To and R-URI.

	  ASTERISK-30178

	  Change-Id: Id3bfb5d225d762e7d2668c023fe09e4541ae8600

2022-09-13 08:14 +0000 [4ab3cd6f86]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Fix segfault when there's an empty element

	  Fixed a segfault caused by var_list_from_loc_info() encountering
	  an empty location info element.

	  Fixed an issue in ast_strsep() where a value with only whitespace
	  wasn't being preserved.

	  Fixed an issue in ast_variable_list_from_quoted_string() where
	  an empty value was considered a failure.

	  ASTERISK-30215
	  Reported by: Dan Cropp

	  Change-Id: Ieca64e061a6d9298f0196c694b60d986ef82613a

2022-08-13 11:32 +0000 [2f5cfa548f]  sungtae kim <pchero21@gmail.com>

	* res_musiconhold: Add option to not play music on hold on unanswered channels

	  This change adds an option, answeredonly, that will prevent music on
	  hold on channels that are not answered.

	  ASTERISK-30135

	  Change-Id: I1ab0defa43a29a26ae39f94c623596cf90fddc08

2022-08-02 12:15 +0000 [1f685d6969]  Ben Ford <bford@digium.com>

	* res_pjsip: Add TEL URI support for basic calls.

	  This change allows TEL URI requests to come through for basic calls. The
	  allowed requests are INVITE, ACK, BYE, and CANCEL. The From and To
	  headers will now allow TEL URIs, as well as the request URI.

	  Support is only for TEL URIs present in traffic from a remote party.
	  Asterisk does not generate any TEL URIs on its own.

	  ASTERISK-26894

	  Change-Id: If5729e6cd583be7acf666373bf9f1b9d653ec29a

2022-03-24 14:22 +0000 [bb8b2259bc]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: Use EVP API's instead of legacy API's

	  ASTERISK-30046 #close

	  Change-Id: I5c738756de75fd27ebad54be144c0ac6193f21b2

2022-05-03 19:27 +0000 [0972106d51]  Philip Prindeville <philipp@redfish-solutions.com>

	* test: Add coverage for res_crypto

	  We're validating the following functionality:

	  encrypting a block of data with RSA
	  decrypting a block of data with RSA
	  signing a block of data with RSA
	  verifying a signature with RSA
	  encrypting a block of data with AES-ECB
	  encrypting a block of data with AES-ECB

	  as well as accessing test keys from the keystore.

	  ASTERISK-30045 #close

	  Change-Id: I0d10e7b41009c5290a4356c6480e636712d5c96d

2022-07-26 12:38 +0000 [53f8cc1d49]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: make keys reloadable on demand for testing

	  ASTERISK-30045

	  Change-Id: If59bbb50c1771084bfe2fef307a6077c90d35ce8

2022-05-03 13:12 +0000 [47e49f93fa]  Philip Prindeville <philipp@redfish-solutions.com>

	* test: Add test coverage for capture child process output

	  ASTERISK-30037 #close

	  Change-Id: I0273e85eeeb6b8e46703f24cd74d84f3daf0a69a

2022-07-26 14:38 +0000 [aeb23fe2a7]  Philip Prindeville <philipp@redfish-solutions.com>

	* main/utils: allow checking for command in $PATH

	  ASTERISK-30037

	  Change-Id: I4b6f7264c8c737c476c798d2352f3232b263bbdf

2022-05-02 23:49 +0000 [f2cd48e9a8]  Philip Prindeville <philipp@redfish-solutions.com>

	* test: Add ability to capture child process output

	  ASTERISK-30037

	  Change-Id: Icbf84ce05addb197a458361c35d784e460d8d6c2

2022-04-26 20:44 +0000 [7a0fe63390]  Philip Prindeville <philipp@redfish-solutions.com>

	* res_crypto: Don't load non-regular files in keys directory

	  ASTERISK-30046

	  Change-Id: Ie77e0648f8b0b1c2159fb24662d1989cfd4cc36d

2022-09-08 09:12 +0000 [f74c459a42]  Naveen Albert <asterisk@phreaknet.org>

	* func_frame_trace: Remove bogus assertion.

	  The FRAME_TRACE function currently asserts if it sees
	  a MASQUERADE_NOTIFY. However, this is a legitimate thing
	  that can happen so asserting is inappropriate, as there
	  are no clear negative ramifications of such a thing. This
	  is adjusted to be like the other frames to print out
	  the subclass.

	  ASTERISK-30210 #close

	  Change-Id: I8ecbdcf17e35f64bdeab42868471f581ad1d1a56

2022-07-27 14:54 +0000 [50ce155749]  Naveen Albert <asterisk@phreaknet.org>

	* lock.c: Add AMI event for deadlocks.

	  Adds an AMI event to indicate that a deadlock
	  has likely started, when Asterisk is compiled
	  with DETECT_DEADLOCKS enabled. This can make
	  it easier to perform automated deadlock detection
	  and take appropriate action (such as doing a core
	  dump). Unlike the deadlock warnings, the AMI event
	  is emitted only once per deadlock.

	  ASTERISK-30161 #close

	  Change-Id: Ifc6ed3e390f8b4cff7f8077a50e4d7a5b54e42fb

2022-09-04 14:38 +0000 [8c6c06a340]  Naveen Albert <asterisk@phreaknet.org>

	* app_confbridge: Add end_marked_any option.

	  Adds the end_marked_any option, which can be used
	  to kick a user from a conference if any marked user
	  leaves.

	  ASTERISK-30211 #close

	  Change-Id: I9e8da7ccb892e522546c0f2b5476d172e022c2f5

2022-08-25 08:00 +0000 [0e9076df7b]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Add two new options to GEOLOC_PROFILE

	  Added an 'a' option to the GEOLOC_PROFILE function to allow
	  variable lists like location_info_refinement to be appended
	  to instead of replacing the entire list.

	  Added an 'r' option to the GEOLOC_PROFILE function to resolve all
	  variables before a read operation and after a Set operation.

	  Added a few missing parameters to the ones allowed for writing
	  with GEOLOC_PROFILE.

	  Fixed a bug where calling GEOLOC_PROFILE to read a parameter
	  might actually update the profile object.

	  Cleaned up XML documentation a bit.

	  ASTERISK-30190

	  Change-Id: I75f541db43345509a2e86225bfa4cf8e242e5b6c

2022-08-18 07:29 +0000 [261051ecec]  George Joseph <gjoseph@digium.com>

	* res_geolocation:  Allow location parameters on the profile object

	  You can now specify the location object's format, location_info,
	  method, location_source and confidence parameters directly on
	  a profile object for simple scenarios where the location
	  information isn't common with any other profiles.  This is
	  mutually exclusive with setting location_reference on the
	  profile.

	  Updated appdocsxml.dtd to allow xi:include in a configObject
	  element.  This makes it easier to link to complete configOptions
	  in another object.  This is used to add the above fields to the
	  profile object without having to maintain the option descriptions
	  in two places.

	  ASTERISK-30185

	  Change-Id: Ifd5f05be0a76f0a6ad49fa28d17c394027677569

2022-08-17 08:15 +0000 [372f5c56e1]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Add profile parameter suppress_empty_ca_elements

	  Added profile parameter "suppress_empty_ca_elements" that
	  will cause Civic Address elements that are empty to be
	  suppressed from the outgoing PIDF-LO document.

	  Fixed a possible SEGV if a sub-parameter value didn't have a
	  value.

	  ASTERISK-30177

	  Change-Id: I924ccc5aa2f45110a3155b22e53dfaf3ef2092dd

2022-08-16 07:25 +0000 [1fc0298f87]  George Joseph <gjoseph@digium.com>

	* res_geolocation:  Add built-in profiles

	  The trigger to perform outgoing geolocation processing is the
	  presence of a geoloc_outgoing_call_profile on an endpoint. This
	  is intentional so as to not leak location information to
	  destinations that shouldn't receive it.   In a totally dynamic
	  configuration scenario however, there may not be any profiles
	  defined in geolocation.conf.  This makes it impossible to do
	  outgoing processing without defining a "dummy" profile in the
	  config file.

	  This commit adds 4 built-in profiles:
	    "<prefer_config>"
	    "<discard_config>"
	    "<prefer_incoming>"
	    "<discard_incoming>"
	  The profiles are empty except for having their precedence
	  set and can be set on an endpoint to allow processing without
	  entries in geolocation.conf.  "<discard_config>" is actually the
	  best one to use in this situation.

	  ASTERISK-30182

	  Change-Id: I1819ccfa404ce59802a3a07ad1cabed60fb9480a

2022-08-30 08:01 +0000 [fb11296a9b]  Joshua C. Colp <jcolp@sangoma.com>

	* res_pjsip_sdp_rtp: Skip formats without SDP details.

	  When producing an outgoing SDP we iterate through the configured
	  formats and produce SDP information. It is possible for some
	  configured formats to not have SDP information available. If this
	  is the case we skip over them to allow the SDP to still be
	  produced.

	  ASTERISK-29185

	  Change-Id: I3e37569aa4ca341260e6ca5904dc2f75e46a1749

2022-05-03 07:53 +0000 [8041bd12c1]  Naveen Albert <asterisk@phreaknet.org>

	* cli: Prevent assertions on startup from bad ao2 refs.

	  If "core show channels" is run before startup has completed, it
	  is possible for bad ao2 refs to occur because the system is not
	  yet fully initialized. This will lead to an assertion failing.

	  To prevent this, initialization of CLI builtins is moved to be
	  later along in the main load sequence. Core CLI commands are
	  loaded at the same time, but channel-related commands are loaded
	  later on.

	  ASTERISK-29846 #close

	  Change-Id: If6b3cde802876bd738c1b4cf2683bea6ddc615b6

2022-08-19 08:24 +0000 [f97e9aed85]  Joshua C. Colp <jcolp@sangoma.com>

	* pjsip: Add TLS transport reload support for certificate and key.

	  This change adds support using the pjsip_tls_transport_restart
	  function for reloading the TLS certificate and key, if the filenames
	  remain unchanged. This is useful for Let's Encrypt and other
	  situations. Note that no restart of the transport will occur if
	  the certificate and key remain unchanged.

	  ASTERISK-30186

	  Change-Id: I9bc95a6bf791830a9491ad9fa43c17d4010028d0

2022-08-25 06:51 +0000 [6c489a891d]  Naveen Albert <asterisk@phreaknet.org>

	* res_tonedetect: Fix typos referring to wrong variables.

	  Fixes two typos that cause fax detection to not work.
	  One refers to the wrong frame variable, and the other
	  refers to the subclass.integer instead of the frametype
	  as it should.

	  ASTERISK-30192 #close

	  Change-Id: I7b35fdb7bcf25a29a212eee37c20812c64ab3ef1

2022-08-17 13:30 +0000 [c49a2c46f6]  Mike Bradeen <mbradeen@sangoma.com>

	* alembic: add missing ps_endpoints columns

	  The following required columns were missing,
	  now added to the ps_endpoints table:

	  incoming_call_offer_pref
	  outgoing_call_offer_pref
	  stir_shaken_profile

	  ASTERISK-29453

	  Change-Id: I5cf565edf30195844d6acbc1e1de8c5f0d837568

2022-08-19 11:02 +0000 [b3bf415455]  Sean Bright <sean@seanbright.com>

	* chan_dahdi.c: Resolve a format-truncation build warning.

	  With gcc (Ubuntu 11.2.0-19ubuntu1) 11.2.0:

	  > chan_dahdi.c:4129:18: error: ‘%s’ directive output may be truncated
	  >   writing up to 255 bytes into a region of size between 242 and 252
	  >   [-Werror=format-truncation=]

	  This removes the error-prone sizeof(...) calculations in favor of just
	  doubling the size of the base buffer.

	  Change-Id: I2d276785286730d3d5d0a921bcea2e065dbf27c5

2022-08-03 09:55 +0000 [18cfcdcd34]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: Postpone destruction of old subscriptions on RLS update

	  Set termination state to old subscriptions to prevent queueing and sending
	  NOTIFY messages on exten/device state changes.

	  Postpone destruction of old subscriptions until all already queued tasks
	  that may be using old subscriptions have completed.

	  ASTERISK-29906

	  Change-Id: I96582aad3a26515ca73a8460ee6756f56f6ba23b

2022-08-15 07:34 +0000 [57972bac38]  Sean Bright <sean@seanbright.com>

	* channel.h: Remove redundant declaration.

	  The DECLARE_STRINGFIELD_SETTERS_FOR() declares ast_channel_name_set()
	  for us, so no need to declare it separately.

	  Change-Id: I4813a884ada475ddc62bca480bceb4a53b3ec59a

2022-02-05 06:13 +0000 [6000f9963c]  Naveen Albert <asterisk@phreaknet.org>

	* features: Add transfer initiation options.

	  Adds additional control options over the transfer
	  feature functionality to give users more control
	  in how the transfer feature sounds and works.

	  First, the "transfer" sound that plays when a transfer is
	  initiated can now be customized by the user in
	  features.conf, just as with the other transfer sounds.

	  Secondly, the user can now specify the transfer extension
	  in advance by using the TRANSFER_EXTEN variable. If
	  a valid extension is contained in this variable, the call
	  will automatically be transferred to this destination.
	  Otherwise, it will fall back to collecting the extension
	  from the user as is always done now.

	  ASTERISK-29899 #close

	  Change-Id: Ibff309caa459a2b958706f2ed0ca393b1ef502e3

2022-08-31 14:16 +0000 [bd821549af]  Mike Bradeen <mbradeen@sangoma.com>

	* CI: Fixing path issue on venv check

	  ASTERISK-26826

	  Change-Id: I07388d16f74452cebc9c981f99044eb6b77df792

2022-08-11 13:39 +0000 [e2f34ad8ce]  Mike Bradeen <mbradeen@sangoma.com>

	* CI: use Python3 virtual environment

	  Requires Python3 testsuite changes

	  ASTERISK-26826

	  Change-Id: I92ec7dec751ad455503a584d6e860db88c56d6bc

2022-07-28 16:12 +0000 [9126f9bd2b]  Naveen Albert <asterisk@phreaknet.org>

	* general: Very minor coding guideline fixes.

	  Fixes a few coding guideline violations:
	  * Use of C99 comments
	  * Opening brace on same line as function prototype

	  ASTERISK-30163 #close

	  Change-Id: I07771c4c89facd41ce8d323859f022ddbddf6ca7

2022-08-11 10:47 +0000 [c5ebc6ba40]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.14.0
2022-08-05 08:50 +0000 [dfedb13eca]  George Joseph <gjoseph@digium.com>

	* res_geolocation: Address user issues, remove complexity, plug leaks

	  * Added processing for the 'confidence' element.
	  * Added documentation to some APIs.
	  * removed a lot of complex code related to the very-off-nominal
	    case of needing to process multiple location info sources.
	  * Create a new 'ast_geoloc_eprofile_to_pidf' API that just takes
	    one eprofile instead of a datastore of multiples.
	  * Plugged a huge leak in XML processing that arose from
	    insufficient documentation by the libxml/libxslt authors.
	  * Refactored stylesheets to be more efficient.
	  * Renamed 'profile_action' to 'profile_precedence' to better
	    reflect it's purpose.
	  * Added the config option for 'allow_routing_use' which
	    sets the value of the 'Geolocation-Routing' header.
	  * Removed the GeolocProfileCreate and GeolocProfileDelete
	    dialplan apps.
	  * Changed the GEOLOC_PROFILE dialplan function as follows:
	    * Removed the 'profile' argument.
	    * Automatically create a profile if it doesn't exist.
	    * Delete a profile if 'inheritable' is set to no.
	  * Fixed various bugs and leaks
	  * Updated Asterisk WiKi documentation.

	  ASTERISK-30167

	  Change-Id: If38c23f26228e96165be161c2f5e849cb8e16fa0

2022-07-30 16:15 +0000 [d76f0506e5]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Add missing options documentation.

	  Adds missing dial resource option documentation.

	  ASTERISK-30164 #close

	  Change-Id: I674e1fc9b1e5d67a20599bd4b418ce294d48fc83

2022-07-31 19:30 +0000 [300a6150d5]  Naveen Albert <asterisk@phreaknet.org>

	* app_confbridge: Fix memory leak on updated menu options.

	  If the CONFBRIDGE function is used to dynamically set
	  menu options, a memory leak occurs when a menu option
	  that has been set is overridden, since the menu entry
	  is not destroyed before being freed. This ensures that
	  it is.

	  Additionally, logic that duplicates the destroy function
	  is removed in lieu of the destroy function itself.

	  ASTERISK-28422 #close

	  Change-Id: I71cfb5c24e636984d41086d1333a416dc12ff995

2022-07-19 09:05 +0000 [0da37ff8ed]  George Joseph <gjoseph@digium.com>

	* Geolocation: Wiki Documentation

	  Change-Id: I68ba22db0a69d9e2eabcc2141b48a2395f7f1a23

2022-07-28 06:10 +0000 [ef1026227d]  Naveen Albert <asterisk@phreaknet.org>

	* manager: Remove documentation for nonexistent action.

	  The manager XML documentation documents a "FilterList"
	  action, but there is no such action. Therefore, this can
	  lead to confusion when people try to use a documented
	  action that does not, in fact, exist. This is removed
	  as the action never did exist in the past, nor would it
	  be trivial to add since we only store the regex_t
	  objects, so the filter list can't actually be provided
	  without storing that separately. Most likely, the
	  documentation was originally added (around version 10)
	  in anticipation of something that never happened.

	  ASTERISK-29917 #close

	  Change-Id: I846b16fd6f80a91d4ddc5d8a861b522d7c6f8f97

2022-07-23 18:07 +0000 [f459872430]  Naveen Albert <asterisk@phreaknet.org>

	* app_meetme: Add missing AMI documentation.

	  The MeetmeList and MeetmeListRooms AMI
	  responses are currently completely undocumented.
	  This adds documentation for these responses.

	  ASTERISK-30018 #close

	  Change-Id: Id93135b7edf01de6f8fba266e2122989dc8996b8

2022-07-22 15:57 +0000 [08afdcbd30]  Naveen Albert <asterisk@phreaknet.org>

	* general: Improve logging levels of some log messages.

	  Adjusts some logging levels to be more or less important,
	  that is more prominent when actual problems occur and less
	  prominent for less noteworthy things.

	  ASTERISK-30153 #close

	  Change-Id: Ifc8f7df427aa018627db462125ae744986d3261b

2022-07-27 13:34 +0000 [d0cd6e82a6]  Naveen Albert <asterisk@phreaknet.org>

	* cdr.conf: Remove obsolete app_mysql reference.

	  The CDR sample config still mentions that app_mysql
	  is available in the addons directory, but this is
	  incorrect as it was removed as of 19. This removes
	  that to avoid confusion.

	  ASTERISK-30160 #close

	  Change-Id: Ie5293ccb4f2b365896981811b480544e67bb9cd7

2022-07-27 13:28 +0000 [307b0fa767]  Naveen Albert <asterisk@phreaknet.org>

	* general: Remove obsolete SVN references.

	  There are a handful of files in the tree that
	  reference an SVN link for the coding guidelines.

	  This removes these because the links are dead
	  and the vast majority of source files do not
	  contain these links, so this is more consistent.

	  app_skel still maintains an (up to date) link
	  to the coding guidelines.

	  ASTERISK-30159 #close

	  Change-Id: I35bbb20f66982e98099cff3029ede20091ffdac7

2022-07-23 18:14 +0000 [38515df4da]  Naveen Albert <asterisk@phreaknet.org>

	* app_confbridge: Add missing AMI documentation.

	  Documents the ConfbridgeListRooms AMI response,
	  which is currently not documented.

	  ASTERISK-30020 #close

	  Change-Id: Id6fff7a936244bae7b52686301eb740c1169cdea

2022-07-23 17:37 +0000 [c8d2c74a5a]  Naveen Albert <asterisk@phreaknet.org>

	* func_srv: Document field parameter.

	  Adds missing documentation for the field parameter
	  for the SRVRESULT function.

	  ASTERISK-30151
	  Reported by: Chris Young

	  Change-Id: I4385a2e0892a07e30dea1a8a0588e2c1bea2b1f1

2022-07-28 15:51 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.14.0-rc1 Released.

2022-07-28 10:40 +0000 [57c4dc1721]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.14.0
2022-07-23 17:17 +0000 [a2799554d2]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_functions.c: Manually update ast_str strlen.

	  When ast_func_read2 is used to read a function using
	  its read function (as opposed to a native ast_str read2
	  function), the result is copied directly by the function
	  into the ast_str buffer. As a result, the ast_str length
	  remains initialized to 0, which is a bug because this is
	  not the real string length.

	  This can cascade and have issues elsewhere, such as when
	  reading substrings of functions that only register read
	  as opposed to read2 callbacks. In this case, since reading
	  ast_str_strlen returns 0, the returned substring is empty
	  as opposed to the actual substring. This has caused
	  the ast_str family of functions to behave inconsistently
	  and erroneously, in contrast to the pbx_variables substitution
	  functions which work correctly.

	  This fixes this issue by manually updating the ast_str length
	  when the result is copied directly into the ast_str buffer.

	  Additionally, an assertion and a unit test that previously
	  exposed these issues are added, now that the issue is fixed.

	  ASTERISK-29966 #close

	  Change-Id: I4e2dba41410f9d4dff61c995d2ca27718248e07f

2022-02-18 15:59 +0000 [133ecb346c]  Sergey V. Lobanov <sergey@lobanov.in>

	* build: fix bininstall launchd issue on cross-platform build

	  configure script detects /sbin/launchd, but the result of this
	  check is not used in Makefile (bininstall). Makefile also detects
	  /sbin/launchd file to decide if it is required to install
	  safe_asterisk.

	  configure script correctly detects cross compile build and sets
	  PBX_LAUNCHD=0

	  In case of building asterisk on MacOS host for Linux target using
	  external toolchain (e.g. OpenWrt toolchain), bininstall does not
	  install safe_asterisk (due to /sbin/launchd detection in Makefile),
	  but it is required on target (Linux).

	  This patch adds HAVE_SBIN_LAUNCHD=@PBX_LAUNCHD@ to makeopts.in to
	  use the result of /sbin/launchd detection from configure script in
	  Makefile.
	  Also this patch uses HAVE_SBIN_LAUNCHD in Makefile (bininstall) to
	  decide if it is required to install safe_asterisk.

	  ASTERISK-29905 #close

	  Change-Id: Iff61217276cd188f43f51ef4cdbffe39d9f07f65

2022-07-12 16:38 +0000 [4580ac7ded]  Naveen Albert <asterisk@phreaknet.org>

	* manager: Fix incomplete filtering of AMI events.

	  The global event filtering code was only in one
	  possible execution path, so not all events were
	  being properly filtered out if requested. This moves
	  that into the universal AMI handling code so all
	  events are properly handled.

	  Additionally, the CLI listing of disabled events can
	  also get truncated, so we now print out everything.

	  ASTERISK-30137 #close

	  Change-Id: If8c42edcb2abc5158552da7eba2a8ff6b20e1959

2022-07-11 06:32 +0000 [7bdab4e206]  Naveen Albert <asterisk@phreaknet.org>

	* db: Add AMI action to retrieve DB keys at prefix.

	  Adds the DBGetTree action, which can be used to
	  retrieve all of the DB keys beginning with a
	  particular prefix, similar to the capability
	  provided by the database show CLI command.

	  ASTERISK-30136 #close

	  Change-Id: I3be9425e53be71f24303fdd4d2923c14e84337e6

2022-06-14 04:12 +0000 [75226a4b02]  Michael Neuhauser <mike@firmix.at>

	* res_pjsip: delay contact pruning on Asterisk start

	  Move the call to ast_sip_location_prune_boot_contacts() *after* the call
	  to ast_res_pjsip_init_options_handling() so that
	  res/res_pjsip/pjsip_options.c is informed about the contact deletion and
	  updates its sip_options_contact_statuses list. This allows for an AMI
	  event to be sent by res/res_pjsip/pjsip_options.c if the endpoint
	  registers again from the same remote address and port (i.e., same URI)
	  as used before the Asterisk restart.

	  ASTERISK-30109
	  Reported-by: Michael Neuhauser

	  Change-Id: I1ba4478019e4931a7085f62708d9b66837e901a8

2022-03-28 20:35 +0000 [8fddef679c]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Fix buggy and missing Caller ID parameters

	  There are several things wrong with analog Caller ID
	  handling that are fixed by this commit:

	  callerid.c's Caller ID generation function contains the
	  logic to use the presentation to properly send the proper
	  Caller ID. However, currently, DAHDI does not pass any
	  presentation information to the Caller ID module, which
	  means that presentation is completely ignored on all calls.
	  This means that lines could be getting Caller ID information
	  they aren't supposed to.

	  Part of the reason this has been obscured is because the
	  simple switch logic for handling the built in *67 and *82
	  is completely wrong. Rather than modifying the presentation
	  for the call accordingly (which is what it's supposed to do),
	  it simply blanks out the Caller ID or fills it in. This is
	  wrong, so wrong that it makes a mockery of the specification.
	  Additionally, it would leave to the "UNAVAILABLE" disposition
	  being used for Caller ID generation as opposed to the "PRIVATE"
	  disposition that it should have been using. This is now fixed
	  to only update the presentation and not modify the number and
	  name, so that the simple switch *67/*82 work correctly.

	  Next, sig_analog currently only copies over the name and number,
	  nothing else, when it is filling in a duplicated caller id
	  structure. Thus, we also now copy over the presentation
	  information so that is available for the Caller ID spill.
	  Additionally, this meant that "valid" was implicitly 0,
	  and as such presentation would always fail to "Unavailable".
	  The validity is therefore also copied over so it can be used
	  by ast_party_id_presentation.

	  As part of this fix, new API is added so that all the relevant
	  Caller ID information can be passed in to the Caller ID generation
	  functions. Parameters that are also completely missing from the
	  Caller ID spill have also been added, to enhance the compatibility,
	  correctness, and completeness of the Asterisk Caller ID implementation.

	  ASTERISK-29991 #close

	  Change-Id: Icc44a5e09979916f4c18a440f96e10dc1c76ae15

2022-07-10 17:31 +0000 [56c6d76a45]  Sam Banks <sam.banks.nz@gmail.com>

	* queues.conf.sample: Correction of typo

	  ASTERISK-30126 #close

	  Change-Id: I009c4dcbf9338a13e3baf87b52a5bbe4f9f81a42

2022-04-01 15:17 +0000 [a78a82016d]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Add POLARITY function.

	  Adds a POLARITY function which can be used to
	  retrieve the current polarity of an FXS channel
	  as well as set the polarity of an FXS channel
	  to idle or reverse at any point during a call.

	  ASTERISK-30000 #close

	  Change-Id: If6f50998f723e4484bf68e2473f5cedfeaf9b8f1

2022-06-01 21:03 +0000 [7a82919256]  Mike Bradeen <mbradeen@sangoma.com>

	* Makefile: Avoid git-make user conflict

	  make_version now silently checks if the required git commands will
	  fail.  If they do, then return UNKNOWN__git_check_fail to
	  distinguish this failure from other UNKNOWN__ version failures

	  Makefile checks for this value on install and exits out with
	  instructions

	  ASTERISK-30029

	  Change-Id: If8f10cac8f509c08981120f17555762342020221

2022-06-18 07:17 +0000 [a4266030ce]  Naveen Albert <asterisk@phreaknet.org>

	* app_confbridge: Always set minimum video update interval.

	  Currently, if multiple video-enabled ConfBridges are
	  conferenced together, we immediately get into a scenario
	  where an infinite sequence of video updates fills up
	  the taskprocessor queue and causes memory consumption
	  to climb unabated until Asterisk is killed. This is due
	  to the core bridging mechanism that provides video updates
	  (softmix_bridge_write_control in bridge_softmix.c)
	  continously updating all the channels in the bridge with
	  video updates.

	  The logic to do so in the core is that the video updates
	  should be provided if the video_update_discard property
	  for the bridge is 0, or if enough time has elapsed since
	  the last video update. Thus, we already have a safeguard
	  built in to ensure the scenario described above does not
	  happen. Currently, however, this safeguard is not being
	  adequately ensured.

	  In app_confbridge, the video_update_discard property
	  defaults to 2000, which is a healthy value that should
	  completely prevent this issue. However, this value is
	  only set onto the bridge in the SFU video mode. This
	  leaves video modes such as follow_talker completely
	  vulnerable, since video_update_discard will actually
	  be 0, since the default or set value was never applied.
	  As a result, the core bridging mechanism will always
	  try to provide video updates regardless of when the last
	  one was sent.

	  To prevent this issue from happening, we now always
	  set the video_update_discard property on the bridge
	  with the value from the bridge profile. The app_confbridge
	  defaults will thus ensure that infinite video updates
	  no longer happen in any video mode.

	  ASTERISK-29907 #close

	  Change-Id: I4accb2536ac62797950468e9930f12ef7dd486b2

2022-07-05 10:24 +0000 [35ebaed94d]  Sean Bright <sean@seanbright.com>

	* pbx.c: Simplify ast_context memory management.

	  Allocate all of the ast_context's character data in the structure's
	  flexible array member and eliminate the clunky fake_context. This will
	  simplify future changes to ast_context.

	  Change-Id: I98357de75d8ac2b3c4c9f201223632e6901021ea

2022-07-13 13:38 +0000 [fcc3e7fac6]  George Joseph <gjoseph@digium.com>

	* geoloc_eprofile.c: Fix setting of loc_src in set_loc_src()

	  line 196:    loc_src = '\0';
	  should have been
	  line 196:    *loc_src = '\0';

	  The issue was caught by the gcc optimizer complaining that
	  loc_src had a zero length because the pointer itself was being
	  set to NULL instead of the _contents_ of the pointer being set
	  to the NULL terminator.

	  ASTERISK-30138
	  Reported-by: Sean Bright

	  Change-Id: Id247be113cc8510f043ca053d5b4f5f3d32acd29

2022-07-07 10:32 +0000 [cdbd973ecd]  George Joseph <gjoseph@digium.com>

	* Geolocation:  chan_pjsip Capability Preview

	  This commit adds res_pjsip_geolocation which gives chan_pjsip
	  the ability to use the core geolocation capabilities.

	  This commit message is intentionally short because this isn't
	  a simple capability.  See the documentation at
	  https://wiki.asterisk.org/wiki/display/AST/Geolocation
	  for more information.

	  THE CAPABILITIES IMPLEMENTED HERE MAY CHANGE BASED ON
	  USER FEEDBACK!

	  ASTERISK-30128

	  Change-Id: Ie2e2bcd87243c2cfabc43eb823d4427c7086f4d9

2022-02-15 07:29 +0000 [f491355384]  George Joseph <gjoseph@digium.com>

	* Geolocation:  Core Capability Preview

	  This commit adds res_geolocation which creates the core capabilities
	  to manipulate Geolocation information on SIP INVITEs.

	  An upcoming commit will add res_pjsip_geolocation which will
	  allow the capabilities to be used with the pjsip channel driver.

	  This commit message is intentionally short because this isn't
	  a simple capability.  See the documentation at
	  https://wiki.asterisk.org/wiki/display/AST/Geolocation
	  for more information.

	  THE CAPABILITIES IMPLEMENTED HERE MAY CHANGE BASED ON
	  USER FEEDBACK!

	  ASTERISK-30127

	  Change-Id: Ibfde963121b1ecf57fd98ee7060c4f0808416303

2022-05-31 19:49 +0000 [0fe1a581e5]  Naveen Albert <asterisk@phreaknet.org>

	* general: Fix various typos.

	  ASTERISK-30089 #close

	  Change-Id: I1f5db911fd05a3a211c522c13e990fa1d0e62275

2022-06-06 15:09 +0000 [182fee79eb]  Morvai Szabolcs

	* cel_odbc & res_config_odbc: Add support for SQL_DATETIME field type

	  See also: ASTERISK_30023

	  ASTERISK-30096 #close
	  patches:
	    inline on issue - submitted by Morvai Szabolcs

	  Change-Id: I79c0b74862100acd9c8319dca5cc456a654d02eb

2022-07-04 05:21 +0000 [1d3d6e49db]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Allow compiling without OpenSSL.

	  ASTERISK_30007 accidentally made OpenSSL a
	  required depdendency. This adds an ifdef so
	  the relevant code is compiled only if OpenSSL
	  is available, since it only needs to be executed
	  if OpenSSL is available anyways.

	  ASTERISK-30083 #close

	  Change-Id: Iad05c1a9a8bd2a48e7edf8d234eaa9f80779e34d

2022-06-28 06:59 +0000 [512c711716]  Joshua C. Colp <jcolp@sangoma.com>

	* websocket / aeap: Handle poll() interruptions better.

	  A sporadic test failure was happening when executing the AEAP
	  Websocket transport tests. It was originally thought this was
	  due to things not getting cleaned up fast enough, but upon further
	  investigation I determined the underlying cause was poll()
	  getting interrupted and this not being handled in all places.

	  This change adds EINTR and EAGAIN handling to the Websocket
	  client connect code as well as the AEAP Websocket transport code.
	  If either occur then the code will just go back to waiting
	  for data.

	  The originally disabled failure test case has also been
	  re-enabled.

	  ASTERISK-30099

	  Change-Id: I1711a331ecf5d35cd542911dc6aaa9acf1e172ad

2022-05-14 16:25 +0000 [4adbdfde06]  Naveen Albert <asterisk@phreaknet.org>

	* res_cliexec: Add dialplan exec CLI command.

	  Adds a CLI command similar to "dialplan eval function" except for
	  applications: "dialplan exec application", useful for quickly
	  testing certain application behavior directly from the CLI
	  without writing any dialplan.

	  ASTERISK-30062 #close

	  Change-Id: I42e9fa9b60746c21450d40f99a026d48d2486dde

2022-07-03 16:29 +0000 [dbace3334d]  Trevor Peirce <trev@acrovoice.ca>

	* features: Update documentation for automon and automixmon

	  The current documentation is out of date and does not reflect actual
	  behaviour.  This change makes documentation clearer and accurately
	  reflect the purpose of relevant channel variables.

	  ASTERISK-30123

	  Change-Id: I160d0b01fce862477ad55ac1aa708a730473eb6f

2022-06-27 12:31 +0000 [1ed15e1815]  George Joseph <gjoseph@digium.com>

	* Geolocation: Base Asterisk Prereqs

	  * Added ast_variable_list_from_quoted_string()
	    Parse a quoted string into an ast_variable list.

	  * Added ast_str_substitute_variables_full2()
	    Perform variable/function/expression substitution on an ast_str.

	  * Added ast_strsep_quoted()
	    Like ast_strsep except you can specify a specific quote character.
	    Also added unit test.

	  * Added ast_xml_find_child_element()
	    Find a direct child element by name.

	  * Added ast_xml_doc_dump_memory()
	    Dump the specified document to a buffer

	  * ast_datastore_free() now checks for a NULL datastore
	    before attempting to destroy it.

	  Change-Id: I5dcefed2f5f93a109e8b489e18d80d42e45244ec

2022-06-24 06:09 +0000 [d6ff560f20]  Boris P. Korzun <drtr0jan@yandex.ru>

	* pbx_lua: Remove compiler warnings

	  Improved variable definitions (specified correct type) for avoiding
	  compiler warnings.

	  ASTERISK-30117 #close

	  Change-Id: I3b00c1befb658ee9379ddabd9a9132765ca9201a

2022-04-08 05:34 +0000 [b29a0e08a3]  Jose Lopes <jose.lopes@nfon.com>

	* res_pjsip_header_funcs: Add functions PJSIP_RESPONSE_HEADER and PJSIP_RESPONSE_HEADERS

	  These new functions allow retrieving information from headers on 200 OK
	  INVITE response.

	  ASTERISK-29999

	  Change-Id: I264a610a9333359297a0825feb29a1bb4f4ad144

2022-06-09 02:10 +0000 [22be2a2857]  Boris P. Korzun <drtr0jan@yandex.ru>

	* res_prometheus: Optional load res_pjsip_outbound_registration.so

	  Switched res_pjsip_outbound_registration.so dep to optional. Added
	  module loaded check before using it.

	  ASTERISK-30101 #close

	  Change-Id: Ia34f1684d984e821fbdd4de8911f930337703666

2022-04-30 11:44 +0000 [8ce1b7db3c]  Naveen Albert <asterisk@phreaknet.org>

	* app_dial: Fix dial status regression.

	  ASTERISK_28638 caused a regression by incorrectly aborting
	  early and overwriting the status on certain calls.
	  This was exhibited by certain technologies such as DAHDI,
	  where DAHDI returns NULL for the request if a line is busy.
	  This caused the BUSY condition to be incorrectly treated
	  as CHANUNAVAIL because the DIALSTATUS was getting incorrectly
	  overwritten and call handling was aborted early.

	  This is fixed by instead checking if any valid peers have been
	  specified, as opposed to checking the list size of successful
	  requests. This is because the latter could be empty but this
	  does not indicate any kind of problem. This restores the
	  previous working behavior.

	  ASTERISK-29989 #close

	  Change-Id: I4d4b209b967816b1bc791534593ababa2b99bb88

2022-04-01 14:49 +0000 [c9955d5fcd]  Naveen Albert <asterisk@phreaknet.org>

	* db: Notify user if deleted DB entry didn't exist.

	  Currently, if using the CLI to delete a DB entry,
	  "Database entry removed" is always returned,
	  regardless of whether or not the entry actually
	  existed in the first place. This meant that users
	  were never told if entries did not exist.

	  The same issue occurs if trying to delete a DB key
	  using AMI.

	  To address this, new API is added that is more stringent
	  in deleting values from AstDB, which will not return
	  success if the value did not exist in the first place,
	  and will print out specific error details if available.

	  ASTERISK-30001 #close

	  Change-Id: Ic84e3eddcd66c7a6ed7fea91cdfd402568378b18

2022-06-18 12:13 +0000 [0a63692716]  Naveen Albert <asterisk@phreaknet.org>

	* app_dial: Propagate outbound hook flashes.

	  The Dial application currently stops hook flashes
	  dead in their tracks from propagating through on
	  outbound calls. This fixes that so they can go
	  down the wire.

	  ASTERISK-30115 #close

	  Change-Id: Id4e78b29a049f35c5b1e7520eaa10d0eb5b7f97c

2022-06-20 16:00 +0000 [53d921a199]  Naveen Albert <asterisk@phreaknet.org>

	* res_calendar_icalendar: Send user agent in request.

	  Microsoft recently began rejecting all requests for
	  ICS calendars on Office 365 with 400 errors if
	  the request doesn't contain a user agent. See:

	  https://docs.microsoft.com/en-us/answers/questions/883904/34the-remote-server-returned-an-error-400-bad-requ.html

	  Accordingly, we now send a user agent on requests for
	  ICS files so that requests to Office 365 will work as
	  they did before.

	  ASTERISK-30106

	  Change-Id: Ie9dcaef12ae8adf37533c684499eb11005fac8f7

2022-02-05 15:16 +0000 [57d66966a1]  Naveen Albert <asterisk@phreaknet.org>

	* cli: Fix CLI blocking forever on terminating backslash

	  A corner case exists in CLI parsing where if
	  a CLI user in a remote console ends with
	  a backslash and then invokes command completion
	  (using TAB or ?), then the console will freeze
	  forever until a SIGQUIT signal is sent to the
	  process, due to getting blocked forever
	  reading the command completion. CTRL+C
	  and other key combinations have no impact on
	  the CLI session.

	  This occurs because, in such cases, the CLI
	  process is waiting for AST_CLI_COMPLETE_EOF
	  to appear in the buffer from the main process,
	  but instead the main process is confused by
	  the funny syntax and thus prints out the CLI help.
	  As a result, the CLI process is stuck on the
	  read call, waiting for the completion that
	  will never come.

	  This prevents blocking forever by checking
	  if the data from the main process starts with
	  "Usage:". If it does, that means that CLI help
	  was sent instead of the tab complete vector,
	  and thus the CLI should bail out and not wait
	  any longer.

	  ASTERISK-29822 #close

	  Change-Id: I9810ac59304fec162da701653c9c834f0ec8f670

2022-06-08 18:32 +0000 [0ddbf6bc45]  Kevin Harwell <kharwell@sangoma.com>

	* res_pjsip: allow TLS verification of wildcard cert-bearing servers

	  Rightly the use of wildcards in certificates is disallowed in accordance
	  with RFC5922. However, RFC2818 does make some allowances with regards to
	  their use when using subject alt names with DNS name types.

	  As such this patch creates a new setting for TLS transports called
	  'allow_wildcard_certs', which when it and 'verify_server' are both enabled
	  allows DNS name types, as well as the common name that start with '*.'
	  to match as a wildcard.

	  For instance: *.example.com
	  will match for: foo.example.com

	  Partial matching is not allowed, e.g. f*.example.com, foo.*.com, etc...
	  And the starting wildcard only matches for a single level.

	  For instance: *.example.com
	  will NOT match for: foo.bar.example.com

	  The new setting is disabled by default.

	  ASTERISK-30072 #close

	  Change-Id: If0be3fdab2e09c2a66bb54824fca406ebaac3da4

2022-05-21 20:40 +0000 [93644fca59]  Naveen Albert <asterisk@phreaknet.org>

	* say: Abort play loop if caller hangs up.

	  If the caller has hung up, break out of the play loop so we don't try
	  to play remaining files and fail to do so.

	  ASTERISK-30075 #close

	  Change-Id: I55e85be28ee90b48c0fe4ce20ac136a7dbb49f14

2022-05-15 07:41 +0000 [6720caa29c]  Naveen Albert <asterisk@phreaknet.org>

	* pbx: Add helper function to execute applications.

	  Finding an application and executing it if found is
	  a common task throughout Asterisk. This adds a helper
	  function around pbx_exec to do this, to eliminate
	  redundant code and make it easier for modules to
	  substitute variables and execute applications by name.

	  ASTERISK-30061 #close

	  Change-Id: Ifee4d2825df7545fb515d763d393065675140c84

2022-05-10 07:19 +0000 [2d500a090f]  Stanislav Abramenkov <stas.abramenkov@gmail.com>

	* pjsip: Upgrade bundled version to pjproject 2.12.1

	  More information:
	  https://github.com/pjsip/pjproject/releases/tag/2.12.1

	  Pull request to third-party
	  https://github.com/asterisk/third-party/pull/11

	  ASTERISK-30050

	  Change-Id: Icb4e86d4b85ef9b975355c91f3ed56a50b51c6bd

2022-06-16 18:51 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.13.0-rc1 Released.

2022-06-16 13:43 +0000 [7933125535]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.13.0
2022-06-11 14:29 +0000 [ae08471d8b]  Naveen Albert <asterisk@phreaknet.org>

	* asterisk.c: Fix incompatibility warnings for remote console.

	  A previous review fixing ASTERISK_22246 and ASTERISK_26582
	  got a couple of the options mixed up as to whether or not
	  they are compatible with the remote console. This fixes
	  those to the best of my knowledge.

	  ASTERISK-30097 #close

	  Change-Id: Id54166991aa79f04fb02699cc499bedda854253b

2022-06-07 16:03 +0000 [71ffc92abf]  Kevin Harwell <kharwell@sangoma.com>

	* test_aeap_transport: disable part of failing unit test

	  The 'transport_binary' test sporadically fails, but on a theory that the
	  problem is caused by a previously executed test, transport_connect_fail,
	  part of that test has been disabled until a solution is found.

	  ASTERISK_30099

	  Change-Id: I48ed74d696aa9b6159f59661f3d535cac4c909e1

2022-05-13 07:33 +0000 [1beccc9a0d]  Naveen Albert <asterisk@phreaknet.org>

	* sig_analog: Fix broken three-way conferencing.

	  Three-way calling for analog lines is currently broken.
	  If party A is on a call with party B and initiates a
	  three-way call to party C, the behavior differs depending
	  on whether the call is conferenced prior to party C
	  answering. The post-answer case is correct. However,
	  if A flashes before C answers, then the next flash
	  disconnects B rather than C, which is incorrect.

	  This error occurs because the subs are not swapped
	  in the misbehaving case. This is because the flash
	  handler only swaps the subs if C has answered already,
	  which is wrong. To fix this, we swap the subs regardless
	  of whether C has answered or not when the call is
	  conferenced. This ensures that C is disconnected
	  on the next hook flash, rather than B as can happen
	  currently.

	  ASTERISK-30043 #close

	  Change-Id: I96c5bf6c9b7eb2636136b716c677c82c079b6f06

2022-05-15 08:31 +0000 [0e65855b9d]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail: Add option to prevent message deletion.

	  Adds an option to VoiceMailMain that prevents the user
	  from deleting messages during that application invocation.
	  This can be useful for public or shared mailboxes, where
	  some users should be able to listen to messages but not
	  delete them.

	  ASTERISK-30063 #close

	  Change-Id: Icdfb8423ae8d1fce65a056b603eb84a672e80a26

2022-06-13 10:38 +0000 [6487498033]  Kevin Harwell <kharwell@sangoma.com>

	* ARI version: increase non-breaking number

	  A recent change, ASTERISK_30027, now exposes a channel driver's unique
	  id to ARI channel resources so bump the ARI version.

	  Change-Id: Ic9da84b7b0eca6f3ff5b6a738b2be8362237951e

2022-06-07 16:53 +0000 [ff80a61118]  Trevor Peirce <trev@acrovoice.ca>

	* res_pjsip: Actually enable session timers when timers=always

	  When a pjsip endpoint is defined with timers=always, this has been a
	  functional noop.  This patch correctly sets the feature bitmap to both
	  enable support for session timers and to enable them even when the
	  endpoint itself does not request or support timers.

	  ASTERISK-29603
	  Reported-By: Ray Crumrine

	  Change-Id: I8b5eeaa9ec7f50cc6d96dd34c2b4aa9c53fb5440

2022-06-06 17:21 +0000 [1c5f023af9]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: delete scheduled notification on RLS update

	  If there is scheduled notification, we must delete it
	  to avoid using destroyed subscriptions.

	  ASTERISK-29906

	  Change-Id: I1c644e5e15a8fe43eed8e4f9112f113cbf87a40f

2022-06-07 08:48 +0000 [7480ebe9ea]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: XML sanitized RLS display name

	  ASTERISK-29891

	  Change-Id: Ic8c9697e616446e06e6302653eae902aa23372ad

2022-06-01 14:59 +0000 [0e96b76d01]  Christof Efkemann <christof@efkemann.net>

	* app_sayunixtime: Use correct inflection for German time.

	  In function ast_say_date_with_format_de(), take special
	  care when the hour is one o'clock. In this case, the
	  German number "eins" must be inflected to its neutrum form,
	  "ein". This is achieved by playing "digits/1N" instead of
	  "digits/1". Fixes both 12- and 24-hour formats.

	  ASTERISK-30092

	  Change-Id: Ica9b80125c0b317e378d89c1ea786816e2635510

2022-03-12 12:27 +0000 [b81fbbc6dc]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_outbound_registration: Make max random delay configurable.

	  Currently, PJSIP will randomly wait up to 10 seconds for each
	  outbound registration's initial attempt. The reason for this
	  is to avoid having all outbound registrations attempt to register
	  simultaneously.

	  This can create limitations with the test suite where we need to
	  be able to receive inbound calls potentially within 10 seconds of
	  starting up. For instance, we might register to another server
	  and then try to receive a call through the registration, but if
	  the registration hasn't happened yet, this will fail, and hence
	  this inconsistent behavior can cause tests to fail. Ultimately,
	  this requires a smaller random value because there may be no good
	  reason to wait for up to 10 seconds in these circumstances.

	  To address this, a new config option is introduced which makes this
	  maximum delay configurable. This allows, for instance, this to be
	  set to a very small value in test systems to ensure that registrations
	  happen immediately without an unnecessary delay, and can be used more
	  generally to control how "tight" the initial outbound registrations
	  are.

	  ASTERISK-29965 #close

	  Change-Id: Iab989a8e94323e645f3a21cbb6082287c7b2f3fd

2022-05-31 05:59 +0000 [c277fd02e0]  Naveen Albert <asterisk@phreaknet.org>

	* res_parking: Add music on hold override option.

	  An m option to Park and ParkAndAnnounce now allows
	  specifying a music on hold class override.

	  ASTERISK-30087

	  Change-Id: I03de8d97b100e451b2611b5a621d48750f5d6a9e

2022-05-31 20:43 +0000 [6ae9a5835e]  Naveen Albert <asterisk@phreaknet.org>

	* xmldocs: Improve examples.

	  Use example tags instead of regular para tags
	  where possible.

	  ASTERISK-30090

	  Change-Id: Iada8bbfda08f30b118cedf2d040bbb21e4966ec5

2022-05-16 08:01 +0000 [879a6a5997]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Prevent deadlock due to duplicate autoservice.

	  If a switch is invoked using chan_iax2, deadlock can result
	  because the PBX core is autoservicing the channel while chan_iax2
	  also then attempts to service it while waiting for the result
	  of the switch. This removes servicing of the channel to prevent
	  any conflicts.

	  ASTERISK-30064 #close

	  Change-Id: Ie92f206d32f9a36924af734ddde652b21106af22

2022-03-23 06:05 +0000 [d0d74d060b]  Naveen Albert <asterisk@phreaknet.org>

	* res_calendar: Prevent assertion if event ends in past.

	  res_calendar will trigger an assertion currently
	  if the ending time is calculated to be in the past.
	  Unlike the reminder and start times, however, there
	  is currently no check to catch non-positive times
	  and set them to 1. As a result, if we get a negative
	  value by happenstance, this can cause a crash.

	  To prevent the assertion from begin triggered, we now
	  use the same logic as the reminder and start events
	  to catch this issue before it can cause a problem.

	  ASTERISK-29981 #close

	  Change-Id: Idfb3204d195f350d2575fb4bc72a54a597d6e93c

2022-05-30 15:55 +0000 [89f3def351]  Naveen Albert <asterisk@phreaknet.org>

	* res_parking: Warn if out of bounds parking spot requested.

	  Emits a warning if the user has requested a parking spot that
	  is out of bounds for the requested parking lot.

	  ASTERISK-30086

	  Change-Id: I1080371e4f63e94724455003753014fbd3f95fbf

2022-05-03 07:44 +0000 [193688dd23]  Naveen Albert <asterisk@phreaknet.org>

	* loader: Prevent deadlock using tab completion.

	  If tab completion using ast_module_helper is attempted
	  during startup, deadlock will ensue because the CLI
	  will attempt to lock the module list while it is already
	  locked by the loader. This causes deadlock because when
	  the loader tries to acquire the CLI lock, they are blocked
	  on each other.

	  Waiting for startup to complete is not feasible because
	  the CLI lock is acquired while waiting, so deadlock will
	  ensure regardless of whether or not a lock on the module
	  list is attempted.

	  To prevent deadlock, we immediately abort if tab completion
	  is attempted on the module list before Asterisk is fully
	  booted.

	  ASTERISK-30039 #close

	  Change-Id: Idd468906c512bb196631e366a8f597a0e2e9271d

2022-05-19 09:23 +0000 [6e8e5e49af]  Maximilian Fridrich <m.fridrich@commend.com>

	* chan_pjsip: Only set default audio stream on hold.

	  When a PJSIP channel is set on hold or off hold, all streams were set
	  on/off hold. This is not the desired behaviour and caused issues
	  when there were multiple streams in the topology.

	  Now, only the default audio stream is set on/off hold when a hold is
	  indicated.

	  ASTERISK-30051

	  Change-Id: I04f1110565fd05fea565f5539b534b54549d4f71

2022-05-26 16:29 +0000 [fa84b4c692]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_dialog_info_body_generator: Set LOCAL target URI as local URI

	  The change "Add LOCAL/REMOTE tags in dialog-info+xml" set both "local"
	  Identity Element URI and Target Element URI to the same value -
	  the channel Caller Number.
	  For Identity Element it's ok to set as Caller ID.
	  But Local Target URI should be set as local URI.

	  In this case the Local Target URI can be used for Directed Call Pickup
	  by Polycom ip-phones (parameter useLocalTargetUriforLegacyPickup).

	  Also XML sanitized Display names.

	  ASTERISK-24601

	  Change-Id: If130a2f2f3b2339b14dca0ec0ebeea3a87b34343

2022-05-11 14:48 +0000 [1978732b8b]  Shloime Rosenblum <shloimerosenblum@gmail.com>

	* res_agi: Evaluate dialplan functions and variables in agi exec if enabled

	  Agi commnad exec can now evaluate dialplan functions and
	  variables if variable AGIEXECFULL is set to yes. this can
	  be useful when executing Playback or Read from agi.

	  ASTERISK-30058 #close

	  Change-Id: I669991f540496e7bddd096fec82b52c083036832

2022-05-17 12:01 +0000 [db824d8f6d]  Sean Bright <sean@seanbright.com>

	* ast_pkgconfig.m4: AST_PKG_CONFIG_CHECK() relies on sed.

	  Make sure that we have a working sed before trying to use it.

	  ASTERISK-30059 #close

	  Change-Id: I9abad67a5df11b665d480feec304ab9d6f55cc76

2022-04-25 17:40 +0000 [aaa14d3c7d]  Moritz Fain <moritz@fain.io>

	* ari: expose channel driver's unique id to ARI channel resource

	  This change exposes the channel driver's unique id (i.e. the Call-ID
	  for chan_sip/chan_pjsip based channels) to ARI channel resources
	  as `protocol_id`.

	  ASTERISK-30027
	  Reported by: Moritz Fain
	  Tested by: Moritz Fain

	  Change-Id: I7cc6e7a9d29efe74bc27811d788dac20fe559b87

2022-05-17 09:18 +0000 [91ab286086]  Sean Bright <sean@seanbright.com>

	* loader.c: Use portable printf conversion specifier for int64.

	  ASTERISK-30060 #close

	  Change-Id: I88d47a1488be2f39017b8d562f993f081844fcb8

2022-05-17 07:18 +0000 [c5c858287a]  Joshua C. Colp <jcolp@sangoma.com>

	* res_pjsip_transport_websocket: Also set the remote name.

	  As part of PJSIP 2.11 a behavior change was done to require
	  a matching remote hostname on an established transport for
	  secure transports. Since the Websocket transport is considered
	  a secure transport this caused the existing connection to not
	  be found and used.

	  We now set the remote hostname and the transport can be found.

	  ASTERISK-30065

	  Change-Id: Ia1cdef33e1411f927985b4b852c95e163c080e94

2022-04-29 11:42 +0000 [b0de067565]  Naveen Albert <asterisk@phreaknet.org>

	* app_confbridge: Add function to retrieve channels.

	  Adds the CONFBRIDGE_CHANNELS function which can be used
	  to retrieve a comma-separated list of channels, filtered
	  by a particular type of participant category. This output
	  can then be used with functions like UNSHIFT, SHIFT, POP,
	  etc.

	  ASTERISK-30036 #close

	  Change-Id: I1950aff932437476dc1abab6f47fb4ac90520b83

2022-05-04 10:37 +0000 [9f6bda1821]  Thomas Guebels <tgu@escaux.com>

	* res_pjsip_transport_websocket: save the original contact host

	  This is needed to be able to restore it in REGISTER responses,
	  otherwise the client won't be able to find the contact it created.

	  ASTERISK-30042

	  Change-Id: I0c5823918199acf09246b3b206fbde66773688f6

2022-01-07 10:25 +0000 [d5d3788648]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_outbound_registration: Show time until expiration

	  Adjusts the pjsip show registration(s) commands to show
	  the amount of seconds remaining until a registration
	  expires.

	  ASTERISK-29845 #close

	  Change-Id: Ic4fea15a1a1056c424416def49d1ca8e776c0483

2022-04-26 14:00 +0000 [8a041fab79]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Fix broken operator mode clearing.

	  Currently, the operator services mode in DAHDI is broken and unusable.
	  The actual operator recall functionality works properly; however,
	  when the operator hangs up (which is the only way that such a call
	  is allowed to end), both lines are permanently taken out of service
	  until "dahdi restart" is run. This prevents this feature from being
	  used.

	  Operator mode is one of the few factors that can cause the general
	  analog event handling in sig_analog not to be used. Several years
	  back, much of the analog handling was moved from chan_dahdi to
	  sig_analog. However, this was not done fully or consistently at
	  the time, and when operator mode is active, sig_analog does not
	  get used. Generally this is correct, but in the case of hangup
	  it should be using sig_analog regardless of the operator mode;
	  otherwise, the lines do not properly clear and they become unusable.

	  This bug is fixed so the operator can now hang up and properly
	  release the call. It is treated just like any other hangup. The
	  operator mode functionality continues to work as it did before.

	  ASTERISK-29993 #close

	  Change-Id: Ib2e3ddb40d9c71e8801e0b4bb0a12e2b52f51d24

2022-05-03 07:57 +0000 [ad6af63895]  George Joseph <gjoseph@digium.com>

	* GCC12: Fixes for 16+

	  Most issues were in stringfields and had to do with comparing
	  a pointer to an constant/interned string with NULL.  Since the
	  string was a constant, a pointer to it could never be NULL so
	  the comparison was always "true".  gcc now complains about that.

	  There were also a few issues where determining if there was
	  enough space for a memcpy or s(n)printf which were fixed
	  by defining some of the involved variables as "volatile".

	  There were also a few other miscellaneous fixes.

	  ASTERISK-30044

	  Change-Id: Ia081ca1bcfb329df6487c4660aaf1944309eb570

2022-05-04 13:00 +0000 [dfd2e4006b]  George Joseph <gjoseph@digium.com>

	* GCC12: Fixes for 18+.  state_id_by_topic comparing wrong value

	  GCC 12 caught an issue in state_id_by_topic where we were
	  checking a pointer for NULL instead of the contents of
	  the pointer for '\0'.

	  ASTERISK-30044

	  Change-Id: Ia0b04d4fff45c92acb7f07132a33622fa341148e

2022-05-05 14:28 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.12.0-rc1 Released.

2022-05-05 09:14 +0000 [efca7f4e8d]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.12.0
2022-04-29 03:47 +0000 [1e6991f95e]  Maximilian Fridrich <m.fridrich@commend.com>

	* core_unreal: Flip stream direction of second channel.

	  When a new unreal (local) channel is created, a second (;2) channel is
	  created as a counterpart which clones the topology of the first
	  channel. This creates issues when an outgoing stream is sendonly or
	  recvonly as the stream state of the inbound channel will be the same
	  as the stream state of the outbound channel.

	  Now the stream state is flipped for the streams of the 2nd channel in
	  ast_unreal_new_channels if the outgoing stream topology is recvonly or
	  sendonly.

	  ASTERISK-29655
	  Reported by: Michael Auracher

	  ASTERISK-29638
	  Reported by: Michael Auracher

	  Change-Id: I0cea29635bb20b7bf7fd0fb95498cd44dab98fbf

2022-03-27 07:33 +0000 [085f33b7a3]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Document dial resource options.

	  Documents the Dial syntax for DAHDI, namely the channel group,
	  distinctive ring, answer confirmation, and digital call options
	  that are specified in the resource itself.

	  ASTERISK-24827 #close

	  Change-Id: Ib95e78497fb00dc5cbfde1c93a69f034bfd08c30

2022-03-29 18:47 +0000 [a4f04666b5]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Don't allow MWI FSK if channel not idle.

	  For lines that have mailboxes configured on them, with
	  FSK MWI, DAHDI will periodically try to dispatch FSK
	  to update MWI. However, this is never supposed to be
	  done when a channel is not idle.

	  There is currently an edge case where MWI FSK can
	  extraneously get spooled for the channel if a caller
	  hook flashes and hangs up, which triggers a recall ring.
	  After one ring, the on hook time threshold in this if
	  condition has been satisfied and an MWI update is spooled.
	  This means that when the phone is picked up again, the
	  answerer gets an FSK spill before being reconnected to
	  the party on hold.

	  To prevent this, we now explicitly check to ensure that
	  subchannel 0 has no owner. There is no owner when DAHDI
	  channels are idle, but if the channel is "in use" in some
	  way (such as in the aforementioned scenario), then there
	  is an owner, and we shouldn't process MWI at this time.

	  ASTERISK-28518 #close

	  Change-Id: Ia3904434fd81688d71742f7e84358b7e1c38e92a

2022-02-23 10:29 +0000 [216a55408e]  Michael Cargile <mikec@vicidial.com>

	* apps/confbridge: Added hear_own_join_sound option to control who hears sound_join

	  Added the hear_own_join_sound option to the confbridge user profile to
	  control who hears the sound_join audio file. When set to 'yes' the user
	  entering the conference and the participants already in the conference
	  will hear the sound_join audio file. When set to 'no' the user entering
	  the conference will not hear the sound_join audio file, but the
	  participants already in the conference will hear the sound_join audio
	  file.

	  ASTERISK-29931
	  Added by Michael Cargile

	  Change-Id: I856bd66dc0dfa057323860a6418c1371d249abd2

2022-03-27 06:23 +0000 [cb53ad5671]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Don't append cadences on dahdi restart.

	  Currently, if any custom ring cadences are specified, they are
	  appended to the array of cadences from wherever we left off
	  last time. This works properly the first time, but on subsequent
	  dahdi restarts, it means that the existing cadences are left
	  alone and (most likely) the same cadences are then re-added
	  afterwards. In short order, the cadence array gets maxed out
	  and the user begins seeing warnings that the array is full
	  and no more cadences may be added.

	  This buggy behavior persists until Asterisk is completely
	  restarted; however, if and when dahdi restart is run again,
	  then the same problem is reintroduced.

	  This fixes this behavior so that cadence parsing is more
	  idempotent, that is so running dahdi restart multiple times
	  starts adding cadences from the beginning, rather than from
	  wherever the last cadence was added.

	  As before, it is still not possible to revert to the default
	  cadences by simply removing all cadences in this manner, nor
	  is it possible to delete existing cadences. However, this
	  does make it possible to update existing cadences, which
	  was not possible before, and also ensures that the cadences
	  remain unchanged if the config remains unchanged.

	  ASTERISK-29990 #close

	  Change-Id: Ie32ea3e8a243b766756b1afce684d4a31ee7421d

2022-04-02 16:22 +0000 [9dc321cbcb]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Prevent crash if dialing RSA-only call without outkey.

	  Currently, if attempting to place a call to a peer that only allows
	  RSA authentication, if we fail to provide an outkey when placing
	  the call, Asterisk will crash.

	  This exposes the broader issue that IAX2 is prone to causing a crash
	  if encryption or decryption is attempted but we never initialized
	  the encryption and decryption keys. In other words, if the logic
	  to use encryption in chan_iax2 is not perfectly aligned with the
	  decision to build keys in the first place, then a crash is not
	  only possible but probable. This was demonstrated by ASTERISK_29264,
	  for instance.

	  This permanently prevents such events from causing a crash by explicitly
	  checking that keys are initialized properly before setting the flags
	  to use encryption for the call. Instead of crashing, the call will
	  now abort.

	  ASTERISK-30007 #close

	  Change-Id: If925c3d86099ceac7f621804f2532baac5050c9a

2022-02-05 09:03 +0000 [b4c17c2044]  Naveen Albert <asterisk@phreaknet.org>

	* menuselect: Don't erroneously recompile modules.

	  A bug in menuselect can cause modules that are disabled
	  by default to be recompiled every time a recompilation
	  occurs. This occurs for module categories that are NOT
	  positive output, as for these categories, the modules
	  contained in the makeopts file indicate modules which
	  should NOT be selected. The existing procedure of iterating
	  through these modules to mark modules as present is thus
	  insufficient. This has led to modules with a default_enabled
	  tag of "no" to get deleted and recompiled every time, even
	  when they haven't changed.

	  To fix this, we now modify the mark as present behavior
	  for module categories that are not positive output. For
	  these, we start by iterating through the module tree
	  and marking all modules as present, then go back and
	  mark anything contained in the makeopts file as not
	  present. This ensures that makeopt selections are actually
	  used properly, regardless of whether a module category
	  uses positive output or not.

	  ASTERISK-29728 #close

	  Change-Id: Idf2974c4ed8d0ba3738a92f08a6082b234277b95

2022-03-31 10:44 +0000 [ff70b2aac6]  Naveen Albert <asterisk@phreaknet.org>

	* app_meetme: Don't erroneously set global variables.

	  The admin_exec function in app_meetme is used by the SLA
	  applications for internal bridging. However, in these cases,
	  chan is NULL. Currently, this function will set some status
	  variables that are intended for a channel, but since channel
	  is NULL, this is erroneously creating meaningless global
	  variables, which shouldn't be happening. This sets these
	  variables only if chan is not NULL.

	  ASTERISK-30002 #close

	  Change-Id: I817df6c26f5bda131678e56791b0b61ba64fc6f7

2022-03-14 20:41 +0000 [ce00f8758d]  Naveen Albert <asterisk@phreaknet.org>

	* func_db: Add function to return cardinality at prefix

	  Adds the DB_KEYCOUNT function, which can be used to retrieve
	  the number of keys at a given prefix in AstDB.

	  ASTERISK-29968 #close

	  Change-Id: Ib2393b77b7e962dbaae6192f8576bc3f6ba92d09

2022-03-29 19:22 +0000 [dd15cd049f]  Naveen Albert <asterisk@phreaknet.org>

	* chan_dahdi: Fix insufficient array size for round robin.

	  According to chan_dahdi.conf, up to 64 groups (numbered
	  0 through 63) can be used when dialing DAHDI channels.

	  However, currently dialing round robin with a group number
	  greater than 31 fails because the array for the round robin
	  structure is only size 32, instead of 64 as it should be.

	  This fixes that so the round robin array size is consistent
	  with the actual groups capacity.

	  ASTERISK-29994

	  Change-Id: I4caa08d7025f78ac75a0539f71aaf3eb3e85b3b7

2022-03-05 05:43 +0000 [09e989f972]  Naveen Albert <asterisk@phreaknet.org>

	* asterisk.c: Warn of incompatibilities with remote console.

	  Some command line options to Asterisk only apply when Asterisk
	  is started and cannot be used with remote console mode. If a
	  user tries to use any of these, they are currently simply
	  silently ignored.

	  This prints out a warning if incompatible options are used,
	  informing users that an option used cannot be used with remote
	  console mode. Additionally, some clarifications are added to
	  the help text and man page.

	  ASTERISK-22246
	  ASTERISK-26582

	  Change-Id: I980a5380ef2c19e8ea348596396d5382893c4337

2021-06-21 07:49 +0000 [79689d9df8]  Naveen Albert <asterisk@phreaknet.org>

	* func_evalexten: Extension evaluation function.

	  This adds the EVAL_EXTEN function, which may be used to retrieve
	  the variable-substituted data at any extension.

	  ASTERISK-29486

	  Change-Id: Iad81019689674c9f4ac77d235f5d7234adbb1432

2022-02-25 14:58 +0000 [4aac359d79]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Adds versioning information.

	  Adds version information for applications, functions,
	  and manager events/actions.

	  This is not completely exhaustive by any means but
	  covers most new things added that have release
	  versioning information in the issue tracker.

	  ASTERISK-29940 #close

	  Change-Id: I506401e93c799715dbbe97c0a8ba18af2bf5e131

2022-02-26 03:07 +0000 [bb2102a991]  Mark Petersen <bugs.digium.com@zombie.dk>

	* chan_sip.c Session timers get removed on UPDATE

	  If Asterisk receives a SIP REFER with Session-Timers UAC
	  maintain Session-Timers when sending UPDATE"

	  ASTERISK-29843

	  Change-Id: I8e9a21c13bf757fa34d778f49ba3cf859b29ae5c

2022-02-28 19:29 +0000 [ea02bc3685]  Naveen Albert <asterisk@phreaknet.org>

	* file.c: Prevent formats from seeking negative offsets.

	  Currently, if a user uses an application like ControlPlayback
	  to try to rewind a file past the beginning, this can throw
	  warnings when the file format (e.g. PCM) tries to seek to
	  a negative offset.

	  Instead of letting file formats try (and fail) to seek a
	  negative offset, we instead now catch this in the rewind
	  function to ensure that we never seek an offset less than 0.
	  This prevents legitimate user actions from triggering warnings
	  from any particular file formats.

	  ASTERISK-29943 #close

	  Change-Id: Ia53f2623f57898f4b8e5c894b968b01e95426967

2022-02-26 06:37 +0000 [8bc6d42a27]  Naveen Albert <asterisk@phreaknet.org>

	* chan_pjsip: Add ability to send flash events.

	  PJSIP currently is capable of receiving flash events
	  and converting them to FLASH control frames, but it
	  currently lacks support for doing the reverse: taking
	  a FLASH control frame and converting it into a flash
	  event in the SIP domain.

	  This adds the ability for PJSIP to process flash control
	  frames by converting them into the appropriate SIP INFO
	  message, which can then be sent to the peer. This allows,
	  for example, flash events to be sent between Asterisk
	  systems using PJSIP.

	  ASTERISK-29941 #close

	  Change-Id: I1590221a4d238597f79672fa5825dd4a920c94dd

2021-12-26 15:39 +0000 [3686a97d79]  Naveen Albert <asterisk@phreaknet.org>

	* cli: Add command to evaluate dialplan functions.

	  Adds the dialplan eval function commands to evaluate a dialplan
	  function from the CLI. The return value and function result are
	  printed out and can be used for testing or debugging.

	  ASTERISK-29820 #close

	  Change-Id: I833e97ea54c49336aca145330a2adeebfad05209

2022-03-07 08:11 +0000 [4f7e3d1609]  Mark Petersen <bugs.digium.com@zombie.dk>

	* chan_sip: SIP route header is missing on UPDATE

	  if Asterisk need to send an UPDATE before answer
	  on a channel that uses Record-Route:
	  it will not include a Route header

	  ASTERISK-29955

	  Change-Id: Id1920ecbfea7739a038b14dc94487ecfe7b57eef

2022-02-21 07:23 +0000 [16e59db514]  Mark Petersen <bugs.digium.com@zombie.dk>

	* chan_pjsip: add allow_sending_180_after_183 option

	  added new global config option "allow_sending_180_after_183"
	  that if enabled will preserve 180 after a 183

	  ASTERISK-29842

	  Change-Id: I8a53f8c35595b6d16d8e86e241b5f110d92f3d18

2022-04-25 18:39 +0000 [ae1373d12d]  Joshua C. Colp <jcolp@sangoma.com>

	* manager: Terminate session on write error.

	  On a write error to an AMI session a flag was set to
	  indicate that the write error had occurred, with the
	  expected result being that the session be terminated.
	  This was not actually happening and instead writing
	  would continue to be attempted.

	  This change adds a check for the write error and causes
	  the session to actually terminate.

	  ASTERISK-29948

	  Change-Id: Icaf5d413d4c0d5dc78292a17287fecc8720a31a5

2021-06-18 12:54 +0000 [2fb8667908]  Kevin Harwell <kharwell@sangoma.com>

	* res_aeap & res_speech_aeap: Add Asterisk External Application Protocol

	  Add framework to connect to, and read and write protocol based
	  messages from and to an external application using an Asterisk
	  External Application Protocol (AEAP). This has been divided into
	  several abstractions:

	   1. transport - base communication layer (currently websocket only)
	   2. message - AEAP description and data (currently JSON only)
	   3. transaction - links/binds requests and responses
	   4. aeap - transport, message, and transaction handler/manager

	  This patch also adds an AEAP implementation for speech to text.
	  Existing speech API callbacks for speech to text have been completed
	  making it possible for Asterisk to connect to a configured external
	  translator service and provide audio for STT. Results can also be
	  received from the external translator, and made available as speech
	  results in Asterisk.

	  Unit tests have also been created that test the AEAP framework, and
	  also the speech to text implementation.

	  ASTERISK-29726 #close

	  Change-Id: Iaa4b259f84aa63501e5fd2a6fb107f900b4d4ed2

2022-04-21 09:10 +0000 [6ac08fdcf8]  Yury Kirsanov <y.kirsanov@gmail.com>

	* bridge_simple.c: Unhold channels on join simple bridge.

	  Patch provided inline by Yury Kirsanov on the linked issue and
	  approved by Josh Colp.

	  ASTERISK-29253 #close

	  Change-Id: I5b9ccc67ebf06e875ed061d9e7fc21f47b0a4e1f

2021-03-29 12:28 +0000 [62f8e157fb]  Ben Ford <bford@digium.com>

	* res_aeap: Add basic config skeleton and CLI commands.

	  Added support for a basic AEAP configuration read from aeap.conf.
	  Also added 2 CLI commands for showing individual configurations as
	  well as all of them: aeap show server <id> and aeap show servers.

	  Only one configuration option is required at the moment, and that one is
	  server_url. It must be a websocket URL. The other option, codecs, is
	  optional and will be used over the codecs specified on the endpoint if
	  provided.

	  https://wiki.asterisk.org/wiki/pages/viewpage.action?pageId=45482453

	  Change-Id: I567ac5148c92b98d29d2ad83421b416b75ffdaa3
	  (cherry picked from commit 45a1977de49f56de5875a2cde951780de146762d)

2022-04-06 05:23 +0000 [09e8667fa5]  Joshua C. Colp <jcolp@sangoma.com>

	* res_pjsip: Always set async_operations to 1.

	  The async_operations setting on a transport configures how
	  many simultaneous incoming packets the transport can handle
	  when multiple threads are polling and waiting on the transport.
	  As we only use a single thread this was needlessly creating
	  incoming packets when set to a non-default value, wasting memory.

	  ASTERISK-30006

	  Change-Id: I1915973ef352862dc2852a6ba4cfce2ed536e68f

2022-04-21 10:26 +0000 [40f4268f2d]  Ben Ford <bford@digium.com>

	* res_pjsip_stir_shaken.c: Fix enabled when not configured.

	  There was an issue with the conditional where STIR/SHAKEN would be
	  enabled even when not configured. It has been changed to ensure that if
	  a profile does not exist and stir_shaken is not set in pjsip.conf, then
	  the conditional will return from the function without performing
	  STIR/SHAKEN operations.

	  ASTERISK-30024

	  Change-Id: I41286a3d35b033ccbfbe4129427a62cb793a86e6

2022-04-13 08:12 +0000 [37829b4461]  Maximilian Fridrich <m.fridrich@commend.com>

	* app_dial: Flip stream direction of outgoing channel.

	  When executing dial, the topology of the incoming channel is cloned and
	  used for the outgoing channel. This creates issues when an incoming
	  stream is sendonly or recvonly as the stream state of the outgoing
	  channel will be the same as the stream state of the incoming channel.

	  Now the stream state is flipped for the outgoing stream in
	  dial_exec_full if the incoming stream topology is recvonly or sendonly.

	  ASTERISK-29655
	  Reported by: Michael Auracher

	  ASTERISK-29638
	  Reported by: Michael Auracher

	  Change-Id: I294dc834ac9a5f048b101b691669959e9df630e1

2022-04-19 10:36 +0000 [2587e58e05]  Sean Bright <sean.bright@gmail.com>

	* config.h: Don't use C++ keywords as argument names.

	  ASTERISK-30021 #close

	  Change-Id: I70eb59b782a4946b979942e21422746b7563029c

2022-04-20 07:40 +0000 [ec8ab44b7f]  Joshua C. Colp <jcolp@sangoma.com>

	* cdr_adaptive_odbc: Add support for SQL_DATETIME field type.

	  ASTERISK-30023

	  Change-Id: I0e1697f6af044e9eab7e07bbaeeffd1bb68ac34a

2022-04-11 04:30 +0000 [8500210611]  Joshua C. Colp <jcolp@sangoma.com>

	* pjsip: Increase maximum number of format attributes.

	  Chrome has added more attributes, causing the limit to be
	  exceeded. This raises it up some more.

	  ASTERISK-30015

	  Change-Id: I964957c005c4e6f7871b15ea1ccd9b4659c7ef32

2022-04-14 15:47 +0000 [801317ae05]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.11.2
2022-03-17 10:23 +0000 [f325cb3d13]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.11.0
2022-02-28 11:19 +0000 [11accf8064]  Ben Ford <bford@digium.com>

	* AST-2022-002 - res_stir_shaken/curl: Add ACL checks for Identity header.

	  Adds a new configuration option, stir_shaken_profile, in pjsip.conf that
	  can be specified on a per endpoint basis. This option will reference a
	  stir_shaken_profile that can be configured in stir_shaken.conf. The type
	  of this option must be 'profile'. The stir_shaken option can be
	  specified on this object with the same values as before (attest, verify,
	  on), but it cannot be off since having the profile itself implies wanting
	  STIR/SHAKEN support. You can also specify an ACL from acl.conf (along
	  with permit and deny lines in the object itself) that will be used to
	  limit what interfaces Asterisk will attempt to retrieve information from
	  when reading the Identity header.

	  ASTERISK-29476

	  Change-Id: I87fa61f78a9ea0cd42530691a30da3c781842406

2022-02-10 06:02 +0000 [39cd09c246]  Joshua C. Colp <jcolp@sangoma.com>

	* func_odbc: Add SQL_ESC_BACKSLASHES dialplan function.

	  Some databases depending on their configuration using backslashes
	  for escaping. When combined with the use of ' this can result in
	  a broken func_odbc query.

	  This change adds a SQL_ESC_BACKSLASHES dialplan function which can
	  be used to escape the backslashes.

	  This is done as a dialplan function instead of being always done
	  as some databases do not require this, and always doing it would
	  result in incorrect data being put into the database.

	  ASTERISK-29838

	  Change-Id: I152bf34899b96ddb09cca3e767254d8d78f0c83d

2022-01-07 08:50 +0000 [33091c2659]  Ben Ford <bford@digium.com>

	* AST-2022-001 - res_stir_shaken/curl: Limit file size and check start.

	  Put checks in place to limit how much we will actually download, as well
	  as a check for the data we receive at the start to ensure it begins with
	  what we would expect a certificate to begin with.

	  ASTERISK-29872

	  Change-Id: Ifd3c6b8bd52b8b6192a04166ccce4fc8a8000b46

2022-03-04 19:41 +0000 [9024bb989b]  Naveen Albert <asterisk@phreaknet.org>

	* app_mf, app_sf: Return -1 if channel hangs up.

	  The ReceiveMF and ReceiveSF applications currently always
	  return 0, even if a channel has hung up. The call will still
	  end but generally applications are expected to return -1 if
	  the channel has hung up.

	  We now return -1 if a hangup occured to bring this behavior
	  in line with this norm. This has no functional impact, but
	  merely increases conformity with how these modules interact
	  with the PBX core.

	  ASTERISK-29951 #close

	  Change-Id: I234d755050ab8ed58f197c6925b968ba26b14033

2022-01-22 09:53 +0000 [b7edc08e33]  Naveen Albert <asterisk@phreaknet.org>

	* app_queue: Add music on hold option to Queue.

	  Adds the m option to the Queue application, which allows a
	  music on hold class to be specified at runtime which will
	  override the class configured in queues.conf.

	  This option functions like the m option to Dial.

	  ASTERISK-29876 #close

	  Change-Id: Ie25a48569cf8755c305c9438b1ed292c3adcf8d7

2022-03-05 09:40 +0000 [b2d5bd4cb8]  Naveen Albert <asterisk@phreaknet.org>

	* app_meetme: Emit warning if conference not found.

	  Currently, if a user tries to access a non-dynamic
	  MeetMe conference and the conference is not found,
	  the call simply silent hangs up. There is no indication
	  to the user that anything went wrong at all.

	  This changes the relevant debug message to a warning
	  so that the user is notified of this invalidity.

	  ASTERISK-29954 #close

	  Change-Id: Iebcfae3755d00f2150d676ee211c57bc59530048

2022-02-22 14:51 +0000 [82dbfe7783]  Boris P. Korzun <drtr0jan@yandex.ru>

	* res_pjsip_sdp_rtp: Improve detecting of lack of RTP activity

	  Change RTP timer behavior for detecting RTP only after two-way
	  SDP channel establishment. Ignore detecting after receiving 183
	  with SDP or while direct media is used.
	  Make rtp_timeout and rtp_timeout_hold options consistent to rtptimeout
	  and rtpholdtimeout options in chan_sip.

	  ASTERISK-26689 #close
	  ASTERISK-29929 #close

	  Change-Id: I07326d5b9c40f25db717fd6075f6f3a8d77279eb

2022-02-24 11:48 +0000 [e5e02f783d]  Joshua C. Colp <jcolp@sangoma.com>

	* pjproject: Update bundled to 2.12 release.

	  This change removes patches which have been merged into
	  upstream and updates some existing ones. It also adds
	  some additional config_site.h changes to restore previous
	  behavior, as well as a patch to allow multiple Authorization
	  headers. There seems to be some confusion or disagreement
	  on language in RFC 8760 in regards to whether multiple
	  Authorization headers are supported. The RFC implies it
	  is allowed, as does some past sipcore discussion. There is
	  also the catch all of "local policy" to allow it. In
	  the case of Asterisk we allow it.

	  ASTERISK-29351

	  Change-Id: Id39ece02dedb7b9f739e0e37ea47d76854af7191

2022-03-23 17:45 +0000 [ec5b449bcf]  Kevin Harwell <kharwell@sangoma.com>

	* res_pjsip_header_funcs: wrong pool used tdata headers

	  When adding headers to an outgoing request the headers were cloned using
	  the dialog's pool when they should have been cloned using tdata's pool.
	  Under certain circumstances it was possible for the dialog object, and
	  its pool to be freed while tdata is still active and available. Thus the
	  cloned header "disappeared", and when tdata tried to later access it a
	  crash would occur.

	  This patch makes it so all added headers are cloned appropriately using
	  tdata's pool.

	  ASTERISK-29411 #close
	  ASTERISK-29535 #close

	  Change-Id: I9852025b5ee93ce1c038209150ee9dba1e0767c5

2022-03-05 10:26 +0000 [bd69639a6b]  Naveen Albert <asterisk@phreaknet.org>

	* pbx.c: Warn if there are too many includes in a context.

	  The PBX core uses the stack when it comes to includes, which
	  means that a context can only contain strictly fewer than
	  AST_PBX_MAX_STACK includes. If this is exceeded, then warnings
	  will be emitted for each number of includes beyond this if
	  searching for an extension in the including context, and if
	  the extension's inclusion is beyond the stack size, it will
	  simply not be found.

	  To address this, we now check if there are too many includes
	  in a context when the dialplan is reloaded so that if there
	  is an issue, the user is aware of at "compile time" as opposed
	  to "run time" only. Secondly, more details are printed out
	  when this message is encountered so it's clear what has happened.

	  ASTERISK-26719

	  Change-Id: Ia3700452e75a7af3391b3e82ee69f06a669f8958

2022-03-25 09:33 +0000 [dd704bbba5]  George Joseph <gjoseph@digium.com>

	* make_xml_documentation: Remove usage of get_sourceable_makeopts

	  get_sourceable_makeopts wasn't handling variables with embedded
	  double quotes in them very well.  One example was the DOWNLOAD
	  variable when curl was being used instead of wget.  Rather than
	  trying to fix get_sourceable_makeopts, it's just been removed.

	  ASTERISK-29986
	  Reported by: Stefan Ruijsenaars

	  Change-Id: Idf2a90902228c2558daa5be7a4f8327556099cd2

2022-03-25 14:00 +0000 [2d3297d4f3]  George Joseph <gjoseph@digium.com>

	* Makefile:  Disable XML doc validation

	  make_xml_documentation was being called with the --validate
	  flag set when it shouldn't have been.  This was causing
	  build failures if neither xmllint nor xmlstarlet were installed.
	  The correct behavior is to simply print a message that either
	  one of those tools should be installed for validation and
	  continue with the build.

	  ASTERISK-29988

	  Change-Id: Idc6c44114e7dd3fadae183a4e22f4fdba0b8a645

2022-02-04 18:36 +0000 [d9e55250dd]  Birger Harzenetter (license 5870)

	* chan_iax2: Fix spacing in netstats command

	  The iax2 show netstats command previously didn't contain
	  enough spacing in the header to properly align the table
	  header with the table body. This caused column headers
	  to not align with the values on longer channel names.

	  Some spacing is added to account for the longest channel
	  names that display (before truncation occurs) so that
	  columns are always properly aligned.

	  ASTERISK-29895 #close
	  patches:
	    61205_misaligned2.patch submitted by Birger Harzenetter (license 5870)

	  Change-Id: I450ce6bb81157b9d6d149007e53b749f237b6d9f

2022-03-23 16:04 +0000 [a893fdd901]  Marcel Wagner <mwagner@sipgate.de>

	* documentation: Add information on running install_prereq script in readme

	  Adding information in the readme about running the install_preqreq script to install components that the ./configure script might indicate as missing.

	  ASTERISK-29976 #close

	  Change-Id: Ic287b46300168729838bddd8f9265e98fc22bce6

2022-03-25 08:19 +0000 [777e9fde67]  Sean Bright <sean.bright@gmail.com>

	* openssl: Supress deprecation warnings from OpenSSL 3.0

	  There is work going on to update our OpenSSL usage to avoid the
	  deprecated functions but in the meantime make it possible to compile
	  in devmode.

	  Change-Id: Ib082eb8b3751f0185d8aa8fe127da664c93f0726

2022-02-25 11:01 +0000 [dc129b6951]  Naveen Albert <asterisk@phreaknet.org>

	* res_agi: Fix xmldocs bug with set music.

	  The XML documentation for the SET MUSIC AGI
	  command is invalid, as the parameter does not
	  have a name and the on/off enum options for
	  the on/off argument are listed separately, which
	  is incorrect. The cumulative effect of these currently
	  is that the Asterisk Wiki documentation for SET MUSIC
	  is broken and external documentation generators crash
	  on SET MUSIC due to the malformed documentation.

	  These issues are corrected so that the documentation
	  can be successfully parsed as with other similar AGI
	  commands.

	  ASTERISK-29939 #close
	  ASTERISK-28891 #close

	  Change-Id: I8c3d59897531bcbc401cbc7b00c9e2829dcb35f8
	  (cherry picked from commit 37ece75677bff5655f0a3fb4dbda2b7c4847bc50)

2022-03-13 12:46 +0000 [97c499ee34]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Fix perceived showing host address.

	  ASTERISK_22025 introduced a regression that shows
	  the host IP and port as the perceived IP and port
	  again, as opposed to showing the actual perceived
	  address. This fixes this by showing the correct
	  information.

	  ASTERISK-29048 #close

	  Change-Id: I0ad3e25bc6b449e83ce72ea5d1a1cdba72aa304a

2022-03-15 06:56 +0000 [b678624f04]  Hugh McMaster <hugh.mcmaster@outlook.com>

	* configure.ac: Use pkg-config to detect libxml2

	  Use pkg-config to detect libxml2, falling back to xml2-config if the
	  former is not available.

	  This patch ensures Asterisk continues to build on systems without
	  xml2-config installed.

	  The patch also updates the associated 'configure' files.

	  ASTERISK-29970 #close

	  Change-Id: I3c90dfe0b0590486cbb8e6d426a7c5c4199410c0

2022-02-13 13:06 +0000 [f50e793665]  Philip Prindeville <philipp@redfish-solutions.com>

	* time: add support for time64 libcs

	  Treat time_t's as entirely unique and use the POSIX API's for
	  converting to/from strings.

	  Lastly, a 64-bit integer formats as 20 digits at most in base10.
	  Don't need to have any 100 byte buffers to hold that.

	  ASTERISK-29674 #close

	  Signed-off-by: Philip Prindeville <philipp@redfish-solutions.com>
	  Change-Id: Id7b25bdca8f92e34229f6454f6c3e500f2cd6f56

2022-03-15 12:24 +0000 [96a3ff9edd]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: RLS 'uri' list attribute mismatch with SUBSCRIBE request

	  When asterisk generates the RLMI part of NOTIFY request,
	  the asterisk uses the local contact uri instead of the URI to which
	  the SUBSCRIBE request is sent.
	  Because of this mismatch some IP phones (for example Cisco 5XX) ignore
	  this list.

	  According
	  https://datatracker.ietf.org/doc/html/rfc4662#section-5.2
	    The first mandatory <list> attribute is "uri", which contains the uri
	    that corresponds to the list. Typically, this is the URI to which
	    the SUBSCRIBE request was sent.
	  https://datatracker.ietf.org/doc/html/rfc4662#section-5.3
	    The "uri" attribute identifies the resource to which the <resource>
	    element corresponds. Typically, this will be a SIP URI that, if
	    subscribed to, would return the state of the resource.

	  This patch makes asterisk to generate URI using SUBSCRIBE request URI.

	  ASTERISK-29961 #close

	  Change-Id: I1fcfc08fd589677f40608c59a4e143c45ee05f6c

2022-02-21 19:05 +0000 [140c19c206]  Philip Prindeville <philipp@redfish-solutions.com>

	* logger: workaround woefully small BUFSIZ in MUSL

	  MUSL defines BUFSIZ as 1024 which is not reasonable for log messages.

	  More broadly, BUFSIZ is the amount of buffering stdio.h does, which
	  is arbitrary and largely orthogonal to what logging should accept
	  as the maximum message size.

	  ASTERISK-29928

	  Signed-off-by: Philip Prindeville <philipp@redfish-solutions.com>
	  Change-Id: Iaa49fbbab029c64ae3d95e4b18270e0442cce170

2022-03-10 11:07 +0000 [3a7d83087b]  Sean Bright <sean.bright@gmail.com>

	* stasis_recording: Perform a complete match on requested filename.

	  Using the length of a file found on the filesystem rather than the
	  file being requested could result in filenames whose names are
	  substrings of another to be erroneously matched.

	  We now ensure a complete comparison before returning a positive
	  result.

	  ASTERISK-29960 #close

	  Change-Id: Id3ffc77681b9b75b8569062f3d952a128a21c71a

2022-03-22 09:01 +0000 [2b636f3766]  Sean Bright <sean.bright@gmail.com>

	* download_externals: Use HTTPS for downloads

	  ASTERISK-29980 #close

	  Change-Id: I7b347665822ea2774dd322276c09be67914d2065

2022-03-04 14:26 +0000 [81a990b8d2]  Sean Bright <sean.bright@gmail.com>

	* conversions.c: Specify that we only want to parse decimal numbers.

	  Passing 0 as the last argument to strtoimax() or strtoumax() causes
	  octal and hexadecimal to be accepted which was not originally
	  intended. So we now force to only accept decimal.

	  ASTERISK-29950 #close

	  Change-Id: I93baf0f273441e8280354630a463df263a8c0edd

2022-03-05 06:04 +0000 [a66b6647b2]  Naveen Albert <asterisk@phreaknet.org>

	* app_dial: Document DIALSTATUS return values.

	  Adds documentation for all of the possible return values
	  for the DIALSTATUS variable in the Dial application.

	  ASTERISK-25716

	  Change-Id: Id22593f1f1f7ea86e5734cee49516ec50848e8c0

2022-03-14 11:57 +0000 [b407511f02]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_builtins: Add missing options documentation

	  BackGround and WaitExten both accept options that are not
	  currently documented. This adds documentation for these
	  options to the xml documentation for each application.

	  ASTERISK-29967 #close

	  Change-Id: If812a9f1ccbba3e4d427a0e7a6dea923c2f905f7

2022-03-17 15:40 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.11.0-rc1 Released.

2022-03-17 10:23 +0000 [5dd61a6e16]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.11.0
2022-03-17 09:19 +0000 [81de525c6e]  Ben Ford <bford@digium.com>

	* AMI: Bump version for 18.11.0.

	  Change-Id: Ic15cfca9e68efd06a1b12ab2335d52a5890e7170

2022-02-18 03:19 +0000 [5b653b8a7b]  Boris P. Korzun <drtr0jan@yandex.ru>

	* res_config_pgsql: Add text-type column check in require_pgsql()

	  Omit "unsupported column type 'text'" warning in logs while
	  using text-type column in the PgSQL backend.

	  ASTERISK-29924 #close

	  Change-Id: I48061a7d469426859670db07f1ed8af1eb814712

2022-02-09 04:28 +0000 [3959d20ba5]  Kfir Itzhak <mastertheknife@gmail.com>

	* app_queue: Add QueueWithdrawCaller AMI action

	  This adds a new AMI action called QueueWithdrawCaller.
	  This AMI action makes it possible to withdraw a caller from a queue,
	  in a safe and a generic manner.
	  This can be useful for retrieving a specific call and
	  dispatching it to a specific extension.
	  It works by signaling the caller to exit the queue application
	  whenever it can. Therefore, it is not guaranteed
	  that the call will leave the queue.

	  ASTERISK-29909 #close

	  Change-Id: Ic15aa238e23b2884abdcaadff2fda7679e29b7ec

2022-02-08 16:58 +0000 [8666455bd8]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: update RLS to reflect the changes to the lists

	  This patch makes the Resource List Subscriptions (RLS) dynamic.
	  The asterisk updates the current subscriptions to reflect the changes
	  to the list on the subscriptions refresh. If list items are added,
	  removed, updated or do not exist anymore, the asterisk regenerates
	  the resource list.

	  ASTERISK-29906 #close

	  Change-Id: Icee8c00459a7aaa43c643d77ce6f16fb7ab037d3

2022-03-03 16:44 +0000 [9e74563a50]  Kevin Harwell <kharwell@sangoma.com>

	* AST-2022-006: pjproject - unconstrained malformed multipart SIP message

	  ASTERISK-29945 #close

	  Change-Id: Ic58957afc453195d53c2bd25c905df3d91d1abe6

2022-03-03 16:42 +0000 [742d265ff5]  Kevin Harwell <kharwell@sangoma.com>

	* AST-2022-005: pjproject - undefined behavior after freeing a dialog set

	  ASTERISK-29945 #close

	  Change-Id: Ia8ce6d82b115c82c1138747c72a0adcaa42b718c

2022-03-03 16:41 +0000 [fc160abb67]  Kevin Harwell <kharwell@sangoma.com>

	* AST-2022-004: pjproject - possible integer underflow on STUN message

	  ASTERISK-29945 #close

	  Change-Id: I721cd254e4f8aa6d3a97a37529cca53519694c54

2022-03-02 08:57 +0000 [b6e482becd]  George Joseph <gjoseph@digium.com>

	* xml.c, config,c:  Add stylesheets and variable list string parsing

	  Added functions to open, close, and apply XML Stylesheets
	  to XML documents.  Although the presence of libxslt was already
	  being checked by configure, it was only happening if xmldoc was
	  enabled.  Now it's checked regardless.

	  Added ability to parse a string consisting of comma separated
	  name/value pairs into an ast_variable list.  The reverse of
	  ast_variable_list_join().

	  Change-Id: I1e1d149be22165a1fb8e88e2903a36bba1a6cf2e

2022-03-01 10:58 +0000 [468441121d]  George Joseph <gjoseph@digium.com>

	* xmldoc: Fix issue with xmlstarlet validation

	  Added the missing xml-stylesheet and Xinclude namespace
	  declarations in pjsip_config.xml and pjsip_manager.xml.

	  Updated make_xml_documentation to show detailed errors when
	  xmlstarlet is the validator.  It's now run once with the '-q'
	  option to suppress harmless/expected messages and if it actually
	  fails, it's run again without '-q' but with '-e' to show
	  the actual errors.

	  Change-Id: I4bdc9d2ea6741e8d2e5eb82df60c68ccc59e1f5e

2022-02-20 14:16 +0000 [777326fa9e]  George Joseph <gjoseph@digium.com>

	* core: Config and XML tweaks needed for geolocation

	  Added:

	  Replace a variable in a list:
	  int ast_variable_list_replace_variable(struct ast_variable **head,
	      struct ast_variable *old, struct ast_variable *new);
	  Added test as well.

	  Create a "name=value" string from a variable list:
	  'name1="val1",name2="val2"', etc.
	  struct ast_str *ast_variable_list_join(
	      const struct ast_variable *head, const char *item_separator,
	      const char *name_value_separator, const char *quote_char,
	      struct ast_str **str);
	  Added test as well.

	  Allow the name of an XML element to be changed.
	  void ast_xml_set_name(struct ast_xml_node *node, const char *name);

	  Change-Id: I330a5f63dc0c218e0d8dfc0745948d2812141ccb

2022-02-14 07:31 +0000 [a81e14d2da]  George Joseph <gjoseph@digium.com>

	* Makefile: Allow XML documentation to exist outside source files

	  Moved the xmldoc build logic from the top-level Makefile into
	  its own script "make_xml_documentation" in the build_tools
	  directory.

	  Created a new utility script "get_sourceable_makeopts", also in
	  the build_tools directory, that dumps the top-level "makeopts"
	  file in a format that can be "sourced" from shell sscripts.
	  This allows scripts to easily get the values of common make
	  build variables such as the location of the GREP, SED, AWK, etc.
	  utilities as well as the AST* and library *_LIB and *_INCLUDE
	  variables.

	  Besides moving logic out of the Makefile, some optimizations
	  were done like removing "third-party" from the list of
	  subdirectories to be searched for documentation and changing some
	  assignments from "=" to ":=" so they're only evaluated once.
	  The speed increase is noticeable.

	  The makeopts.in file was updated to include the paths to
	  REALPATH and DIRNAME.  The ./conifgure script was setting them
	  but makeopts.in wasn't including them.

	  So...

	  With this change, you can now place documentation in any"c"
	  source file AND you can now place it in a separate XML file
	  altogether.  The following are examples of valid locations:

	  res/res_pjsip.c
	      Using the existing /*** DOCUMENTATION ***/ fragment.

	  res/res_pjsip/pjsip_configuration.c
	      Using the existing /*** DOCUMENTATION ***/ fragment.

	  res/res_pjsip/pjsip_doc.xml
	      A fully-formed XML file.  The "configInfo", "manager",
	      "managerEvent", etc. elements that would be in the "c"
	      file DOCUMENTATION fragment should be wrapped in proper
	      XML.  Example for "somemodule.xml":

	      <?xml version="1.0" encoding="UTF-8"?>
	      <!DOCTYPE docs SYSTEM "appdocsxml.dtd">
	      <docs>
	          <configInfo>
	          ...
	          </configInfo>
	      </docs>

	  It's the "appdocsxml.dtd" that tells make_xml_documentation
	  that this is a documentation XML file and not some other XML file.
	  It also allows many XML-capable editors to do formatting and
	  validation.

	  Other than the ".xml" suffix, the name of the file is not
	  significant.

	  As a start... This change also moves the documentation that was
	  in res_pjsip.c to 2 new XML files in res/res_pjsip:
	  pjsip_config.xml and pjsip_manager.xml.  This cut the number of
	  lines in res_pjsip.c in half. :)

	  Change-Id: I486c16c0b5a44d7a8870008e10c941fb19b71ade

2022-02-17 10:26 +0000 [47106a09b0]  George Joseph <gjoseph@digium.com>

	* build: Refactor the earlier "basebranch" commit

	  Recap from earlier commit:  If you have a development branch for a
	  major project that will receive gerrit reviews it'll probably be
	  named something like "development/16/newproject" or a work branch
	  based on that "development" branch.  That will necessitate
	  setting "defaultbranch=development/16/newproject" in .gitreview.
	  The make_version script uses that variable to construct the
	  asterisk version however, which results in versions
	  like "GIT-development/16/newproject-ee582a8c7b" which is probably
	  not what you want.  It also constructs the URLs for downloading
	  external modules with that version, which will fail.

	  Fast-forward:

	  The earlier attempt at adding a "basebranch" variable to
	  .gitreview didn't work out too well in practice because changes
	  were made to .gitreview, which is a checked-in file.  So, if
	  you wanted to rebase your work branch on the base branch, rebase
	  would attempt to overwrite your .gitreview with the one from
	  the base branch and complain about a conflict.

	  This is a slighltly different approach that adds three methods to
	  determine the mainline branch:

	  1.  --- MAINLINE_BRANCH from the environment

	  If MAINLINE_BRANCH is already set in the environment, that will
	  be used.  This is primarily for the Jenkins jobs.

	  2.  --- .develvars

	  Instead of storing the basebranch in .gitreview, it can now be
	  stored in a non-checked-in ".develvars" file and keyed by the
	  current branch.  So, if you were working on a branch named
	  "new-feature-work" based on "development/16/new-feature" and wanted
	   to push to that branch in Gerrit but wanted to pull the external
	   modules for 16, you'd create the following .develvars file:

	  [branch "new-feature-work"]
	      mainline-branch = 16

	  The .gitreview file would still look like:

	  [gerrit]
	  defaultbranch=development/16/new-feature

	  ...which would cause any reviews pushed from "new-feature-work" to
	  go to the "development/16/new-feature" branch in Gerrit.

	  The key is that the .develvars file is NEVER checked in (it's been
	  added to .gitignore).

	  3.  --- Well Known Development Branch

	  If you're actually working in a branch named like
	  "development/<mainline_branch>/some-feature", the mainline branch
	  will be parsed from it.

	  4.  --- .gitreview

	  If none of the earlier conditions exist, the .gitreview
	  "defaultbranch" variable will be used just as before.

	  Change-Id: I1cdeeaa0944bba3f2e01d7a2039559d0c266f8c9

2022-02-23 07:58 +0000 [3771074a45]  Joshua C. Colp <jcolp@sangoma.com>

	* jansson: Update bundled to 2.14 version.

	  ASTERISK-29353

	  Change-Id: I4ea43eda1691565563a4c03ef37166952d211b2b

2022-01-09 07:32 +0000 [59b25e9d59]  Naveen Albert <asterisk@phreaknet.org>

	* ami: Allow events to be globally disabled.

	  The disabledevents setting has been added to the general section
	  in manager.conf, which allows users to specify events that
	  should be globally disabled and not sent to any AMI listeners.

	  This allows for processing of these AMI events to end sooner and,
	  for frequent AMI events such as Newexten which users may not have
	  any need for, allows them to not be processed. Additionally, it also
	  cleans up core debug as previously when debug was 3 or higher,
	  the debug was constantly spammed by "Analyzing AMI event" messages
	  along with a complete dump of the event contents (often for Newexten).

	  ASTERISK-29853 #close

	  Change-Id: Id42b9a3722a1f460d745cad1ebc47c537fd4f205

2022-01-06 07:57 +0000 [42525b0fe2]  Naveen Albert <asterisk@phreaknet.org>

	* func_channel: Add lastcontext and lastexten.

	  Adds the lastcontext and lastexten channel fields to allow users
	  to access previous dialplan execution locations.

	  ASTERISK-29840 #close

	  Change-Id: Ib455fe300cc8e9a127686896ee2d0bd11e900307

2022-02-04 19:27 +0000 [7f123b3143]  Naveen Albert <asterisk@phreaknet.org>

	* channel.c: Clean up debug level 1.

	  Although there are 10 debugs levels, over time,
	  many current debug calls have come to use
	  inappropriately low debug levels. In particular,
	  a select few debug calls (currently all debug 1)
	  can result in thousands of debug messages per minute
	  for a single call.

	  This can adds a lot of noise to core debug
	  which dilutes the value in having different
	  debug levels in the first place, as these
	  log messages are from the core internals are
	  are better suited for higher debug levels.

	  Some debugs levels are thus adjusted so that
	  debug level 1 is not inappropriately overloaded
	  with these extremely high-volume and general
	  debug messages.

	  ASTERISK-29897 #close

	  Change-Id: I55a71598993552d3d64a401a35ee99474770d4b4

2022-02-17 13:47 +0000 [8631e00a41]  Naveen Albert <asterisk@phreaknet.org>

	* configs, LICENSE: remove pbx.digium.com.

	  pbx.digium.com no longer accepts IAX2 calls and
	  there are no plans for it to come back.

	  Accordingly, nonworking IAX2 URIs are removed from
	  both the LICENSE file and the sample config.

	  ASTERISK-29923 #close

	  Change-Id: I257c54d4d812ed6b4bd4cbec2cd7ebe2b87b5bad

2022-02-04 19:11 +0000 [3499aea882]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Add since tag to xmldocs DTD

	  Adds the since tag to the documentation DTD so
	  that individual applications, functions, etc.
	  can now specify when they were added to Asterisk.

	  This tag is added at the individual application,
	  function, etc. level as opposed to at the module
	  level because modules can expand over time as new
	  functionality is added, and granularity only
	  to the module level would generally not be useful.

	  This enables the ability to more easily determine
	  when new functionality was added to Asterisk, down
	  to minor version as opposed to just by major version.
	  This makes it easier for users to write more portable
	  dialplan if desired to not use functionality that may
	  not be widely available yet.

	  ASTERISK-29896 #close

	  Change-Id: Ibbb35c702d8038bdc3fd0a944fbfa69384cc15d5

2022-01-13 08:37 +0000 [63db7505f2]  Naveen Albert <asterisk@phreaknet.org>

	* asterisk: Add macro for curl user agent.

	  Currently, each module that uses libcurl duplicates the standard
	  Asterisk curl user agent.

	  This adds a global macro for the Asterisk user agent used for
	  curl requests to eliminate this duplication.

	  ASTERISK-29861 #close

	  Change-Id: I9fc37935980384b4daf96ae54fa3c9adb962ed2d

2021-12-16 13:41 +0000 [74742cdb5e]  Naveen Albert <asterisk@phreaknet.org>

	* res_stir_shaken: refactor utility function

	  Refactors temp file utility function into file.c.

	  ASTERISK-29809 #close

	  Change-Id: Ife478708c8f2b127239cb73c1755ef18c0bf431b

2022-02-16 05:34 +0000 [2016b33139]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail: Emit warning if asking for nonexistent mailbox.

	  Currently, if VoiceMailMain is called with a mailbox, if that
	  mailbox doesn't exist, then the application silently falls back
	  to prompting the user for the mailbox, as if no arguments were
	  provided.

	  However, if a specific mailbox is requested and it doesn't exist,
	  then no warning at all is emitted.

	  This fixes this behavior to now warn if a specifically
	  requested mailbox could not be accessed, before falling back to
	  prompting the user for the correct mailbox.

	  ASTERISK-29920 #close

	  Change-Id: Ib4093b88cd661a2cabc5d685777d4e2f0ebd20a4

2022-02-07 16:31 +0000 [1cc1fb54e7]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: fix Batched Notifications stop working

	  If Subscription refresh occurred between when the batched notification
	  was scheduled and the serialized notification was to be sent,
	  then new schedule notification task would never be added.

	  There are 2 threads:

	  thread #1. ast_sip_subscription_notify is called,
	  if notification_batch_interval then call schedule_notification.
	  1.1. The schedule_notification checks notify_sched_id > -1
	  not true, then
	  send_scheduled_notify = 1
	  notify_sched_id =
	    ast_sched_add(sched, sub_tree->notification_batch_interval, sched_cb....
	  1.2. The sched_cb pushes task serialized_send_notify to serializer
	  and returns 0 which means no reschedule.
	  1.3. The serialized_send_notify checks send_scheduled_notify if it's false
	  the just returns. BUT notify_sched_id is still set, so no more ast_sched_add.

	  thread #2. pubsub_on_rx_refresh is called
	  2.1 it pushes serialized_pubsub_on_refresh_timeout to serializer
	  2.2. The serialized_pubsub_on_refresh_timeout calls pubsub_on_refresh_timeout
	  which calls send_notify
	  2.3. The send_notify set send_scheduled_notify = 0;

	  The serialized_send_notify should always unset notify_sched_id.

	  ASTERISK-29904 #close

	  Change-Id: Ifc50c00b213c396509e10326a1ed89d8cf8c7875

2022-02-18 06:09 +0000 [26141981c5]  Naveen Albert <asterisk@phreaknet.org>

	* func_db: Add validity check for key names when writing.

	  Adds a simple sanity check for key names when users are
	  writing data to AstDB. This captures four cases indicating
	  malformed keynames that generally result in bad data going
	  into the DB that the user didn't intend: an empty key name,
	  a key name beginning or ending with a slash, and a key name
	  containing two slashes in a row. Generally, this is the
	  result of a variable being used in the key name being empty.

	  If a malformed key name is detected, a warning is emitted
	  to indicate the bug in the dialplan.

	  ASTERISK-29925 #close

	  Change-Id: Ifc08a9fe532a519b1b80caca1aafed7611d573bf

2022-02-01 09:59 +0000 [e2423c6f49]  Alexei Gradinari <alex2grad@gmail.com>

	* res_pjsip_pubsub: provide a display name for RLS subscriptions

	  Whereas BLFs allow to show a display name for each RLS entry,
	  the asterisk provides only the extension now.
	  This is not end user friendly.

	  This commit adds a new resource_list option, resource_display_name,
	  to indicate whether display name of resource or the resource name being
	  provided for RLS entries.
	  If this option is enabled, the Display Name will be provided.
	  This option is disabled by default to remain the previous behavior.
	  If the 'event' set to 'presence' or 'dialog' the non-empty HINT name
	  will be set as the Display Name.
	  The 'message-summary' is not supported yet.

	  ASTERISK-29891 #close

	  Change-Id: Ic5306bd5a7c73d03f5477fe235e9b0f41c69c681

2022-01-13 19:37 +0000 [4358c776b8]  Naveen Albert <asterisk@phreaknet.org>

	* cli: Add core dump info to core show settings.

	  Adds two pieces of information to the core show settings command
	  which are useful in the context of getting backtraces.

	  The first is to display whether or not Asterisk would generate
	  a core dump if it were to crash.

	  The second is to show the current running directory of Asterisk.

	  ASTERISK-29866 #close

	  Change-Id: Ic42c0a9ecc233381aad274d86c62808d1ebb4d83

2022-02-04 19:46 +0000 [74e9b60bd0]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Adds missing default attributes.

	  The configObject tag contains a default attribute which
	  allows the default value to be specified, if applicable.
	  This allows for the default value to show up specially on
	  the wiki in a way that is clear to users.

	  There are a couple places in the tree where default values
	  are included in the description as opposed to as attributes,
	  which means these can't be parsed specially for the wiki.
	  These are changed to use the attribute instead of being
	  included in the text description.

	  ASTERISK-29898 #close

	  Change-Id: I9d7ea08f50075f41459ea7b76654906b674ec755

2022-02-05 06:39 +0000 [da801e2438]  Naveen Albert <asterisk@phreaknet.org>

	* app_mp3: Document and warn about HTTPS incompatibility.

	  mpg123 doesn't support HTTPS, but the MP3Player application
	  doesn't document this or warn the user about this. HTTPS
	  streams have become more common nowadays and users could
	  reasonably try to play them without being aware they should
	  use the HTTP stream instead.

	  This adds documentation to note this limitation. It also
	  throws a warning if users try to use the HTTPS stream to
	  tell them to use the HTTP stream instead.

	  ASTERISK-29900 #close

	  Change-Id: Ie3b029be5258c5a701f71ed3b1a7a80d1e03b827

2022-01-22 16:52 +0000 [332eed3aa7]  Naveen Albert <asterisk@phreaknet.org>

	* app_mf: Add max digits option to ReceiveMF.

	  Adds an option to the ReceiveMF application to allow specifying a
	  maximum number of digits.

	  Originally, this capability was not added to ReceiveMF as it was
	  with ReceiveSF because typically a ST digit is used to denote that
	  sending of digits is complete. However, there are certain signaling
	  protocols which simply transmit a digit (such as Expanded In-Band
	  Signaling) and for these, it's necessary to be able to read a
	  certain number of digits, as opposed to until receiving a ST digit.

	  This capability is added as an option, as opposed to as a parameter,
	  to remain compatible with existing usage (and not shift the
	  parameters).

	  ASTERISK-29877 #close

	  Change-Id: I4229167c9aa69b87402c3c2a9065bd8dfa973a0b

2022-02-02 19:18 +0000 [9e71f7fe37]  Mike Bradeen <mbradeen@sangoma.com>

	* taskprocessor.c: Prevent crash on graceful shutdown

	  When tps_shutdown is called as part of the cleanup process there is a
	  chance that one of the taskprocessors that references the
	  tps_singletons object is still running.  The change is to allow for
	  tps_shutdown to check tps_singleton's container count and give the
	  running taskprocessors a chance to finish.  If after
	  AST_TASKPROCESSOR_SHUTDOWN_MAX_WAIT (10) seconds there are still
	  container references we shutdown anyway as this is most likely a bug
	  due to a taskprocessor not being unreferenced.

	  ASTERISK-29365

	  Change-Id: Ia932fc003d316389b9c4fd15ad6594458c9727f1

2022-01-21 13:00 +0000 [fcdeb3e5b7]  Alexei Gradinari <alex2grad@gmail.com>

	* app_queue: load queues and members from Realtime when needed

	  There are a lot of Queue AMI actions and Queue applications
	  which do not load queue and queue members from Realtime.

	  AMI actions
	  QueuePause - if queue not in memory - response "Interface not found".
	  QueueStatus/QueueSummary - if queue not in memory - empty response.

	  Applications:
	  PauseQueueMember - if queue not in memory
	  	Attempt to pause interface %s, not found
	  UnpauseQueueMember - if queue not in memory
	  	Attempt to unpause interface xxxxx, not found

	  This patch adds a new function load_realtime_queues
	  which loads queue and queue members for desired queue
	  or all queues and all members if param 'queuename' is NULL or empty.
	  Calls the function load_realtime_queues when needed.

	  Also this patch fixes leak of ast_config in function set_member_value.

	  Also this patch fixes incorrect LOG_WARNING when pausing/unpausing
	  already paused/unpaused member.
	  The function ast_update_realtime returns 0 when no record modified.
	  So 0 is not an error to warn about.

	  ASTERISK-29873 #close
	  ASTERISK-18416 #close
	  ASTERISK-27597 #close

	  Change-Id: I554ee0eebde93bd8f49df7f84b74acb21edcb99c

2022-01-21 07:52 +0000 [6659e502a4]  Mark Petersen <bugs.digium.com@zombie.dk>

	* res_prometheus.c: missing module dependency

	  added res_pjsip_outbound_registration to .requires in AST_MODULE_INFO
	  which fixes issue with module crashes on load "FRACK!, Failed assertion"

	  ASTERISK-29871

	  Change-Id: Ia0f49d048427a40e1b763296b834a52a03610096

2022-02-07 10:55 +0000 [acd6f30cc5]  Sean Bright <sean.bright@gmail.com>

	* manager.c: Simplify AMI ModuleCheck handling

	  This code was needlessly complex and would fail to properly delimit
	  the response message if LOW_MEMORY was defined.

	  Change-Id: Iae50bf09ef4bc34f9dc4b49435daa76f8b2c5b6e

2022-02-03 15:48 +0000 [de0c29de55]  Sean Bright <sean.bright@gmail.com>

	* res_pjsip.c: Correct minor typos in 'realm' documentation.

	  Change-Id: I886936b808def5540d40071321e72f6bfa19063a

2022-01-31 12:52 +0000 [118e034287]  Sean Bright <sean.bright@gmail.com>

	* manager.c: Generate valid XML if attribute names have leading digits.

	  The XML Manager Event Interface (amxml) now generates attribute names
	  that are compliant with the XML 1.1 specification. Previously, an
	  attribute name that started with a digit would be rendered as-is, even
	  though attribute names must not begin with a digit. We now prefix
	  attribute names that start with a digit with an underscore ('_') to
	  prevent XML validation failures.

	  This is not backwards compatible but my assumption is that compliant
	  XML parsers would already have been complaining about this.

	  ASTERISK-29886 #close

	  Change-Id: Icfaa56a131a082d803e9b7db5093806d455a0523

2022-02-03 12:25 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.10.0-rc1 Released.

2022-02-03 06:12 +0000 [aa6a50630f]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.10.0
2022-02-01 10:09 +0000 [c51353e4db]  Sean Bright <sean.bright@gmail.com>

	* build_tools/make_version: Fix bashism in comparison.

	  In POSIX sh (which we indicate in the shebang), there is no ==
	  operator.

	  Change-Id: Ic03d38214d14cdf329b0ba272279a815bb532965

2022-01-21 14:08 +0000 [0d53ce35f9]  George Joseph <gjoseph@digium.com>

	* bundled_pjproject:  Add additional multipart search utils

	  Added the following APIs:
	  pjsip_multipart_find_part_by_header()
	  pjsip_multipart_find_part_by_header_str()
	  pjsip_multipart_find_part_by_cid_str()
	  pjsip_multipart_find_part_by_cid_uri()

	  Change-Id: I6aee3dcf59eb171f93aae0f0564ff907262ef40d

2022-01-07 04:01 +0000 [95ee1d06d6]  Mark Petersen <bugs.digium.com@zombie.dk>

	* chan_sip.c Fix pickup on channel that are in AST_STATE_DOWN

	  resolve issue with pickup on device that uses "183" and not "180"

	  ASTERISK-29832

	  Change-Id: I4c7d223870f8ce9a7354e0f73d4e4cb2e8b58841

2022-01-31 07:09 +0000 [2a34bb1e11]  George Joseph <gjoseph@digium.com>

	* res_pjsip_outbound_authenticator_digest: Prevent ABRT on cleanup

	  In dev mode, if you call pjsip_auth_clt_deinit() with an auth_sess
	  that hasn't been initialized, it'll assert and abort.  If
	  digest_create_request_with_auth() fails to find the proper
	  auth object however, it jumps to its cleanup which does exactly
	  that.  So now we no longer attempt to call pjsip_auth_clt_deinit()
	  if we never actually initialized it.

	  ASTERISK-29888

	  Change-Id: Ib6171c25c9fe8e61cc8d11129e324c021bc30b62

2022-01-26 07:56 +0000 [135e48deba]  George Joseph <gjoseph@digium.com>

	* build: Add "basebranch" to .gitreview

	  If you have a development branch for a major project that
	  will receive gerrit reviews it'll probably be named something
	  like "development/16/newproject".  That will necessitate setting
	  "defaultbranch=development/16/newproject" in .gitreview.  The
	  make_version script uses that variable to construct the asterisk
	  version however, which results in versions like
	  "GIT-development/16/newproject-ee582a8c7b" which is probably not
	  what you want.  Worse, since the download_externals script uses
	  make_version to construct the URL to download the binary codecs
	  or DPMA.  Since it's expecting a simple numeric version, the
	  downloads will fail.

	  To get this to work, a new variable "basebranch" has been added
	  to .gitreview and make_version has been updated to use that instead
	  of defaultversion:

	  .gitreview:
	  defaultbranch=development/16/myproject
	  basebranch=16

	  Now git-review will send the reviews to the proper branch
	  (development/16/myproject) but the version will still be
	  constructed using the simple branch number (16).

	  If "basebranch" is missing from .gitreview, make_version will
	  fall back to using "defaultbranch".

	  Change-Id: I2941a3b21e668febeb6cfbc1a7bb51a67726fcc4

2021-12-15 12:36 +0000 [6fc8453e96]  Naveen Albert <asterisk@phreaknet.org>

	* cdr: allow disabling CDR by default on new channels

	  Adds a new option, defaultenabled, to the CDR core to
	  control whether or not CDR is enabled on a newly created
	  channel. This allows CDR to be disabled by default on
	  new channels and require the user to explicitly enable
	  CDR if desired. Existing behavior remains unchanged.

	  ASTERISK-29808 #close

	  Change-Id: Ibb78c11974bda229bbb7004b64761980e0b2c6d1

2022-01-11 13:19 +0000 [a4b01ececb]  Naveen Albert <asterisk@phreaknet.org>

	* res_tonedetect: Fixes some logic issues and typos

	  Fixes some minor logic issues with the module:

	  Previously, the OPT_END_FILTER flag was getting
	  tested before options were parsed, so it could
	  never evaluate to true (wrong ordering).

	  Additionally, the initially parsed timeout (float)
	  needs to be compared with 0, not the result int
	  which is set afterwards (wrong variable).

	  ASTERISK-29857 #close

	  Change-Id: I0062bce3b391c15e5df7a714780eeaa96dd93d4c

2022-01-11 12:33 +0000 [5df5a70d37]  Naveen Albert <asterisk@phreaknet.org>

	* func_frame_drop: Fix typo referencing wrong buffer

	  In order to get around the issue of certain frames
	  having names that could overlap, func_frame_drop
	  surrounds names with commas for the purposes of
	  comparison.

	  The buffer is allocated and printed to properly,
	  but the original buffer is used for comparison.
	  In most cases, this wouldn't have had any effect,
	  but that was not the intention behind the buffer.
	  This updates the code to reference the modified
	  buffer instead.

	  ASTERISK-29854 #close

	  Change-Id: I430b52e14e712d0e62a23aa3b5644fe958b684a7

2022-01-20 06:56 +0000 [9c9083b45a]  Torrey Searle <tsearle@voxbone.com>

	* res/res_rtp_asterisk: fix skip in rtp sequence numbers after dtmf

	  When generating dtmfs, asterisk can incorrectly think packet loss
	  occured during the dtmf generation, resulting in a jump in sequence
	  numbers when forwarding voice frames resumes.  This patch forces
	  asterisk to re-learn the expected sequence number after each DTMF
	  to avoid this

	  ASTERISK-29869 #close

	  Change-Id: Icc7de3d947b207b82c99d3c327af8095884df853

2022-01-13 16:31 +0000 [98f86697cc]  Kevin Harwell <kharwell@sangoma.com>

	* res_http_websocket: Add a client connection timeout

	  Previously there was no way to specify a connection timeout when
	  attempting to connect a websocket client to a server. This patch
	  makes it possible to now do such.

	  Change-Id: I5812f6f28d3d13adbc246517f87af177fa20ee9d

2022-01-21 10:34 +0000 [5b47b7a37e]  Sean Bright <sean.bright@gmail.com>

	* build: Rebuild configure and autoconfig.h.in

	  autoconfigh.h.in was missed in the original review for this
	  issue. Additionally it looks like I have newer pkg-config autoconf
	  macros on my development machine.

	  ASTERISK-29817

	  Change-Id: I3c85a4de82c5d7d6e0e23dad4c33bb650a86a57b

2021-12-08 15:14 +0000 [ac8988c9a3]  Mike Bradeen <mbradeen@sangoma.com>

	* sched: fix and test a double deref on delete of an executing call back

	  sched: Avoid a double deref when AST_SCHED_DEL_UNREF is called on an
	  executing call-back. This is done by adding a new variable 'rescheduled'
	  to the struct sched which is set in ast_sched_runq and checked in
	  ast_sched_del_nonrunning. ast_sched_del_nonrunning is a replacement for
	  now deprecated ast_sched_del which returns a new possible value -2
	  if called on an executing call-back with rescheduled set. ast_sched_del
	  is modified to call ast_sched_del_nonrunning to maintain existing code.
	  AST_SCHED_DEL_UNREF is also updated to look for the -2 in which case it
	  will not throw a warning or invoke refcall.
	  test_sched: Add a new unit test sched_test_freebird that will check the
	  reference count in the resolved scenario.

	  ASTERISK-29698

	  Change-Id: Icfb16b3acbc29cf5b4cef74183f7531caaefe21d

2022-01-19 16:33 +0000 [6e8bbe4b3a]  Luke Escude <luke@primevox.net>

	* res_pjsip_sdp_rtp.c: Support keepalive for video streams.

	  ASTERISK-28890 #close

	  Change-Id: Iad269a8dc36f892ede90fe8ceb3010560c0f70d1

2022-01-04 03:11 +0000 [c8d89e7e1b]  Mark Petersen <bugs.digium.com@zombie.dk>

	* app_queue.c: Queue don't play "thank-you" when here is no hold time announcements

	  if holdtime is (0 min, 0 sec) there is no hold time announcements
	  we should then also not playing queue-thankyou

	  ASTERISK-29831

	  Change-Id: Ic7e51dcde526b23f1cd8d24e1d1e2d81e10f9d2c

2021-11-10 22:24 +0000 [d68d90c5be]  Michał Górny <mgorny@NetBSD.org>

	* main: Enable rdtsc support on NetBSD

	  Enable the Linux rdtsc implementation on NetBSD as well.  The assembly
	  works correctly there.

	  ASTERISK-29851

	  Change-Id: I460ad9b4d971913420ecb84186f5ba5ab03f6f37

2021-11-10 21:40 +0000 [90d02cf0a3]  Michał Górny <mgorny@NetBSD.org>

	* build_tools/make_version: Fix sed(1) syntax compatibility with NetBSD

	  Fix the sed(1) invocation used to process git-svn-id not to use "\s"
	  that is a GNU-ism and is not supported by NetBSD sed.  As a result,
	  this call did not work properly and make_version did output the full
	  git-svn-id line rather than the revision.

	  ASTERISK-29852

	  Change-Id: Ie4b406e2748920643446851a0a252a4ca7245772

2021-11-10 22:29 +0000 [c8ef232d76]  Michał Górny <mgorny@NetBSD.org>

	* main/utils: Implement ast_get_tid() for NetBSD

	  Implement the ast_get_tid() function for NetBSD system.  NetBSD supports
	  getting the TID via _lwp_self().

	  ASTERISK-29850

	  Change-Id: If57fd3f9ea15ef5d010bfbdcbbbae9b379f72f8c

2021-11-10 20:05 +0000 [7b1e5fa34a]  Michał Górny <mgorny@NetBSD.org>

	* BuildSystem: Fix misdetection of gethostbyname_r() on NetBSD

	  Fix the configure script not to detect the presence of gethostbyname_r()
	  on NetBSD incorrectly.  NetBSD includes it as an internal libc symbol
	  that is not exposed in system headers and that is incompatible with
	  other implementations.  In order to avoid misdetecting it, perform
	  the symbol check only if the declaration is found in the public header
	  first.

	  ASTERISK-29817

	  Change-Id: Iafa359b09908251bcd299ff54be003ea129b9eda

2021-11-10 22:06 +0000 [eef29d24e1]  Michał Górny <mgorny@NetBSD.org>

	* include: Remove unimplemented HMAC declarations

	  Remove the HMAC declarations from the includes.  They are
	  not implemented nor used anywhere, and their presence breaks the build
	  on NetBSD that delivers an incompatible hmac() function in <stdlib.h>.

	  ASTERISK-29818

	  Change-Id: I0c4b88645e30174b1b63846a6b328625b69c2ea7

2022-01-11 12:41 +0000 [18c257b44d]  Naveen Albert <asterisk@phreaknet.org>

	* frame.h: Fix spelling typo

	  Fixes CNG description from "noice" to "noise".

	  ASTERISK-29855 #close

	  Change-Id: Ie7cbbd7d72b426693df7447384ff8700318cd36d

2022-01-11 12:46 +0000 [a9e9e15c3a]  Naveen Albert <asterisk@phreaknet.org>

	* res_rtp_asterisk: Fix typo in flag test/set

	  The code currently checks to see if an RFC3389
	  warning flag is set, except if it is, it merely
	  sets the flag again, the logic of which doesn't
	  make any sense.

	  This adjusts the if comparison to check if the
	  flag has NOT been set, and if so, emit a notice
	  log event and set the flag so that future frames
	  do not cause an event to be logged.

	  ASTERISK-29856 #close

	  Change-Id: Ib7098c947c63537d087a03b4646199fbb963f8e1

2022-01-18 08:04 +0000 [cc38ed9c21]  George Joseph <gjoseph@digium.com>

	* bundled_pjproject: Fix srtp detection

	  Reverted recent change that set '--with-external-srtp' instead
	  of '--without-external-srtp'.  Since Asterisk handles all SRTP,
	  we don't need it enabled in pjproject at all.

	  ASTERISK-29867

	  Change-Id: I2ce1bdd30abd21c062eac8f8fefe9b898787b801

2022-01-10 07:44 +0000 [f55886a72c]  George Joseph <gjoseph@digium.com>

	* res_pjsip: Make message_filter and session multipart aware

	  Neither pjsip_message_filter's filter_on_tx_message() nor
	  res_pjsip_session's session_outgoing_nat_hook() were multipart
	  aware and just assumed that an SDP would be the only thing in
	  a message body.  Both were changed to use the new
	  pjsip_get_sdp_info() function which searches for an sdp in
	  both single- and multi- part message bodies.

	  ASTERISK-29813

	  Change-Id: I8f5b8cfdc27f1d4bd3e7491ea9090951a4525c56

2022-01-06 13:05 +0000 [59cf9f0047]  George Joseph <gjoseph@digium.com>

	* res_pjsip: Add utils for checking media types

	  Added two new functions to assist checking media types...

	  * ast_sip_are_media_types_equal compares two pjsip_media_types.
	  * ast_sip_is_media_type_in tests if one media type is in a list
	    of others.

	  Added static definitions for commonly used media types to
	  res_pjsip.h.

	  Changed several modules to use the new functions and static
	  definitions.

	  ASTERISK_29813
	  (not ready to close)

	  Change-Id: Ief77675235bd3bf00a6b095d4673fd878d0801b9

2022-01-12 11:12 +0000 [b59bd3d3e4]  George Joseph <gjoseph@digium.com>

	* build: Fix issues building pjproject

	  The change to allow easier hacking on bundled pjproject created
	  a few issues:

	  * The new Makefile was trying to run the bundled make even if
	    PJPROJECT_BUNDLED=no.  third-party/Makefile now checks for
	    PJPROJECT_BUNDLED and JANSSON_BUNDLED and skips them if they
	    are "no".

	  * When building with bundled, config_site.h was being copied
	    only if a full make or a "make main" was done.  A "make res"
	    would fail all the pjsip modules because they couldn't find
	    config_site.h.  The Makefile now copies config_site.h and
	    asterisk_malloc_debug.h into the pjproject source tree
	    when it's "configure" is performed.  This is how it used
	    to be before the big change.

	  ASTERISK-29858

	  Change-Id: I9427264fa3cb8b3f59a95e5f9693eac236a6f76d

2022-01-12 07:16 +0000 [f10947ecc2]  George Joseph <gjoseph@digium.com>

	* bundled_pjproject: Create generic pjsip_hdr_find functions

	  pjsip_msg_find_hdr(), pjsip_msg_find_hdr_by_name(), and
	  pjsip_msg_find_hdr_by_names() require a pjsip_msg to be passed in
	  so if you need to search a header list that's not in a pjsip_msg,
	  you have to do it yourself.  This commit adds generic versions of
	  those 3 functions that take in the actual header list head instead
	  of a pjsip_msg so if you need to search a list of headers in
	  something like a pjsip_multipart_part, you can do so easily.

	  Change-Id: I6f2c127170eafda48e5e0d5d4d187bcd52b4df07

2022-01-12 13:20 +0000 [3fd47840c9]  Sean Bright <sean.bright@gmail.com>

	* say.c: Prevent erroneous failures with 'say' family of functions.

	  A regression was introduced in ASTERISK~29531 that caused 'say'
	  functions to fail with file lists that would previously have
	  succeeded. This caused affected channels to hang up where previously
	  they would have continued.

	  We now explicitly check for the empty string to restore the previous
	  behavior.

	  ASTERISK-29859 #close

	  Change-Id: Ia2e5769868e2792313c2d7c07996efe009c6f8d5

2022-01-08 09:09 +0000 [e006d2d2a6]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_variables: add missing ASTSBINDIR variable

	  Every config variable in the directories
	  section of asterisk.conf currently has a
	  counterpart built-in variable containing
	  the value of the config option, except
	  for the last one, astsbindir, which should
	  have an ASTSBINDIR variable.

	  However, the actual corresponding ASTSBINDIR
	  variable is missing in pbx_variables.c.

	  This adds the missing variable so that all
	  the config options have their corresponding
	  variable.

	  ASTERISK-29847 #close

	  Change-Id: I36006faf471825b36ebc8aa5e87a3bcb38d446fc

2022-01-08 14:35 +0000 [707f32170c]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Document built-in system and channel vars

	  Documentation for built-in special system and channel
	  vars is currently outdated, and updating is a manual
	  process since there is no XML documentation for these
	  anywhere.

	  This adds documentation for system vars to func_env
	  and for channel vars to func_channel so that they
	  appear along with the corresponding fields that would
	  be accessed using a function.

	  ASTERISK-29848 #close

	  Change-Id: I6997f925c4a45fffe71321861f5898a8b7182fa9

2021-11-30 16:35 +0000 [3f093b8dda]  George Joseph <gjoseph@digium.com>

	* bundled_pjproject:  Make it easier to hack

	  There are times when you need to troubleshoot issues with bundled
	  pjproject or add new features that need to be pushed upstream
	  but...

	  * The source directory created by extracting the pjproject tarball
	    is not scanned for code changes so you have to keep forcing
	    rebuilds.
	  * The source directory isn't a git repo so you can't easily create
	    patches, do git bisects, etc.
	  * Accidentally doing a make distclean will ruin your day by wiping
	    out the source directory, and your changes.
	  * etc.

	  This commit makes that easier.
	  See third-party/pjproject/README-hacking.md for the details.

	  ASTERISK-29824

	  Change-Id: Idb1251040affdab31d27cd272dda68676da9b268

2021-12-24 10:26 +0000 [0bbef4d8c5]  Sean Bright <sean.bright@gmail.com>

	* utils.c: Remove all usages of ast_gethostbyname()

	  gethostbyname() and gethostbyname_r() are deprecated in favor of
	  getaddrinfo() which we use in the ast_sockaddr family of functions.

	  ASTERISK-29819 #close

	  Change-Id: Ie277c0ef768d753b169c121ef570a71665692ab7

2021-12-13 09:53 +0000 [54f2f1e027]  Naveen Albert <asterisk@phreaknet.org>

	* say.conf: fix 12pm noon logic

	  Fixes 12pm noon incorrectly returning 0/a.m.
	  Also fixes a misspelling typo in the config.

	  ASTERISK-29695 #close

	  Change-Id: Ie40f9618636eb4c483b449bd707a5dcffca5c406

2022-01-04 08:08 +0000 [ee69441fbd]  Sean Bright <sean.bright@gmail.com>

	* pjproject: Fix incorrect unescaping of tokens during parsing

	  ASTERISK-29664 #close

	  Change-Id: I29dcde52e9faeaf2609c604eada61c6a9e49d8f5

2021-12-30 07:02 +0000 [dea71ddbbf]  Mark Petersen <bugs.digium.com@zombie.dk>

	* app_queue.c: Support for Nordic syntax in announcements

	  adding support for playing the correct en/et for nordic languages
	  by adding 'n' for neuter gender in the relevant ast_say_number

	  ASTERISK-29827

	  Change-Id: I03ebc827d2f0dc95132ab2f42799893c70edc5b1

2021-12-23 08:50 +0000 [6d7161820e]  Naveen Albert <asterisk@phreaknet.org>

	* dsp: Add define macro for DTMF_MATRIX_SIZE

	  Adds the macro DTMF_MATRIX_SIZE to replace
	  the magic number 4 sprinkled throughout
	  dsp.c.

	  ASTERISK-29815 #close

	  Change-Id: Ie3bddb92c6b16204ece0f758009e9490eb33b9ba

2022-01-03 11:10 +0000 [f133ae6ca2]  Naveen Albert <asterisk@phreaknet.org>

	* ami: Add AMI event for Wink

	  Adds an AMI event for a wink frame.

	  ASTERISK-29830 #close

	  Change-Id: I83e426de5e37baed79a4dbcc91e9e8d030ef1b56

2021-12-15 08:23 +0000 [1c2f311ba3]  Naveen Albert <asterisk@phreaknet.org>

	* cli: Add module refresh command

	  Adds a command to the CLI to unload and then
	  load a module. This makes it easier to perform
	  these operations which are often done
	  subsequently to load a new version of a module.

	  "module reload" already refers to reloading of
	  configuration, so the name "refresh" is chosen
	  instead.

	  ASTERISK-29807 #close

	  Change-Id: I595f6f11774a0de2565a1fba38da22309ce93a2c

2022-01-02 19:13 +0000 [775c371d09]  Naveen Albert <asterisk@phreaknet.org>

	* app_mp3: Throw warning on nonexistent stream

	  Currently, the MP3Player application doesn't
	  emit a warning if attempting to play a stream
	  which no longer exists. This can be a common
	  scenario as many mp3 streams are valid at some
	  point but can disappear at any time.

	  Now a warning is thrown if attempting to play
	  a nonexistent MP3 stream, instead of silently
	  exiting.

	  ASTERISK-29829 #close

	  Change-Id: I53a0bf1ed1740166655eb66fe7675f6f808bf535

2021-12-13 08:29 +0000 [b37feb42ae]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Add missing AMI documentation

	  Adds missing documentation for some channel,
	  bridge, and queue events.

	  ASTERISK-24427
	  ASTERISK-29515

	  Change-Id: I92b06b88c8cadc0155f95ebe3e870b3e795a8c64

2021-11-15 16:13 +0000 [06f9227ac5]  Kevin Harwell <kharwell@sangoma.com>

	* tcptls.c: refactor client connection to be more robust

	  The current TCP client connect code, blocks and does not handle EINTR
	  error case.

	  This patch makes the client socket non-blocking while connecting,
	  ensures a connect does not immediately fail due to EINTR "errors",
	  and adds a connect timeout option.

	  The original client start call sets the new timeout option to
	  "infinite", thus making sure old, orginal behavior is retained.

	  ASTERISK-29746 #close

	  Change-Id: I907571843a83e43c0742b95a64785f4411f02671

2021-12-13 10:59 +0000 [dd6df42534]  Naveen Albert <asterisk@phreaknet.org>

	* app_sf: Add full tech-agnostic SF support

	  Adds tech-agnostic support for SF signaling
	  by adding SF sender and receiver applications
	  as well as Dial integration.

	  ASTERISK-29802 #close

	  Change-Id: I7ec50752e9a661af639425e5d1e339f17411bcad

2021-12-15 06:23 +0000 [16a63027c0]  Steve Davies <steve@one47.co.uk>

	* app_queue: Fix hint updates, allow dup. hints

	  A previous patch for ASTERISK_29578 caused a 'leak' of
	  extension state information across queues, causing the
	  state of the first member of unrelated queues to be
	  updated in addition to the correct member. Which queues
	  and members depended on the order of queues in the
	  iterator.

	  Additionally, it is possible to use the same 'hint:' on
	  multiple queue members, so the update cannot break out
	  of the update loop early when a match is found.

	  ASTERISK-29806 #close

	  Change-Id: If2c1d1cc2a752afd9286d79710fc818596e7a7ad

2021-12-23 15:57 +0000 [4fe94bab09]  Sean Bright <sean.bright@gmail.com>

	* say.c: Honor requests for DTMF interruption.

	  SayAlpha, SayAlphaCase, SayDigits, SayMoney, SayNumber, SayOrdinal,
	  and SayPhonetic all claim to allow DTMF interruption if the
	  SAY_DTMF_INTERRUPT channel variable is set to a truthy value, but we
	  are failing to break out of a given 'say' application if DTMF actually
	  occurs.

	  ASTERISK-29816 #close

	  Change-Id: I6a96e0130560831d2cb45164919862b9bcb6287e

2021-11-16 06:32 +0000 [4e204db2bf]  Florentin Mayer <f.mayer@commend.com>

	* res_pjsip_sdp_rtp: Preserve order of RTP codecs

	  The ast_rtp_codecs_payloads functions do not preserve the order in which
	  the payloads were specified on an incoming SDP media line. This leads to
	  a problem with the codec negotiation functionality, as the format
	  capabilities of the stream are extracted from the ast_rtp_codecs. This
	  commit moves the ast_rtp_codec to ast_format conversion to the place
	  where the order is still known.

	  ASTERISK-28863
	  ASTERISK-29320

	  Change-Id: I3aabcfed3f379c36654f59c1872c313d0cb57e25

2021-12-27 07:28 +0000 [d83a46869e]  Joshua C. Colp <jcolp@sangoma.com>

	* bridge: Unlock channel during Local peer check.

	  It's not safe to keep the channel locked while locking
	  the peer Local channel, as it can result in a deadlock.

	  This change unlocks it during this time but keeps the
	  bridge locked to ensure nothing changes about the bridge.

	  ASTERISK-29821

	  Change-Id: Ib68eb7037e5a479bcc2aceee77337cdde1fbdde6

2021-11-07 09:32 +0000 [a5cdee36a7]  Josh Soref <jsoref@gmail.com>

	* test_time.c: Tolerate DST transitions

	  When test_timezone_watch runs very near a DST transition,
	  two time zones that would otherwise be expected to report the same
	  time can differ because of the DST transition.

	  Instead of having the test fail when this happens, report the
	  times, time zones, and dst flags.

	  ASTERISK-29722

	  Change-Id: Id59bdac8b277e14343ccdf0c99b89e92f79f316a

2021-12-14 11:39 +0000 [0cf4e325aa]  George Joseph <gjoseph@digium.com>

	* bundled_pjproject:  Add more support for multipart bodies

	  Adding upstream patch for pull request...
	  https://github.com/pjsip/pjproject/pull/2920
	  ---------------------------------------------------------------

	  sip_inv:  Additional multipart support (#2919)

	  sip_inv.c:inv_check_sdp_in_incoming_msg() deals with multipart
	  message bodies in rdata correctly. In the case where early media is
	  involved though, the existing sdp has to be retrieved from the last
	  tdata sent in this transaction. This, however, always assumes that
	  the sdp sent is in a non-multipart body. While there's a function
	  to retrieve the sdp from multipart and non-multpart rdata bodies,
	  no similar function for tdata exists.  So...

	  * The existing pjsip_rdata_get_sdp_info2 was refactored to
	    find the sdp in any body, multipart or non-multipart, and
	    from either an rdata or tdata.  The new function is
	    pjsip_get_sdp_info.  This new function detects whether the
	    pjsip_msg->body->data is the text representation of the sdp
	    from an rdata or an existing pjmedia_sdp_session object
	    from a tdata, or whether pjsip_msg->body is a multipart
	    body containing either of the two sdp formats.

	  * The exsting pjsip_rdata_get_sdp_info and pjsip_rdata_get_sdp_info2
	    functions are now wrappers that get the body and Content-Type
	    header from the rdata and call pjsip_get_sdp_info.

	  * Two new wrappers named pjsip_tdata_get_sdp_info and
	    pjsip_tdata_get_sdp_info2 have been created that get the body
	    from the tdata and call pjsip_get_sdp_info.

	  * inv_offer_answer_test.c was updated to test multipart scenarios.

	  ASTERISK-29804

	  Change-Id: I483c7c3d413280c9e247a96ad581278347f9c71b

2021-12-09 02:55 +0000 [965f4abd9a]  Frederic Van Espen <frederic.ve@gmail.com>

	* ast_coredumper: Fix deleting results when output dir is set

	  When OUTPUTDIR is set to another directory and the
	  --delete-results-after is set, the resulting txt files are
	  not deleted.

	  ASTERISK-29794 #close

	  Change-Id: I1c0071f6809a1e3f5cfc455d6eb08378bc0d7286

2021-12-13 16:49 +0000 [bb27d5e1fe]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_variables: initialize uninitialized variable

	  The variable cp4 in a variable substitution function
	  can potentially be used without being initialized
	  currently. This causes Asterisk to no longer compile.

	  This initializes cp4 to NULL to make the compiler
	  happy.

	  ASTERISK-29803 #close

	  Change-Id: I392579cbb76db2795d5820c9427cf55fbcee9e72

2021-12-08 05:24 +0000 [3d71bcd2f4]  Mark Petersen <bugs.digium.com@zombie.dk>

	* app_queue.c: added DIALEDPEERNUMBER on outgoing channel

	  added that we set DIALEDPEERNUMBER on the outgoing channels
	  so it is avalible in b(content^extension^line)
	  this add the same behaviour as Dial

	  ASTERISK-29795

	  Change-Id: Icbc589ea2066f0c401a892bf478f6b2fd44e62f6

2021-11-15 15:35 +0000 [05afa061f5]  Kevin Harwell <kharwell@sangoma.com>

	* http.c: Add ability to create multiple HTTP servers

	  Previously, it was only possible to have one HTTP server in Asterisk.
	  With this patch it is now possible to have multiple HTTP servers
	  listening on different addresses.

	  Note, this behavior has only been made available through an API call
	  from within the TEST_FRAMEWORK. Specifically, this feature has been
	  added in order to allow unit test to create/start and stop servers,
	  if one has not been enabled through configuration.

	  Change-Id: Ic5fb5f11e62c019a1c51310f4667b32a4dae52f5

2021-12-12 18:08 +0000 [030f7d4131]  Naveen Albert <asterisk@phreaknet.org>

	* app.c: Throw warnings for nonexistent options

	  Currently, Asterisk doesn't throw warnings if options
	  are passed into applications that don't accept them.
	  This can confuse users if they're unaware that they
	  are doing something wrong.

	  This adds an additional check to parse_options so that
	  a warning is thrown anytime an option is parsed that
	  doesn't exist in the parsing application, so that users
	  are notified of the invalid usage.

	  ASTERISK-29801 #close

	  Change-Id: Id029274a57135caca193c913307a63fd75e24679

2021-12-08 12:07 +0000 [a4c42e70c1]  Mark Petersen <bugs.digium.com@zombie.dk>

	* app_voicemail.c: Support for Danish syntax in VM

	  added support for playing the correct plural sound file
	  dependen on where you have 1 or multipe messages
	  based on the existing SE/NO code

	  ASTERISK-29797

	  Change-Id: I88aa814d02f3772bb80b474204b1ffb26fe438c2

2021-12-11 20:11 +0000 [86bc3eef99]  Naveen Albert <asterisk@phreaknet.org>

	* strings: Fix enum names in comment examples

	  The enum values for ast_strsep_flags includes
	  AST_STRSEP_STRIP. However, some comments reference
	  AST_SEP_STRIP, which doesn't exist. This fixes
	  these comments to use the correct value.

	  ASTERISK-29800 #close

	  Change-Id: If7bbd0c0e6226a211d25ddf9d1629347e2674943

2021-11-17 15:16 +0000 [c6410dc4ed]  Naveen Albert <asterisk@phreaknet.org>

	* configs: Updates to sample configs

	  Includes some minor updates to extensions.conf
	  and iax.conf. In particular, the demonstration
	  of macros in extensions.conf is removed, as
	  Macro is deprecated and will be removed soon.
	  These examples have been replaced with examples
	  demonstrating the usage of Gosub instead.

	  The older exten => ...,n syntax is also mostly
	  replaced with the same keyword to demonstrate the
	  newer, more concise way of defining extensions.

	  IAXTEL no longer exists, so this example is replaced
	  with something more generic.

	  Some documentation is also added to extensions.conf
	  and iax.conf to clarify some of the new expanded
	  encryption capabilities with IAX2.

	  ASTERISK-29758 #close

	  Change-Id: I04fba9671aa1ee9ba1bd5027061f80bbe38e7b46

2021-11-17 15:39 +0000 [2f1eb56116]  Naveen Albert <asterisk@phreaknet.org>

	* app_sendtext: Add ReceiveText application

	  Adds a ReceiveText application that can be used in
	  conjunction with SendText. Currently, there is no
	  way in Asterisk to receive text in the dialplan
	  (or anywhere else, really). This allows for Asterisk
	  to be the recipient of text instead of just the sender.

	  ASTERISK-29759 #close

	  Change-Id: Ica2c354a42bff69f323a0493d3a7cd0fb129d52d

2021-11-20 14:37 +0000 [c6309af560]  Naveen Albert <asterisk@phreaknet.org>

	* pbx_variables: Increase parsing capabilities of MSet

	  Currently MSet can only parse a maximum of 24 variables.
	  If more variables are provided to MSet, the 24th variable
	  will simply contain the remainder of the string and the
	  remaining variables thereafter will never get set.

	  This increases the number of variables that can be parsed
	  in one go from 24 to 99. Additionally, documentation is added
	  since this limitation is currently undocumented and is
	  confusing to users who encounter this limitation.

	  ASTERISK-29766 #close

	  Change-Id: I3fe35b462dedec0a452fd9ea7f92c920a3939f16

2021-11-23 20:21 +0000 [3108457d8f]  Naveen Albert <asterisk@phreaknet.org>

	* chan_sip: Fix crash when accessing RURI before initiating outgoing call

	  Attempting to access ${CHANNEL(ruri)} in a pre-dial handler before
	  initiating an outgoing call will cause Asterisk to crash. This is
	  because a null field is accessed, resulting in an offset from null and
	  subsequent memory access violation.

	  Since RURI is not guaranteed to exist, we now check if the base
	  pointer is non-null before calculating an offset.

	  ASTERISK-29772

	  Change-Id: Icd3b02f07256bbe6615854af5717074087b95a83

2021-10-25 16:19 +0000 [c0cdaf0246]  Naveen Albert <asterisk@phreaknet.org>

	* func_json: Adds JSON_DECODE function

	  Adds the JSON_DECODE function for parsing JSON in the
	  dialplan. JSON parsing already exists in the Asterisk
	  core and is used for many different things. This
	  function exposes the basic parsing capability to
	  the user in the dialplan, for instance, in conjunction
	  with CURL for using API responses.

	  ASTERISK-29706 #close

	  Change-Id: Iea60c49a7358dfdc2db60803cdc9a742f808ba2c

2021-12-11 18:45 +0000 [087f25d3fd]  Sean Bright <sean.bright@gmail.com>

	* CHANGES: Correct reference to configuration file.

	  Change-Id: I22a788ebf11168fff7fbf9ea956ebcd705ab63dd

2021-11-15 15:08 +0000 [cc1418ef47]  Naveen Albert <asterisk@phreaknet.org>

	* pbx: Add variable substitution API for extensions

	  Currently, variable substitution involving dialplan
	  extensions is quite clunky since it entails obtaining
	  the current dialplan location, backing it up, storing
	  the desired variables for substitution on the channel,
	  performing substitution, then restoring the original
	  location.

	  In addition to being clunky, things could also go wrong
	  if an async goto were to occur and change the dialplan
	  location during a substitution.

	  Fundamentally, there's no reason it needs to be done this
	  way, so new API is added to allow for directly passing in
	  the dialplan location for the purposes of variable
	  substitution so we don't need to mess with the channel
	  information anymore. Existing API is not changed.

	  ASTERISK-29745 #close

	  Change-Id: I23273bf27fa0efb64a606eebf9aa8e2f41a065e4

2021-09-21 19:18 +0000 [2b2b708d43]  Naveen Albert <asterisk@phreaknet.org>

	* app_mf: Add full tech-agnostic MF support

	  Adds tech-agnostic support for MF signaling by adding
	  MF sender and receiver applications as well as Dial
	  integration.

	  ASTERISK-29496-mf #do-not-close

	  Change-Id: I61962b359b8ec4cfd05df877ddf9f5b8f71927a4

2021-12-06 04:25 +0000 [55dd77b921]  Alexander Traud <pabstraud@compuserve.com>

	* xmldoc: Avoid whitespace around value for parameter/required.

	  Otherwise, the value 'false' was not found in the enumerated set of
	  the XML DTD for the XML attribute 'required' in the XML element
	  'parameter'. Therefore, DTD validation of the runtime XML failed.

	  ASTERISK-29790

	  Change-Id: Id13f230ad65a70dd8c2e3ae9ac85d1e841aed03e

2021-12-04 02:36 +0000 [4b6c72572c]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Fix Doxygen left-overs.

	  Change-Id: I5b5cf9c9cbbe00ba8b379a8d162ac67445d39016

2021-12-06 05:17 +0000 [5b24edeb7c]  Alexander Traud <pabstraud@compuserve.com>

	* xmldoc: Correct definition for XML element 'matchInfo'.

	  ASTERISK-29791

	  Change-Id: I7c656498427fcadd0a5d61a54ff67e6036609725

2021-11-23 08:05 +0000 [d914e14420]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Update Makefile.

	  In developer mode, use internal documentation as well.
	  This should produce no warnings. Fix yours!

	  In noisy mode, output all possible warnings of Doxygen.
	  This creates zillion of warnings. Double-check your current module!

	  Any warnings are in the file './doxygen.log'. Beside that, this change
	  avoids deprecated parameters because the configuration file for Doxygen
	  contains only those parameters which differ from the default. This
	  avoids the need to update the file on each run. Furthermore, it adds
	  AST_VECTOR to be expanded. Finally, the default name for that file is
	  Doxyfile. Therefore, let us use that!

	  ASTERISK-26991
	  ASTERISK-20259

	  Change-Id: I4129092a199d5e24c319a09cd088614b121015af

2021-12-03 07:38 +0000 [a103956fc9]  Alexander Traud <pabstraud@compuserve.com>

	* res_pjsip_sdp_rtp: Do not warn on unknown sRTP crypto suites.

	  res_sdp_crypto_parse_offer(.) emits many log messages already.

	  ASTERISK-29785

	  Change-Id: I1a191ebe4fec1102946d4e31887e5197ca02dfe8

2021-11-30 14:16 +0000 [c37cc5d3bc]  Sean Bright <sean.bright@gmail.com>

	* channel: Short-circuit ast_channel_get_by_name() on empty arg.

	  We know that passing a NULL or empty argument to
	  ast_channel_get_by_name() will never result in a matching channel and
	  will always result in an error being emitted, so just short-circuit
	  out in that case.

	  ASTERISK-28219 #close

	  Change-Id: I88eadc748e9c6996fc17467b0a05881bbfd00bce

2021-10-26 16:12 +0000 [04d00c203c]  Mike Bradeen <mbradeen@sangoma.com>

	* res_rtp_asterisk: Addressing possible rtp range issues

	  res/res_rtp_asterisk.c: Adding 1 to rtpstart if it is deteremined
	  that rtpstart was configured to be an odd value. Also adding a loop
	  counter to prevent a possible infinite loop when looking for a free
	  port.

	  ASTERISK-27406

	  Change-Id: I90f07deef0716da4a30206e9f849458b2dbe346b

2021-08-24 09:56 +0000 [6c9e8afd4e]  Mark Petersen <bugs.digium.com@zombie.dk>

	* apps/app_dial.c: HANGUPCAUSE reason code for CANCEL is set to AST_CAUSE_NORMAL_CLEARING

	  changed that when we recive a CANCEL that we set HANGUPCAUSE to AST_CAUSE_NORMAL_CLEARING

	  ASTERISK-28053
	  Reported by: roadkill

	  Change-Id: Ib653aec2282f55b59d87484391cc07c8e6612b89

2021-11-19 02:54 +0000 [178cb0ffe4]  Alexander Traud <pabstraud@compuserve.com>

	* res: Fix for Doxygen.

	  These are the remaining issues found in /res.

	  ASTERISK-29761

	  Change-Id: I572e6019c422780dde5ce8448b6c85c77af6046d

2021-11-08 18:30 +0000 [b2e71b82e7]  Dustin Marquess <jailbird@fdf.net>

	* res_fax_spandsp: Add spandsp 3.0.0+ compatibility

	  Newer versions of spandsp did refactoring of code to add new features
	  like color FAXing. This refactoring broke backwards compatibility.
	  Add support for the new version while retaining support for 0.0.6.

	  ASTERISK-29729 #close

	  Change-Id: I3bd74550604ebcf0304528d647fa39abc62fbaa1

2021-11-19 09:47 +0000 [20d9158c9c]  Alexander Traud <pabstraud@compuserve.com>

	* main: Fix for Doxygen.

	  ASTERISK-29763

	  Change-Id: Ib8359e3590a9109eb04a5376559d040e5e21867e

2021-12-02 18:26 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.9.0-rc1 Released.

2021-12-02 11:59 +0000 [868d2d5e53]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.9.0
2021-11-28 04:29 +0000 [f946b92553]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Fix for Doxygen, the hidden parts.

	  ASTERISK-29779

	  Change-Id: If338163488498f65fa7248b60e80299c0a928e4b

2021-11-12 10:05 +0000 [751bbf4b97]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Fix grouping for latest Doxygen.

	  Since Doxygen 1.8.16, a special comment block is required. Otherwise
	  (pure C comment), the group command is ignored. Additionally, several
	  unbalanced group commands were fixed.

	  ASTERISK-29732

	  Change-Id: I4687857b9d56e6f44fd440b73af156691660202e

2021-11-25 12:41 +0000 [bcb7aee723]  Naveen Albert <asterisk@phreaknet.org>

	* documentation: Standardize examples

	  Most examples in the XML documentation use the
	  example tag to demonstrate examples, which gets
	  parsed specially in the Wiki to make it easier
	  to follow for users.

	  This fixes a few modules to use the example
	  tag instead of vanilla para tags to bring them
	  in line with the standard syntax.

	  ASTERISK-29777 #close

	  Change-Id: I9acb6cc5faf1d220e73c6dd28592371d768d279b

2021-11-28 14:52 +0000 [04ac4fe509]  Sean Bright <sean.bright@gmail.com>

	* config.c: Prevent UB in ast_realtime_require_field.

	  A backend's implementation of the realtime 'require' function may call
	  va_arg() and then fail, leaving the va_list in an undefined
	  state. Pass a copy of the va_list instead.

	  ASTERISK-29771 #close

	  Change-Id: I555565a72af84e96d49f62fe8cb66ba5a78461f4

2021-11-01 10:40 +0000 [70cdb0f9a8]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail: Refactor email generation functions

	  Refactors generic functions used for email generation
	  into utils.c so that they can be used by multiple
	  modules, including app_voicemail and app_minivm,
	  to avoid code duplication.

	  ASTERISK-29715 #close

	  Change-Id: I1de0ed3483623e9599711129edc817c45ad237ee

2021-11-25 10:34 +0000 [b290bb1251]  Alexander Traud <pabstraud@compuserve.com>

	* stir/shaken: Avoid a compiler extension of GCC.

	  ASTERISK-29776

	  Change-Id: I86e5eca66fb775a5744af0c929fb269e70575a73

2021-11-20 04:00 +0000 [858c9e1d80]  Alexander Traud <pabstraud@compuserve.com>

	* chan_misdn: Fix for Doxygen.

	  ASTERISK-29764

	  Change-Id: I6e5466cce03e25695c5c7d8b68c305184dcf5375

2021-11-23 07:45 +0000 [422f5389f6]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Remove outdated references in doxyref.h.

	  ASTERISK-29773

	  Change-Id: Ica93160d9158cc0e80c5fda829b80d1b49a6b9b9

2021-11-20 06:05 +0000 [31e385bebb]  Alexander Traud <pabstraud@compuserve.com>

	* xmldoc: Fix for Doxygen.

	  ASTERISK-29765

	  Change-Id: I654ba0debe8351038d4433716434a09370f04c9d

2021-10-28 02:28 +0000 [89237be105]  Jaco Kroon <jaco@uls.co.za>

	* logger: use __FUNCTION__ instead of __PRETTY_FUNCTION__

	  This avoids a few long-name overflows, at the cost of less instructive
	  names in the case of C++ (specifically overloaded functions and class
	  methods).  This in turn is offset against the fact that we're logging
	  the filename and line numbers in any case.

	  Change-Id: I54101a0bb5f8cb9ef63ec12c5e0d4c8edafff9ed
	  Signed-off-by: Jaco Kroon <jaco@uls.co.za>

2021-11-16 16:34 +0000 [ea941032ff]  Mike Bradeen <mbradeen@sangoma.com>

	* astobj2.c: Fix core when ref_log enabled

	  In the AO2_ALLOC_OPT_LOCK_NOLOCK case the referenced obj
	  structure is freed, but is then referenced later if ref_log is
	  enabled. The change is to store the obj->priv_data.options value
	  locally and reference it instead of the value from the freed obj

	  ASTERISK-29730

	  Change-Id: I60cc5dc1f5a4330e7ad56976fc38a42de0ab6072

2021-11-19 03:46 +0000 [3f86c95cf5]  Alexander Traud <pabstraud@compuserve.com>

	* channels: Fix for Doxygen.

	  ASTERISK-29762

	  Change-Id: Ia8811ac12b93ff8c18164699c6fbc604cb0a23f7

2021-11-16 04:06 +0000 [7d4e37a180]  Joshua C. Colp <jcolp@sangoma.com>

	* bridge: Deny full Local channel pair in bridge.

	  Local channels are made up of two pairs - the 1 and 2
	  sides. When a frame goes in one side, it comes out the
	  other. Back and forth. When both halves are in a
	  bridge this creates an infinite loop of frames.

	  This change makes it so that bridging no longer
	  allows both of these sides to exist in the same
	  bridge.

	  ASTERISK-29748

	  Change-Id: I29928b6de87cd9be996a77daccefd7c360fef651

2021-11-06 18:35 +0000 [ca2e13e18f]  Naveen Albert <asterisk@phreaknet.org>

	* res_tonedetect: Add call progress tone detection

	  Makes basic call progress tone detection available
	  in a tech-agnostic manner with the addition of the
	  ToneScan application. This can determine if the channel
	  has encountered a busy signal, SIT tones, dial tone,
	  modem, fax machine, etc. A few basic async progress
	  tone detect options are also added to the TONE_DETECT
	  function.

	  ASTERISK-29720 #close

	  Change-Id: Ia02437e0450473031e294798b8cb421fb8f24e90

2021-11-08 13:59 +0000 [70b14f3eda]  Boris P. Korzun <drtr0jan@yandex.ru>

	* rtp_engine: Add type field for JSON RTCP Report stasis messages

	  ASTERISK-29727 #close

	  Change-Id: I2eca8aeb591cb63ac2238d08eab662367453cb82

2021-11-17 03:24 +0000 [783b775946]  Alexander Traud <pabstraud@compuserve.com>

	* odbc: Fix for Doxygen.

	  ASTERISK-29754

	  Change-Id: Ia09eb68d283d201d9a6fbeccfc0efe83fe0502a5

2021-11-17 02:54 +0000 [c549eda0a7]  Alexander Traud <pabstraud@compuserve.com>

	* parking: Fix for Doxygen.

	  ASTERISK-29753

	  Change-Id: I7a61974584f6169502e6860fc711919fe7bbfaa7

2021-11-17 05:43 +0000 [b4eebfa191]  Alexander Traud <pabstraud@compuserve.com>

	* ari-stubs: Avoid 'is' as comparism with an literal.

	  Python 3.9.7 gave a syntax warning.

	  Change-Id: I3e3a982fe720726bc0015bcdb0e638a626ec89d4

2021-11-17 04:26 +0000 [b5962fe528]  Alexander Traud <pabstraud@compuserve.com>

	* frame: Fix for Doxygen.

	  ASTERISK-29755

	  Change-Id: I8240013ec3db0669c0acf67e26bf6c9cbb5b72af

2021-11-17 06:18 +0000 [5b5a9ea4f0]  Alexander Traud <pabstraud@compuserve.com>

	* res_ari: Fix for Doxygen.

	  ASTERISK-29756

	  Change-Id: I2f1c1eea1c902492b77b74de9950f20ebbb7e758

2021-11-16 12:07 +0000 [e27b91d542]  Alexander Traud <pabstraud@compuserve.com>

	* channel: Fix for Doxygen.

	  ASTERISK-29751

	  Change-Id: Ie04da5029c57ebee44733bdf05013156abe80176

2021-11-08 10:08 +0000 [53610679bf]  Alexander Traud <pabstraud@compuserve.com>

	* BuildSystem: Consistently allow 'ye' even for Jansson.

	  Furthermore, consistently use not 'No' but ':' for non-existent file
	  paths. Finally, use the same pattern for checking file paths:
	    a)  = ":"
	    b) != "x:"

	  Change-Id: I0c80c76d2cc98b0e5c859131290f4e3141a1a544

2021-11-16 10:26 +0000 [6988386234]  Alexander Traud <pabstraud@compuserve.com>

	* stasis: Fix for Doxygen.

	  ASTERISK-29750

	  Change-Id: Iea50173e785b2e9d49bc24c0af7111cfd96d44a9

2021-11-17 02:30 +0000 [e7d5db1471]  Alexander Traud <pabstraud@compuserve.com>

	* app: Fix for Doxygen.

	  ASTERISK-29752

	  Change-Id: If40cbd01d47a6cfd620b18206dedb8460216c8af

2021-11-16 06:51 +0000 [31c26fcbc6]  Alexander Traud <pabstraud@compuserve.com>

	* res_xmpp: Fix for Doxygen.

	  ASTERISK-29749

	  Change-Id: I7885793b63bdeaa883e76edb899bbba9660eb1c5

2021-11-15 07:38 +0000 [026c6d51b1]  Alexander Traud <pabstraud@compuserve.com>

	* addons: Fix for Doxygen.

	  ASTERISK-29742

	  Change-Id: Ie752cb9638ced1ebe3a55d710c6c18ef6bd0aafc

2021-11-16 03:55 +0000 [bae495601a]  Alexander Traud <pabstraud@compuserve.com>

	* res_pjsip: Fix for Doxygen.

	  ASTERISK-29747

	  Change-Id: Ic7a1e9453f805a6264fe86c96b7d18b87b376084

2021-11-13 06:04 +0000 [cb043633d4]  Alexander Traud <pabstraud@compuserve.com>

	* chan_iax2: Fix for Doxygen.

	  ASTERISK-29737

	  Change-Id: I282003cc553989fd5c19ceeac9e478fa4ee06cec

2021-11-15 08:12 +0000 [42055f4a65]  Alexander Traud <pabstraud@compuserve.com>

	* bridges: Fix for Doxygen.

	  ASTERISK-29743

	  Change-Id: I6e1bbbaa5875e19994a328ab40a5d429c6010e8b

2021-11-15 07:29 +0000 [1a9df88d98]  Alexander Traud <pabstraud@compuserve.com>

	* tests: Fix for Doxygen.

	  ASTERISK-29741

	  Change-Id: I012d72b237bda2ef2d0f86307dfc6dc7add4b54b

2021-11-15 07:18 +0000 [09bac49a01]  Alexander Traud <pabstraud@compuserve.com>

	* apps: Fix for Doxygen.

	  ASTERISK-29740

	  Change-Id: Icb6fbcfea0a5f1c82caa5001902b6a786adbf307

2021-11-12 12:41 +0000 [44a9c16e9c]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Avoid 'name' with Doxygen \file.

	  Fixes four misuses of the parameter 'name'. Additionally, for
	  consistency and to avoid such an issue in future, those few other
	  places, which used '\file name', were changed just to '\file'. Then,
	  Doxygen uses the name of the current file.

	  ASTERISK-29733

	  Change-Id: I0c18b4c863c6988b138c77448057349a9ee7052d

2021-11-13 04:40 +0000 [d08792ceba]  Alexander Traud <pabstraud@compuserve.com>

	* bridge_channel: Fix for Doxygen.

	  ASTERISK-29736

	  Change-Id: Ia5370289e6526001a6b52754b533bcea1a9d7e5c

2021-11-12 13:52 +0000 [57b4956a8a]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Avoid multiple use of section labels.

	  ASTERISK-29735

	  Change-Id: I56935e73f7bd1d4ae2721d11040f4835da64b810

2021-11-12 13:17 +0000 [23b16c5372]  Alexander Traud <pabstraud@compuserve.com>

	* progdocs: Use Doxygen \example correctly.

	  ASTERISK-29734

	  Change-Id: I83b51e85cd71867645ab3a8a820f8fd1f065abd2

2021-10-30 20:04 +0000 [4bc3dc6543]  Josh Soref <jsoref@users.noreply.github.com>

	* bridges: Spelling fixes

	  Correct typos of the following word families:

	  multiplication
	  potentially
	  iteration
	  interaction
	  virtual
	  synthesis
	  convolve
	  initializes
	  overlap

	  ASTERISK-29714

	  Change-Id: Ia40f1aca8f2996ab407c6ed9d24cb10a67c6684b
	  (cherry picked from commit 2a8fb4695ef87c363fc49f142b696ceed85a7f98)

2021-11-15 13:02 +0000 [721026ff37]  Naveen Albert <asterisk@phreaknet.org>

	* app_morsecode: Fix deadlock

	  Fixes a deadlock in app_morsecode caused by locking
	  the channel twice when reading variables from the
	  channel. The duplicate lock is simply removed.

	  ASTERISK-29744 #close

	  Change-Id: I204000701f123361d7f85e0498fedc90243c75e4

2021-10-24 13:38 +0000 [1cd2584b27]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_callerid: Fix OLI parsing

	  Fix parsing of ANI2/OLI information, since it was previously
	  parsing the user, when it should have been parsing other_param.

	  Also improves the parsing by using pjproject native functions
	  rather than trying to parse the parameters ourselves like
	  chan_sip did. A previous attempt at this caused a crash, but
	  this works correctly now.

	  ASTERISK-29703 #close

	  Change-Id: I8f3c79032d9ea1a21d16f8e11f22bd8d887738a1

2021-10-25 12:51 +0000 [3c4b7cef64]  Naveen Albert <asterisk@phreaknet.org>

	* app_read: Fix custom terminator functionality regression

	  Currently, when the t option is specified with no arguments,
	  the # character is still treated as a terminator, even though
	  no character should be treated as a terminator.

	  This is because a previous regression fix was modified to
	  remove the use of NULL as a default altogether. However,
	  NULL and an empty string actually refer to different
	  arrangements and should be treated differently. NULL is the
	  default terminator (#), while an empty string removes the
	  terminator altogether. This is the behavior being used by
	  the rest of the core.

	  Additionally, since S_OR catches empty strings as well as
	  NULL (not intended), this is changed to a ternary operator
	  instead, which fixes the behavior.

	  ASTERISK-29705 #close

	  Change-Id: I9b6b72196dd04f5b1e0ab5aa1b0adf627725e086

2021-10-30 20:04 +0000 [59715a073b]  Josh Soref <jsoref@users.noreply.github.com>

	* utils: Spelling fixes

	  Correct typos of the following word families:

	  command-line
	  immediately
	  extensions
	  momentarily
	  mustn't
	  numbered
	  bytes
	  caching

	  ASTERISK-29714

	  Change-Id: I8b2b125c5d4d2f9e87a58515c97468ad47ca44f8

2021-10-30 20:04 +0000 [3685e55673]  Josh Soref <jsoref@users.noreply.github.com>

	* pbx: Spelling fixes

	  Correct typos of the following word families:

	  process
	  populate
	  with
	  africa
	  accessing
	  contexts
	  exercise
	  university
	  organizations
	  withhold
	  maintaining
	  independent
	  rotation
	  ignore
	  eventname

	  ASTERISK-29714

	  Change-Id: I90eacc5bc3dcf75a9c898cfb85164f37dec08345

2021-10-30 20:04 +0000 [4cf87f6175]  Josh Soref <jsoref@users.noreply.github.com>

	* rest-api-templates: Spelling fixes

	  Correct typos of the following word families:

	  overwritten
	  descendants

	  ASTERISK-29714

	  Change-Id: I2307e35887a3437e50317a4b86f0893f25f9fd3b

2021-10-30 20:04 +0000 [c1b21bee6d]  Josh Soref <jsoref@users.noreply.github.com>

	* channels: Spelling fixes

	  Correct typos of the following word families:

	  appease
	  permanently
	  overriding
	  residue
	  silliness
	  extension
	  channels
	  globally
	  reference
	  japanese
	  group
	  coordinate
	  registry
	  information
	  inconvenience
	  attempts
	  cadence
	  payloads
	  presence
	  provisioning
	  mimics
	  behavior
	  width
	  natively
	  syslabel
	  not owning
	  unquelch
	  mostly
	  constants
	  interesting
	  active
	  unequipped
	  brodmann
	  commanding
	  backlogged
	  without
	  bitstream
	  firmware
	  maintain
	  exclusive
	  practically
	  structs
	  appearance
	  range
	  retransmission
	  indication
	  provisional
	  associating
	  always
	  whether
	  cyrillic
	  distinctive
	  components
	  reinitialized
	  initialized
	  capability
	  switches
	  occurring
	  happened
	  outbound

	  ASTERISK-29714

	  Change-Id: Ife52ee89cd2170b684fa651ca72b1cb911a57339

2021-10-30 20:04 +0000 [4fc59ccc92]  Josh Soref <jsoref@users.noreply.github.com>

	* tests: Spelling fixes

	  Correct typos of the following word families:

	  mounting
	  jitterbuffer
	  thrashing
	  original
	  manipulating
	  entries
	  actual
	  possibility
	  tasks
	  options
	  positives
	  taskprocessor
	  other
	  dynamic
	  declarative

	  ASTERISK-29714

	  Change-Id: I6b94659d045eec5d8d020fce2e9b6e2f593dfeb6

2021-10-30 20:04 +0000 [c3978efef6]  Josh Soref <jsoref@users.noreply.github.com>

	* Makefile: Spelling fixes

	  Correct typos of the following word families:

	  libraries
	  install
	  overwrite

	  ASTERISK-29714

	  Change-Id: I6488814f79186d6c23dfd7b7f9bba0a046126174

2021-10-30 20:04 +0000 [2a8b651b7e]  Josh Soref <jsoref@users.noreply.github.com>

	* contrib: Spelling fixes

	  Correct typos of the following word families:

	  standard
	  increase
	  comments
	  valgrind
	  promiscuous
	  editing
	  libtonezone
	  storage
	  aggressive
	  whitespace
	  russellbryant
	  consecutive
	  peternixon

	  ASTERISK-29714

	  Change-Id: I9cafbf41b579c9c0c84c81719d2c4f900beec245

2021-10-30 20:04 +0000 [3ac7afe09c]  Josh Soref <jsoref@users.noreply.github.com>

	* formats: Spelling fixes

	  Correct typos of the following word families:

	  truncate

	  ASTERISK-29714

	  Change-Id: I6507760c72b919873cff7cac22b3781036cd4955

2021-10-30 20:04 +0000 [49ef881eb4]  Josh Soref <jsoref@users.noreply.github.com>

	* addons: Spelling fixes

	  Correct typos of the following word families:

	  definition
	  listener
	  fastcopy
	  logical
	  registration
	  classify
	  documentation
	  explicitly
	  dialed
	  endpoint
	  elements
	  arithmetic
	  might
	  prepend
	  byte
	  terminal
	  inquiry
	  skipping
	  aliases
	  calling
	  absent
	  authentication
	  transmit
	  their
	  ericsson
	  disconnecting
	  redir
	  items
	  client
	  adapter
	  transmitter
	  existing
	  satisfies
	  pointer
	  interval
	  supplied

	  ASTERISK-29714

	  Change-Id: I8548438246f7b718d88e0b9e0a1eb384bbec88e4

2021-10-30 20:04 +0000 [70af726dcd]  Josh Soref <jsoref@users.noreply.github.com>

	* agi: Spelling fixes

	  Correct typos of the following word families:

	  pretend
	  speech

	  ASTERISK-29714

	  Change-Id: I7d0527c329cda07552247ea11b2d7db207a3d87d

2021-10-30 20:04 +0000 [c0fafa1863]  Josh Soref <jsoref@users.noreply.github.com>

	* funcs: Spelling fixes

	  Correct typos of the following word families:

	  effectively
	  emitted
	  expect
	  anthony

	  ASTERISK-29714

	  Change-Id: Ic16f9ec855bb6d14ec8e170b90af9a36b06d488a

2021-10-30 20:04 +0000 [8fb9588e8c]  Josh Soref <jsoref@users.noreply.github.com>

	* build_tools: Spelling fixes

	  Correct typos of the following word families:

	  binutils

	  ASTERISK-29714

	  Change-Id: I2f676ab48cd50edc400c43307cb53679e4c09b97

2021-10-30 20:04 +0000 [7a59a9365a]  Josh Soref <jsoref@users.noreply.github.com>

	* menuselect: Spelling fixes

	  Correct typos of the following word families:

	  dependency
	  unless
	  random
	  dependencies
	  delimited
	  randomly
	  modules

	  ASTERISK-29714

	  Change-Id: I3920603a8dc7c0a1852d2f885e06b1144692d40e

2021-10-30 20:04 +0000 [b13acf3ae6]  Josh Soref <jsoref@users.noreply.github.com>

	* include: Spelling fixes

	  Correct typos of the following word families:

	  activities
	  forward
	  occurs
	  unprepared
	  association
	  compress
	  extracted
	  doubly
	  callback
	  prometheus
	  underlying
	  keyframe
	  continue
	  convenience
	  calculates
	  ignorepattern
	  determine
	  subscribers
	  subsystem
	  synthetic
	  applies
	  example
	  manager
	  established
	  result
	  microseconds
	  occurrences
	  unsuccessful
	  accommodates
	  related
	  signifying
	  unsubscribe
	  greater
	  fastforward
	  itself
	  unregistering
	  using
	  translator
	  sorcery
	  implementation
	  serializers
	  asynchronous
	  unknowingly
	  initialization
	  determining
	  category
	  these
	  persistent
	  propagate
	  outputted
	  string
	  allocated
	  decremented
	  second
	  cacheability
	  destructor
	  impaired
	  decrypted
	  relies
	  signaling
	  based
	  suspended
	  retrieved
	  functions
	  search
	  auth
	  considered

	  ASTERISK-29714

	  Change-Id: I542ce887a16603f886a915920d5710d4a0a1358d

2021-10-30 20:04 +0000 [135d51e55e]  Josh Soref <jsoref@users.noreply.github.com>

	* doc: Spelling fixes

	  Correct typos of the following word families:

	  transparent
	  roughly

	  ASTERISK-29714

	  Change-Id: I2b90c68dfde4aa3f0d58f64f8187465336acb1b3

2021-10-30 20:04 +0000 [ae83d927d8]  Josh Soref <jsoref@users.noreply.github.com>

	* configs: Spelling fixes

	  Correct typos of the following word families:

	  password
	  excludes
	  undesirable
	  checksums
	  through
	  screening
	  interpreting
	  database
	  causes
	  initiation
	  member
	  busydetect
	  defined
	  severely
	  throughput
	  recognized
	  counter
	  require
	  indefinitely
	  accounts

	  ASTERISK-29714

	  Change-Id: Ie8f2a7b274a162dd627ee6a2165f5e8a3876527e

2021-10-30 20:04 +0000 [dcf492e7b6]  Josh Soref <jsoref@users.noreply.github.com>

	* res: Spelling fixes

	  Correct typos of the following word families:

	  identifying
	  structures
	  actcount
	  initializer
	  attributes
	  statement
	  enough
	  locking
	  declaration
	  userevent
	  provides
	  unregister
	  session
	  execute
	  searches
	  verification
	  suppressed
	  prepared
	  passwords
	  recipients
	  event
	  because
	  brief
	  unidentified
	  redundancy
	  character
	  the
	  module
	  reload
	  operation
	  backslashes
	  accurate
	  incorrect
	  collision
	  initializing
	  instance
	  interpreted
	  buddies
	  omitted
	  manually
	  requires
	  queries
	  generator
	  scheduler
	  configuration has
	  owner
	  resource
	  performed
	  masquerade
	  apparently
	  routable

	  ASTERISK-29714

	  Change-Id: I88485116d2c59b776aa2e1f8b4ce8239a21decda

2021-10-30 20:04 +0000 [ccfebc3cfc]  Josh Soref <jsoref@users.noreply.github.com>

	* codecs: Spelling fixes

	  Correct typos of the following word families:

	  voiced
	  denumerator
	  codeword
	  upsampling
	  constructed
	  residual
	  subroutine
	  conditional
	  quantizing
	  courtesy
	  number

	  ASTERISK-29714

	  Change-Id: I471fb8086a5277d8f05047fedee22cfa97a4252d

2021-10-30 20:04 +0000 [4019a93edf]  Josh Soref <jsoref@users.noreply.github.com>

	* main: Spelling fixes

	  Correct typos of the following word families:

	  analysis
	  nuisance
	  converting
	  although
	  transaction
	  desctitle
	  acquire
	  update
	  evaluate
	  thousand
	  this
	  dissolved
	  management
	  integrity
	  reconstructed
	  decrement
	  further on
	  irrelevant
	  currently
	  constancy
	  anyway
	  unconstrained
	  featuregroups
	  right
	  larger
	  evaluated
	  encumbered
	  languages
	  digits
	  authoritative
	  framing
	  blindxfer
	  tolerate
	  traverser
	  exclamation
	  perform
	  permissions
	  rearrangement
	  performing
	  processing
	  declension
	  happily
	  duplicate
	  compound
	  hundred
	  returns
	  elicit
	  allocate
	  actually
	  paths
	  inheritance
	  atxferdropcall
	  earlier
	  synchronization
	  multiplier
	  acknowledge
	  across
	  against
	  thousands
	  joyous
	  manipulators
	  guaranteed
	  emulating
	  soundfile

	  ASTERISK-29714

	  Change-Id: I926ba4b11e9f6dd3fdd93170ab1f9b997910be70

2021-10-30 20:04 +0000 [998ad0e179]  Josh Soref <jsoref@users.noreply.github.com>

	* CREDITS: Spelling fixes

	  Correct typos of the following word families:

	  contributors

	  ASTERISK-29714

	  Change-Id: I6f46dae8bf8125a21ce8ff318380b2b412d9d2f9

2021-10-30 20:04 +0000 [e7b1dcf769]  Josh Soref <jsoref@users.noreply.github.com>

	* apps: Spelling fixes

	  Correct typos of the following word families:

	  simultaneously
	  administrator
	  directforward
	  attachfmt
	  dailplan
	  automatically
	  applicable
	  nouns
	  explicit
	  outside
	  sponsored
	  attachment
	  audio
	  spied
	  doesn't
	  counting
	  encoded
	  implements
	  recursively
	  emailaddress
	  arguments
	  queuerules
	  members
	  priority
	  output
	  advanced
	  silencethreshold
	  brazilian
	  debugging
	  argument
	  meadmin
	  formatting
	  integrated
	  sneakiness

	  ASTERISK-29714

	  Change-Id: Ie5ecaec91c00b26309da4e51cfc0991a5bb7d092

2021-10-30 20:04 +0000 [0150c3b698]  Josh Soref <jsoref@users.noreply.github.com>

	* UPGRADE.txt: Spelling fixes

	  Correct typos of the following word families:

	  themselves
	  support
	  received

	  ASTERISK-29714

	  Change-Id: Ibd0a7996d5801c754d3d44fba31fe788a13dba95

2021-10-30 20:04 +0000 [42d1c134f7]  Josh Soref <jsoref@users.noreply.github.com>

	* CHANGES: Spelling fixes

	  Correct typos of the following word families:

	  issuing
	  execution
	  bridging
	  alert
	  respective
	  unlikely
	  confbridge
	  offered
	  negotiation
	  announced
	  engineer
	  systems
	  inherited
	  passthrough
	  functionality
	  supporting
	  conflicts
	  semantically
	  monitor
	  specify
	  specifiable

	  ASTERISK-29714

	  Change-Id: Ia6b1cf634f52c5f7b1b8769dc54dae78106ed98c

2021-11-08 07:00 +0000 [301647788e]  George Joseph <gjoseph@digium.com>

	* CI: Rename 'master' node to 'built-in'

	  Jenkins renamed the 'master' node to 'built-in' in version
	  2.319 so we have to adjust as well.

	  Change-Id: Ice663c3a66d0eedf76e8e5fe530328455991ec25

2021-11-08 08:08 +0000 [608e52c939]  Alexander Traud <pabstraud@compuserve.com>

	* BuildSystem: In POSIX sh, == in place of = is undefined.

	  ASTERISK-29724

	  Change-Id: I59aa0e52effdc16992f3a736ccf73430a6ef135b

2021-10-24 06:55 +0000 [36c5f5e5fa]  Naveen Albert <asterisk@phreaknet.org>

	* sig_analog: Fix truncated buffer copy

	  Fixes compiler warning caused by a truncated copy of the ANI2 into a
	  buffer of size 10. This could prevent the null terminator from being
	  copied if the copy value exceeds the size of the buffer. This increases
	  the buffer size to 101 to ensure there is no way for truncation to occur.

	  ASTERISK-29702 #close

	  Change-Id: Ief9052212952840fa44de6463b8699fdb3e163d0

2021-11-08 09:01 +0000 [e63461b008]  Sean Bright <sean.bright@gmail.com>

	* pbx.c: Don't remove dashes from hints on reload.

	  When reloading dialplan, hints created dynamically would lose any dash
	  characters. Now we ignore those dashes if we are dealing with a hint
	  during a reload.

	  ASTERISK-28040 #close

	  Change-Id: I95e48f5a268efa3c6840ab69798525d3dce91636

2021-10-24 07:31 +0000 [92857e70b6]  Naveen Albert <asterisk@phreaknet.org>

	* app_voicemail: Fix phantom voicemail bug on rerecord

	  If users are able to press # for options while leaving
	  a message and then press 3 to rerecord the message, if
	  the caller hangs up during the rerecord prompt but before
	  Asterisk starts recording a message, then an "empty"
	  voicemail gets processed whereby an email gets sent out
	  notifying the user of a 0:00 duration message. The file
	  doesn't actually exist, so playback will fail since there
	  was no message to begin with.

	  This adds a check after the streaming of the rerecord
	  announcement to see if the caller has hung up. If so,
	  we bail out early so that we can clean up properly.

	  ASTERISK-29391 #close

	  Change-Id: Id965d72759a2fd3b39afb76fec08aaebebe75c31

2021-10-25 19:47 +0000 [bea08a563b]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Allow both secret and outkey at dial time

	  Historically, the dial syntax for IAX2 has held that
	  an outkey (used only for RSA authenticated calls)
	  and a secret (used only for plain text and MD5 authenticated
	  calls, historically) were mutually exclusive, and thus
	  the same position in the dial string was used for both
	  values.

	  Now that encryption is possible with RSA authentication,
	  this poses a limitation, since encryption requires a
	  secret and RSA authentication requires an outkey. Thus,
	  the dial syntax is extended so that both a secret and
	  an outkey can be specified.

	  The new extended syntax is backwards compatible with the
	  old syntax. However, a secret can now be specified after
	  the outkey, or the outkey can be specified after the secret.
	  This makes it possible to spawn an encrypted RSA authenticated
	  call without a corresponding peer being predefined in iax.conf.

	  ASTERISK-29707 #close

	  Change-Id: I1f8149313ed760169d604afbb07720a8b07dd00e

2021-10-28 07:09 +0000 [95da40cd50]  Alexander Traud <pabstraud@compuserve.com>

	* res_snmp: As build tool, prefer pkg-config over net-snmp-config.

	  ASTERISK-29709

	  Change-Id: Ie169df878bdfc3a06b3097c5c38d185b480f54d4

2021-10-28 07:41 +0000 [8b76a3cd3b]  Alexander Traud <pabstraud@compuserve.com>

	* stasis: Avoid 'dispatched' as unused variable in normal mode.

	  ASTERISK-29710

	  Change-Id: Ia849f1172e4e694c5d5d7f0cad449f936ee12216

2021-10-29 10:05 +0000 [2c03f73016]  Sean Bright <sean@seanbright.com>

	* various: Fix GCC 11.2 compilation issues.

	  * Initialize some variables that are never used anyway.

	  * Use valid pointers instead of integers cast to void pointers when
	    calling pthread_setspecific().

	  ASTERISK-29711 #close
	  ASTERISK-29713 #close

	  Change-Id: I8728cd6f2f4b28e0e48113c5da450b768c2a6683

2021-09-09 09:39 +0000 [08cb67251f]  George Joseph <gjoseph@digium.com>

	* ast_coredumper:  Refactor to better find things

	  The search for a running asterisk when --running is used
	  has been greatly simplified and in the event it doesn't
	  work, you can now specify a pid to use on the command
	  line with --pid.

	  The search for asterisk modules when --tarball-coredumps
	  is used has been enhanced to have a better chance of finding
	  them and in the event it doesn't work, you can now specify
	  --libdir on the command line to indicate the library directory
	  where they were installed.

	  The DATEFORMAT variable was renamed to DATEOPTS and is now
	  passed to the 'date' utility rather than running DATEFORMAT
	  as a command.

	  The coredump and output files are now renamed with DATEOPTS.
	  This can be disabled by specifying --no-rename.

	  Several confusing and conflicting options were removed:
	  --append-coredumps
	  --conffile
	  --no-default-search
	  --tarball-uniqueid

	  The script was re-structured to make it easier for follow.

	  Change-Id: I674be64bdde3ef310b6a551d4911c3b600ffee59

2021-10-21 12:29 +0000 [ae97aaedb0]  Kevin Harwell <kharwell@sangoma.com>

	* strings/json: Add string delimter match, and object create with vars methods

	  Add a function to check if there is an exact match a one string between
	  delimiters in another string.

	  Add a function that will create an ast_json object out of a list of
	  Asterisk variables. An excludes string can also optionally be passed
	  in.

	  Also, add a macro to make it easier to get object integers.

	  Change-Id: I5f34f18e102126aef3997f19a553a266d70d6226

2021-09-21 12:09 +0000 [2e55c0fded]  Ben Ford <bford@digium.com>

	* STIR/SHAKEN: Option split and response codes.

	  The stir_shaken configuration option now has 4 different choices to pick
	  from: off, attest, verify, and on. Off and on behave the same way they
	  do now. Attest will only perform attestation on the endpoint, and verify
	  will only perform verification on the endpoint.

	  Certain responses are required to be sent based on certain conditions
	  for STIR/SHAKEN. For example, if we get a Date header that is outside of
	  the time range that is considered valid, a 403 Stale Date response
	  should be sent. This and several other responses have been added.

	  Change-Id: I4ac1ecf652cd0e336006b0ca638dc826b5b1ebf7

2021-08-25 08:15 +0000 [a203769c9d]  Rodrigo Ramírez Norambuena <a@rodrigoramirez.com>

	* app_queue: Add LoginTime field for member in a queue.

	  Add a time_t logintime to storage a time when a member is added into a
	  queue.

	  Also, includes show this time (in seconds) using a 'queue show' command
	  and the field LoginTime for response for AMI events.

	  ASTERISK-18069 #close

	  Change-Id: Ied6c3a300f78d78eebedeb3e16a1520fc3fff190

2021-10-21 12:49 +0000 [859f579504]  Kevin Harwell <kharwell@sangoma.com>

	* res_speech: Add a type conversion, and new engine unregister methods

	  Add a new function that converts a speech results type to a string.
	  Also add another function to unregister an engine, but returns a
	  pointer to the unregistered engine object instead of a success/fail
	  integer.

	  Change-Id: I0f7de17cb411021c09fb03988bc2b904e1380192

2021-10-07 13:07 +0000 [0b2646aee6]  Mike Bradeen <mbradeen@sangoma.com>

	* various: Fix GCC 11 compilation issues.

	  test_voicemail_api: Use empty char* for empty_msg_ids.
	  chan_skinny: Fix size of calledParty to be maximum extension.
	  menuselect: Change Makefile to stop deprecated warnings. Added comments
	  test_linkedlist: 'bogus' variable was manually allocated from a macro
	  and the test fails if this happens but the compiler couldn't 'see' this
	  and returns a warning. memset to all 0's after allocation.
	  chan_ooh323: Fixed various indentation issues that triggered misleading
	   indentation warnings.

	  ASTERISK-29682
	  Reported by: George Joseph

	  Change-Id: If4fe42222c8444dc16828a42731ee53b4ce5cbbe

2021-09-20 11:10 +0000 [63c8d12e95]  Shloime Rosenblum <shloimerosenblum@gmail.com>

	* apps/app_playback.c: Add 'mix' option to app_playback

	  I am adding a mix option that will play by filename and say.conf unlike
	  say option that will only play with say.conf. It
	  will look on the format of the name, if it is like say it play with
	  say.conf if not it will play the file name.

	  ASTERISK-29662

	  Change-Id: I815816916a308f0fa8f165140dc15772dcbd547a

2021-10-19 11:35 +0000 [c07e3c2f4d]  George Joseph <gjoseph@digium.com>

	* BuildSystem: Check for alternate openssl packages

	  OpenSSL is one of those packages that often have alternatives
	  with later versions.  For instance, CentOS/EL 7 has an
	  openssl package at version 1.0.2 but there's an openssl11
	  package from the epel repository that has 1.1.1.  This gets
	  installed to /usr/include/openssl11 and /usr/lib64/openssl11.
	  Unfortunately, the existing --with-ssl and --with-crypto
	  ./configure options expect to point to a source tree and
	  don't work in this situation.  Also unfortunately, the
	  checks in ./configure don't use pkg-config.

	  In order to make this work with the existing situation, you'd
	  have to run...
	  ./configure --with-ssl=/usr/lib64/openssl11 \
	      --with-crypto=/usr/lib64/openssl11 \
	      CFLAGS=-I/usr/include/openssl11

	  BUT...  those options don't get passed down to bundled pjproject
	  so when you run make, you have to include the CFLAGS again
	  which is a big pain.

	  Oh...  To make matters worse, although you can specify
	  PJPROJECT_CONFIGURE_OPTS on the ./configure command line,
	  they don't get saved so if you do a make clean, which will
	  force a re-configure of bundled pjproject, those options
	  don't get used.

	  So...

	  * In configure.ac... Since pkg-config is installed by install_prereq
	    anyway, we now use it to check for the system openssl >= 1.1.0.
	    If that works, great.  If not, we check for the openssl11
	    package. If that works, great.  If not, we fall back to just
	    checking for any openssl.  If pkg-config isn't installed for some
	    reason, or --with-ssl=<dir> or --with-crypto=<dir> were specified
	    on the ./configure command line, we fall back to the existing
	    logic that uses AST_EXT_LIB_CHECK().

	  * The whole OpenSSL check process has been moved up before
	    THIRD_PARTY_CONFIGURE(), which does the initial pjproject
	    bundled configure, is run.  This way the results of the above
	    checks, which may result in new include or library directories,
	    is included.

	  * Although not strictly needed for openssl, We now save the value of
	    PJPROJECT_CONFIGURE_OPTS in the makeopts file so it can be used
	    again if a re-configure is triggered.

	  ASTERISK-29693

	  Change-Id: I341ab7603e6b156aa15a66f43675ac5029d5fbde

2021-10-14 14:38 +0000 [8c2720e540]  Sean Bright <sean.bright@gmail.com>

	* func_talkdetect.c: Fix logical errors in silence detection.

	  There are 3 separate changes here:

	  1. The documentation erroneously stated that the dsp_talking_threshold
	     argument was a number of milliseconds when it is actually an energy
	     level used by the DSP code to classify talking vs. silence.

	  2. Fixes a copy paste error in the argument handling code.

	  3. Don't erroneously switch to the talking state if we aren't actively
	     handling a frame we've classified as talking.

	  Patch inspired by one provided by Moritz Fain (License #6961).

	  ASTERISK-27816 #close

	  Change-Id: I5953fd570b98b49c41cee55bfe3b941753fb2511

2021-10-14 10:15 +0000 [e3466893e9]  Sebastien Duthil <sduthil@wazo.community>

	* main/stun.c: fix crash upon STUN request timeout

	  Some ast_stun_request users do not provide a destination address when
	  sending to a connection-mode socket.

	  ASTERISK-29691

	  Change-Id: Idd9114c3380216ba48abfc3c68619e79ad37defc

2021-10-12 13:17 +0000 [bac66e9743]  Mike Bradeen <mbradeen@sangoma.com>

	* build: prevent binary downloads for non x86 architectures

	  download_externals: Add check for i686 and i386 (in addition
	  to the current x86_64) and exit if not one of the three.

	  ASTERISK-26497

	  Change-Id: Ia4d429fcefa5b2f5b6e99159d4607de8e8325b2f

2021-10-11 14:04 +0000 [482281deff]  Sean Bright <sean.bright@gmail.com>

	* configure: Remove unused OpenSSL SRTP check.

	  Discovered while looking at ASTERISK~29684. Usage was removed in change
	  I3c77c7b00b2ffa2e935632097fa057b9fdf480c0.

	  Change-Id: Iaf2f7a16ea5a7eee6375319347e4b40b8e7b10e3

2021-10-13 10:26 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.8.0-rc1 Released.

2021-10-13 05:21 +0000 [9063680148]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.8.0
2021-10-07 12:50 +0000 [804b1987fb]  Sean Bright <sean.bright@gmail.com>

	* Makefile: Use basename in a POSIX-compliant way.

	  If you aren't using GNU coreutils, chances are that your basename
	  doesn't know about the -s argument. Luckily for us, basename does what
	  we need it do even without the -s argument.

	  Change-Id: I8b81a429bb037b997ee6640ff8a2b5e860962bb7

2021-10-05 19:59 +0000 [e091aa2763]  Mark Murawski <markm@intellasoft.net>

	* pbx_ael:  Fix crash and lockup issue regarding 'ael reload'

	  Avoid infinite recursion and crash

	  Change-Id: I8ed05ec3aa2806c50c77edc5dd0cd4e4fa08b3f4

2021-05-24 13:04 +0000 [437b2bfbd6]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Add encryption for RSA authentication

	  Adds support for encryption to RSA-authenticated
	  calls. Also prevents crashes if an RSA IAX2 call
	  is initiated to a switch requiring encryption
	  but no secret is provided.

	  ASTERISK-20219

	  Change-Id: I18f1f9d7c59b4f9cffa00f3b94a4c875846efd40

2021-07-19 11:34 +0000 [15e432220c]  Matthew Kern <mkern@alconconstruction.com>

	* res_pjsip_t38: bind UDPTL sessions like RTP

	  In res_pjsip_sdp_rtp, the bind_rtp_to_media_address option and the
	  fallback use of the transport's bind address solve problems sending
	  media on systems that cannot send ipv4 packets on ipv6 sockets, and
	  certain other situations. This change extends both of these behaviors
	  to UDPTL sessions as well in res_pjsip_t38, to fix fax-specific
	  problems on these systems, introducing a new option
	  endpoint/t38_bind_udptl_to_media_address.

	  ASTERISK-29402

	  Change-Id: I87220c0e9cdd2fe9d156846cb906debe08c63557

2021-09-29 12:58 +0000 [5a6f140765]  Naveen Albert <asterisk@phreaknet.org>

	* app_read: Fix null pointer crash

	  If the terminator character is not explicitly specified
	  and an indications tone is used for reading a digit,
	  there is no null pointer check so Asterisk crashes.
	  This prevents null usage from occuring.

	  ASTERISK-29673 #close

	  Change-Id: Ie941833e123c3dbfb88371b5de5edbbe065514ac

2021-09-29 04:32 +0000 [0ab4e7491d]  Jean Aunis <jean.aunis@prescom.fr>

	* res_rtp_asterisk: fix memory leak

	  Add missing reference decrement in rtp_deallocate_transport()

	  ASTERISK-29671

	  Change-Id: I8d22dbedb90e8dade0829b7a28372f404b07caa9

2021-09-19 15:08 +0000 [29c44caecb]  Shloime Rosenblum <shloimerosenblum@gmail.com>

	* main/say.c: Support future dates with Q and q format params

	  The current versions do not support future dates in all say application when using the 'Q' or 'q' format parameter and says "today" for everything that is greater than today

	  ASTERISK-29637

	  Change-Id: I1fb1cef0ce3c18d87b1fc94ea309d13bc344af02

2021-07-21 16:36 +0000 [4368764032]  Joseph Nadiv <ynadiv@corpit.xyz>

	* res_pjsip_registrar: Remove unavailable contacts if exceeds max_contacts

	  The behavior of max_contacts and remove_existing are connected.  If
	  remove_existing is enabled, the soonest expiring contacts are removed.
	  This may occur when there is an unavailable contact.  Similarly,
	  when remove_existing is not enabled, registrations from good
	  endpoints are rejected in favor of retaining unavailable contacts.

	  This commit adds a new AOR option remove_unavailable, and the effect
	  of this setting will depend on remove_existing.  If remove_existing
	  is set to no, we will still remove unavailable contacts when they
	  exceed max_contacts, if there are any. If remove_existing is set to
	  yes, we will prioritize the removal of unavailable contacts before
	  those that are expiring soonest.

	  ASTERISK-29525

	  Change-Id: Ia2711b08f2b4d1177411b1be23e970d7fdff5784

2021-09-23 09:13 +0000 [ea36473c45]  Joshua C. Colp <jcolp@sangoma.com>

	* ari: Ignore invisible bridges when listing bridges.

	  When listing bridges we go through the ones present in
	  ARI, get their snapshot, turn it into JSON, and add it
	  to the payload we ultimately return.

	  An invisible "dial bridge" exists within ARI that would
	  also try to be added to this payload if the channel
	  "create" and "dial" routes were used. This would ultimately
	  fail due to invisible bridges having no snapshot
	  resulting in the listing of bridges failing.

	  This change makes it so that the listing of bridges
	  ignores invisible ones.

	  ASTERISK-29668

	  Change-Id: I14fa4b589b4657d1c2a5226b0f527f45a0cd370a

2021-09-19 06:14 +0000 [484da42d6c]  Naveen Albert <asterisk@phreaknet.org>

	* func_vmcount: Add support for multiple mailboxes

	  Allows multiple mailboxes to be specified for VMCOUNT
	  instead of just one.

	  ASTERISK-29661 #close

	  Change-Id: I9108528300795fd5b607efa9d4dd7b74be031813

2021-09-21 09:58 +0000 [e98839b73c]  Sean Bright <sean.bright@gmail.com>

	* message.c: Support 'To' header override with AMI's MessageSend.

	  The MessageSend AMI action has been updated to allow the Destination
	  and the To addresses to be provided separately. This brings the
	  MessageSend manager command in line with the capabilities of the
	  MessageSend dialplan application.

	  ASTERISK-29663 #close

	  Change-Id: I8513168d3e189a9fed88aaab6f5547ccb50d332c

2021-09-15 13:21 +0000 [cf0d656ae6]  Naveen Albert <asterisk@phreaknet.org>

	* func_channel: Add CHANNEL_EXISTS function.

	  Adds a function to check for the existence of a channel by
	  name or by UNIQUEID.

	  ASTERISK-29656 #close

	  Change-Id: Ib464e9eb6e13dc683a846286798fecff4fd943cb

2021-09-05 13:11 +0000 [cfd0246d11]  Naveen Albert <asterisk@phreaknet.org>

	* app_queue: Fix hint updates for included contexts

	  Previously, if custom hints were used with the hint:
	  format in app_queue, when device state changes occured,
	  app_queue would only do a literal string comparison of
	  the context used for the hint in app_queue and the context
	  of the hint which just changed state. This caused hints
	  to not update and become stale if the context associated
	  with the agent included the context which actually changes
	  state, essentially completely breaking device state for
	  any such agents defined in this manner.

	  This fix adds an additional check to ensure that included
	  contexts are also compared against the context which changed
	  state, so that the behavior is correct no matter whether the
	  context is specified to app_queue directly or indirectly.

	  ASTERISK-29578 #close

	  Change-Id: I8caf2f8da8157ef3d9ea71a8568c1eec95592b78

2021-09-10 09:40 +0000 [b2c834e349]  Sean Bright <sean.bright@gmail.com>

	* res_http_media_cache.c: Compare unaltered MIME types.

	  Rather than stripping parameters from Content-Type headers before
	  comparison, first try to compare the whole string. If no match is
	  found, strip the parameters and try that way.

	  ASTERISK-29275 #close

	  Change-Id: I2963c8ecbb3a9605b78b6421c415108d77a66a0f

2021-07-25 17:19 +0000 [a65bb134f5]  Naveen Albert <asterisk@phreaknet.org>

	* logger: Add custom logging capabilities

	  Adds the ability for users to log to custom log levels
	  by providing custom log level names in logger.conf. Also
	  adds a logger show levels CLI command.

	  ASTERISK-29529

	  Change-Id: If082703cf81a436ae5a565c75225fa8c0554b702

2021-09-17 10:57 +0000 [dce142baa4]  Sean Bright <sean.bright@gmail.com>

	* app_externalivr.c: Fix mixed leading whitespace in source code.

	  No functional changes.

	  Change-Id: I46514152c0af67f395526374aaa847ccd6a85378

2021-09-17 14:58 +0000 [03377c35fc]  Guido Falsi <madpilot@freebsd.org>

	* res_rtp_asterisk.c: Fix build failure when not building with pjproject.

	  Some code has been added referencing symbols defined in a block
	  protected by #ifdef HAVE_PJPROJECT. Protect those code parts in
	  ifdef blocks too.

	  ASTERISK-29660

	  Change-Id: Ib18d4392d51ac80ca5481dabf6e498a4e3e49e6f

2021-09-16 13:43 +0000  Asterisk Development Team <asteriskteam@digium.com>

	* asterisk 18.7.0-rc1 Released.

2021-09-16 08:39 +0000 [00cf86dafe]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.7.0
2021-09-13 10:18 +0000 [e8f7b53023]  Carlos Oliva <carlos.oliva@invoxcontact.com>

	* app_mp3: Force output to 16 bits in mpg123

	  In new mpg123 versions (since 1.26) the default output is 32 bits
	  Asterisk expects the output in 16 bits, so we force the output to be on 16 bits.
	  It will work wit new and old versions of mpg123.
	  Thanks Thomas Orgis <thomas-forum@orgis.org> for giving the key!

	  ASTERISK-29635 #close

	  Change-Id: I88c7740118b5af4e895bd8b765b68ed5c11fc816

2021-09-14 12:02 +0000 [0947c30224]  George Joseph <gjoseph@digium.com>

	* pjproject: Add patch to fix trailing whitespace issue in rtpmap

	  An issue was found where a particular manufacturer's phones add a
	  trailing space to the end of the rtpmap attribute when specifying
	  a payload type that has a "param" after the format name and clock
	  rate. For example:

	  a=rtpmap:120 opus/48000/2 \r\n

	  Because pjmedia_sdp_attr_get_rtpmap currently takes everything after
	  the second '/' up to the line end as the param, the space is
	  included in future comparisons, which then fail if the param being
	  compared to doesn't also have the space.

	  We now use pj_scan_get() to parse the param part of rtpmap so
	  trailing whitespace is automatically stripped.

	  ASTERISK-29654

	  Change-Id: Ibd0a4e243a69cde7ba9312275b13ab62ab86bc1b

2021-06-08 15:44 +0000 [1a23c9c047]  Naveen Albert <asterisk@phreaknet.org>

	* res_pjsip_caller_id: Add ANI2/OLI parsing

	  Adds parsing of ANI II digits (Originating
	  Line Information) to PJSIP, on par with
	  what currently exists in chan_sip.

	  ASTERISK-29472

	  Change-Id: Ifc938a7a7d45ce33999ebf3656a542226f6d3847

2021-06-28 10:37 +0000 [60daa8f761]  Naveen Albert <asterisk@phreaknet.org>

	* app_mf: Add channel agnostic MF sender

	  Adds a SendMF application and PlayMF manager
	  event to send arbitrary R1 MF tones on the
	  current or specified channel.

	  ASTERISK-29496

	  Change-Id: I5d89afdbccee3f86cc702ed96d882f3d351327a4

2021-09-10 09:56 +0000 [847349853a]  Sean Bright <sean.bright@gmail.com>

	* test_http_media_cache.c: Fix copy/paste error during test deregistration.

	  Change-Id: I9a3a978b2f818be464e062d97b93831b127ef28c

2021-09-02 18:20 +0000 [c736cef310]  Naveen Albert <asterisk@phreaknet.org>

	* app_stack: Include current location if branch fails

	  Previously, the error emitted when app_stack tries
	  to branch to a dialplan location that doesn't exist
	  has included only the information about the attempted
	  branch in the error log. This adds the current location
	  as well so users can see where the branch failed in
	  the logs.

	  ASTERISK-29626

	  Change-Id: Ia23502ab2ad21485a1ac74295063a8f25a6df5ce

2021-09-03 13:27 +0000 [d9747104ff]  Sungtae Kim <pchero21@gmail.com>

	* resource_channels.c: Fix external media data option

	  Fixed the external media creation handle to handle the 'data' option correctly.

	  ASTERISK-29629

	  Change-Id: I22e57fe8ebf3d3e08fb2121aa4a8a52cc62e8129

2021-09-02 18:57 +0000 [6198c1d28c]  Naveen Albert <asterisk@phreaknet.org>

	* func_strings: Add STRBETWEEN function

	  Adds the STRBETWEEN function, which can be used to insert a
	  substring between each character in a string. For instance,
	  this can be used to insert pauses between DTMF tones in a
	  string of digits.

	  ASTERISK-29627

	  Change-Id: Ice23009d4a8e9bb9718d2b2301d405567087d258

2021-09-08 14:29 +0000 [ee62a07914]  Sean Bright <sean.bright@gmail.com>

	* test_abstract_jb.c: Fix put and put_out_of_order memory leaks.

	  We can't rely on RAII_VAR(...) to properly clean up data that is
	  allocated within a loop.

	  ASTERISK-27176 #close

	  Change-Id: Ib575616101230c4f603519114ec62ebf3936882c

2021-09-02 19:00 +0000 [19de228e8b]  Naveen Albert <asterisk@phreaknet.org>

	* func_env: Add DIRNAME and BASENAME functions

	  Adds the DIRNAME and BASENAME functions, which are
	  wrappers around the corresponding C library functions.
	  These can be used to safely and conveniently work with
	  file paths and names in the dialplan.

	  ASTERISK-29628 #close

	  Change-Id: Id3aeb907f65c0ff96b6e57751ff0cb49d61db7f3

2021-07-26 12:46 +0000 [b6b7b1490b]  Naveen Albert <asterisk@phreaknet.org>

	* func_sayfiles: Retrieve say file names

	  Up until now, all of the logic used to translate
	  arguments to the Say applications has been
	  directly coupled to playback, preventing other
	  modules from using this logic.

	  This refactors code in say.c and adds a SAYFILES
	  function that can be used to retrieve the file
	  names that would be played. These can then be
	  used in other applications or for other purposes.

	  Additionally, a SayMoney application and a SayOrdinal
	  application are added. Both SayOrdinal and SayNumber
	  are also expanded to support integers greater than
	  one billion.

	  ASTERISK-29531

	  Change-Id: If9718c89353b8e153d84add3cc4637b79585db19

2021-08-09 12:41 +0000 [a6eb1b6f95]  Naveen Albert <asterisk@phreaknet.org>

	* res_tonedetect: Tone detection module

	  dsp.c contains arbitrary tone detection functionality
	  which is currently only used for fax tone recognition.
	  This change makes this functionality publicly
	  accessible so that other modules can take advantage
	  of this.

	  Additionally, a WaitForTone and TONE_DETECT app and
	  function are included to allow users to do their
	  own tone detection operations in the dialplan.

	  ASTERISK-29546

	  Change-Id: Ie38c395000f4fd4d04e942e8658e177f8f499b26

2021-09-08 09:36 +0000 [2806a45034]  George Joseph <gjoseph@digium.com>

	* res_snmp: Add -fPIC to _ASTCFLAGS

	  With gcc 11, res/res_snmp.c and res/snmp/agent.c need the
	  -fPIC option added to its _ASTCFLAGS.

	  ASTERISK-29634

	  Change-Id: I34649c85e075fd954e578378fabf798c3f038f50

2021-09-04 12:07 +0000 [858cb386fd]  Sean Bright <sean.bright@gmail.com>

	* term.c: Add support for extended number format terminfo files.

	  ncurses 6.1 introduced an extended number format for terminfo files
	  which the terminfo parsing in Asterisk is not able to parse. This
	  results in some TERM values that do support color (screen-256color on
	  Ubuntu 20.04 for example) to not get a color console.

	  ASTERISK-29630 #close

	  Change-Id: I27a4fcfab502219924af2d6b1c46feba92903cb3

2021-09-07 12:32 +0000 [347e9a7e4d]  Sean Bright <sean.bright@gmail.com>

	* app_voicemail.c: Ability to silence instructions if greeting is present.

	  There is an option to silence voicemail instructions but it does not
	  take into consideration if a recorded greeting exists or not. Add a
	  new 'S' option that does that.

	  ASTERISK-29632 #close

	  Change-Id: I03f2f043a9beb9d99deab302247e2a8686066fb4

2021-09-03 00:30 +0000 [c1a575907b]  Jasper Hafkenscheid <jasper.hafkenscheid@wearespindle.com>

	* res_srtp: Disable parsing of not enabled cryptos

	  When compiled without extended srtp crypto suites also disable parsing
	  these from received SDP. This prevents using these, as some client
	  implementations are not stable.

	  ASTERISK-29625

	  Change-Id: I7dafb29be1cdaabdc984002573f4bea87520533a

2021-09-06 11:37 +0000 [689c703b2c]  Sean Bright <sean.bright@gmail.com>

	* dns.c: Load IPv6 DNS resolvers if configured.

	  IPv6 nameserver addresses are stored in different part of the
	  __res_state structure, so look there if we appear to have support for
	  it.

	  ASTERISK-28004 #close

	  Change-Id: I67067077d8a406ee996664518d9c8fbf11f6977d

2021-09-08 07:52 +0000 [de19836c24]  George Joseph <gjoseph@digium.com>

	* bridge_softmix: Suppress error on topology change failure

	  There are conditions under which a failure to change topology
	  is expected so there's no need to print an ERROR message.

	  ASTERISK-29618
	  Reported by: Alexander

	  Change-Id: Idc168b8588e018bf3a23769f08c4ad646086d481

2021-08-31 02:50 +0000 [479cc17f45]  sungtae kim <sungtae.kim@avoxi.com>

	* resource_channels.c: Fix wrong external media parameter parse

	  Fixed ARI external media handler to accept body parameters.

	  ASTERISK-29622

	  Change-Id: I49509c48a6cbc0fb4165bfa4f834b5e8b9ace20d

2021-08-25 10:21 +0000 [5c836c8e36]  Sean Bright <sean.bright@gmail.com>

	* config_options: Handle ACO arrays correctly in generated XML docs.

	  There are 3 separate changes here but they are all closely related:

	  * Only try to set matchfield attributes on 'field' nodes

	  * We need to adjust how we treat the category pointer based on the
	    value of the category_match, to avoid memory corruption. We now
	    generate a regex-like string when match types other than
	    ACO_WHITELIST and ACO_BLACKLIST are used.

	  * Switch app_agent_pool from ACO_BLACKLIST_ARRAY to
	    ACO_BLACKLIST_EXACT since we only have one category we need to
	    ignore, not two.

	  ASTERISK-29614 #close

	  Change-Id: I7be7bdb1bb9814f942bc6bb4fdd0a55a7b7efe1e

2021-08-18 14:44 +0000 [5a685249ce]  Naveen Albert <asterisk@phreaknet.org>

	* chan_iax2: Add ANI2/OLI information element

	  Adds an information element for ANI2 so that
	  Originating Line Information can be transmitted
	  over IAX2 channels.

	  ASTERISK-29605 #close

	  Change-Id: Iaeacdf6ccde18eaff7f776a0f49fee87dcb549d2

2021-08-31 15:03 +0000 [042ae05be7]  Mark Murawski <markm@intellasoft.net>

	* pbx_ael:  Fix crash and lockup issue regarding 'ael reload'

	  Currently pbx_ael does not check if a reload is currently pending
	  before proceeding with a reload. This can cause multiple threads to
	  operate at the same time on what should be mutex protected data. This
	  change adds protection to reloading to ensure only one ael reload is
	  executing at a time.

	  ASTERISK-29609 #close

	  Change-Id: I5ed392ad226f6e4e7696ad742076d3e45c57af35

2021-08-25 06:49 +0000 [dd980e00b4]  Naveen Albert <asterisk@phreaknet.org>

	* app_read: Allow reading # as a digit

	  Allows for the digit # to be read as a digit,
	  just like any other DTMF digit, as opposed to
	  forcing it to be used as an end of input
	  indicator. The default behavior remains
	  unchanged.

	  ASTERISK-18454 #close

	  Change-Id: I3033432adb9d296ad227e76b540b8b4a2417665b

2021-04-05 14:06 +0000 [ac492f2ff8]  Sebastien Duthil <sduthil@wazo.community>

	* res_rtp_asterisk: Automatically refresh stunaddr from DNS

	  This allows the STUN server to change its IP address without having to
	  reload the res_rtp_asterisk module.

	  The refresh of the name resolution occurs first when the module is
	  loaded, then recurringly, slightly after the previous DNS answer TTL
	  expires.

	  ASTERISK-29508 #close

	  Change-Id: I7955a046293f913ba121bbd82153b04439e3465f

2021-08-24 20:04 +0000 [e660a2c03b]  Naveen Albert <asterisk@phreaknet.org>

	* bridge_basic: Change warning to verbose if transfer cancelled

	  The attended transfer feature will emit a warning if the user
	  cancels the transfer or the attended transfer doesn't complete
	  for any reason. Changes the warning to a verbose message,
	  since nothing is actually wrong here.

	  ASTERISK-29612 #close

	  Change-Id: I64c93cdb21360a0a8d45e9cb6db3af8168f66e6d

2021-08-20 15:35 +0000 [c7af46995e]  Naveen Albert <asterisk@phreaknet.org>

	* app_queue: Don't reset queue stats on reload

	  Prevents reloads of app_queue from also resetting
	  queue statistics.

	  Also preserves individual queue agent statistics
	  if we're just reloading members.

	  ASTERISK-28701

	  Change-Id: Ib5d4cdec175e44de38ef0f6ede4a7701751766f1

2021-08-25 09:23 +0000 [82d6bd7ec9]  Alexander Traud <pabstraud@compuserve.com>

	* res_rtp_asterisk: sqrt(.) requires the header math.h.

	  ASTERISK-29616

	  Change-Id: I6c01623926bf10ccac32612687a50fdab3ba0900

2021-08-25 09:29 +0000 [8410afc7ab]  Alexander Traud <pabstraud@compuserve.com>

	* dialplan: Add one static and fix two whitespace errors.

	  Change-Id: Ia14d515ab63e773097adc6af772ca7123a392f83

2021-06-19 23:36 +0000 [241686f860]  Sarah Autumn <sarah@connectionsmuseum.org>

	* sig_analog: Changes to improve electromechanical signalling compatibility

	  This changeset is intended to address compatibility issues encountered
	  when interfacing Asterisk to electromechanical telephone switches that
	  implement ANI-B, ANI-C, or ANI-D.

	  In particular the behaviours that this impacts include:

	   - FGC-CAMA did not work at all when using MF signaling. Modified the
	     switch case block to send calls to the correct part of the
	     signaling-handling state machine.

	   - For FGC-CAMA operation, the delay between called number ST and
	     second wink for ANI spill has been made configurable; previously
	     all calls were made to wait for one full second.

	   - After the ANI spill, previous behavior was to require a 'ST' tone
	     to advance the call.  This has been changed to allow 'STP' 'ST2P'
	     or 'ST3P' as well, for compatibility with ANI-D.

	   - Store ANI2 (ANI INFO) digits in the CALLERID(ANI2) channel variable.

	   - For calls with an ANI failure, No. 1 Crossbar switches will send
	     forward a single-digit failure code, with no calling number digits
	     and no ST pulse to terminate the spill.  I've made the ANI timeout
	     configurable so to reduce dead air time on calls with ANI fail.

	   - ANI info digits configurable.  Modern digital switches will send 2
	     digits, but ANI-B sends only a single info digit.  This caused the
	     ANI reported by Asterisk to be misaligned.

	   - Changed a confusing log message to be more informative.

	  ASTERISK-29518

	  Change-Id: Ib7e27d987aee4ed9bc3663c57ef413e21b404256

2021-08-05 11:55 +0000 [eb486db3af]  Andre Barbosa <andre.emanuel.barbosa@gmail.com>

	* media_cache: Don't lock when curl the remote file

	  When playing a remote sound file, which is not in cache, first we need
	  to download it with ast_bucket_file_retrieve.

	  This can take a while if the remote host is slow. The current CURL
	  timeout is 180secs, so in extreme situations, it can take 3 minutes to
	  return.

	  Because ast_media_cache_retrieve has a lock on all function, while we
	  are waiting for the delayed download, Asterisk is not able to play any
	  more files, even the files already cached locally.

	  ASTERISK-29544 #close

	  Change-Id: I8d4142b463ae4a1d4c41bff2bf63324821567408

2021-08-16 08:25 +0000 [b72425b1f0]  George Joseph <gjoseph@digium.com>

	* res_pjproject: Allow mapping to Asterisk TRACE level

	  Allow mapping pjproject log messages to the Asterisk TRACE
	  log level.  The defaults were also changes to log pjproject
	  levels 3,4 to DEBUG and 5,6 to TRACE.  Previously 3,4,5,6
	  all went to DEBUG.

	  ASTERISK-29582

	  Change-Id: I859a37a8dec263ed68099709cfbd3e665324c72d

2021-08-12 16:02 +0000 [dffc5e7f5c]  Naveen Albert <asterisk@phreaknet.org>

	* app_milliwatt: Timing fix

	  The Milliwatt application uses incorrect tone timings
	  that cause it to play the 1004 Hz tone constantly.

	  This adds an option to enable the correct timing
	  behavior, so that the Milliwatt application can
	  be used for milliwatt test lines. The default behavior
	  remains unchanged for compatability reasons, even
	  though it is incorrect.

	  ASTERISK-29575 #close

	  Change-Id: I73ccc6c6fcaa31931c6fff3b85ad1805b2ce9d8c

2021-06-28 09:25 +0000 [c52ef4ac79]  Naveen Albert <asterisk@phreaknet.org>

	* func_math: Return integer instead of float if possible

	  The MIN, MAX, and ABS functions all support float
	  arguments, but currently return floats even if the
	  arguments are all integers and the response is
	  a whole number, in which case the user is likely
	  expecting an integer. This casts the float to an integer
	  before printing into the response buffer if possible.

	  ASTERISK-29495

	  Change-Id: I902d29eacf3ecd0f8a6a5e433c97f0421d205488

2021-08-04 09:46 +0000 [9cac1c16da]  Naveen Albert <asterisk@phreaknet.org>

	* app_morsecode: Add American Morse code

	  Previously, the Morsecode application only supported international
	  Morse code. This adds support for American Morse code and adds an
	  option to configure the frequency used in off intervals.

	  Additionally, the application checks for hangup between tones
	  to prevent application execution from continuing after hangup.

	  ASTERISK-29541

	  Change-Id: I172431a2e18e6527d577e74adfb05b154cba7bd4

2021-08-04 14:16 +0000 [3eec5b8c5c]  Naveen Albert <asterisk@phreaknet.org>

	* func_scramble: Audio scrambler function

	  Adds a function to scramble audio on a channel using
	  whole spectrum frequency inversion. This can be used
	  as a privacy enhancement with applications like
	  ChanSpy or other potentially sensitive audio.

	  ASTERISK-29542

	  Change-Id: I01020769d91060a1f56a708eb405f87648d1a67e

2021-08-04 19:28 +0000 [cb1dfecc11]  Naveen Albert <asterisk@phreaknet.org>

	* app_originate: Add ability to set codecs

	  A list of codecs to use for dialplan-originated calls can
	  now be specified in Originate, similar to the ability
	  in call files and the manager action.

	  Additionally, we now default to just using the slin codec
	  for originated calls, rather than all the slin* codecs up
	  through slin192, which has been known to cause issues
	  and inconsistencies from AMI and call file behavior.

	  ASTERISK-29543

	  Change-Id: I96a1aeb83d54b635b7a51e1b4680f03791622883

2021-08-16 11:11 +0000 [a8e8b3aaff]  Alexander Traud <pabstraud@compuserve.com>

	* BuildSystem: Remove two dead exceptions for compiler Clang.

	  Commit 305ce3d added -Wno-parentheses-equality to Makefile.rules,
	  turning the previous two warning suppressions from commit e9520db
	  redundant. Let us remove the latter.

	  Change-Id: I0b471254b31e6e05902062761dded4b3e626c7ac

2021-08-10 12:41 +0000 [121860e3f6]  Sean Bright <sean.bright@gmail.com>

	* mgcp: Remove dead debug code

	  ASTERISK-20339 #close

	  Change-Id: I36f364aaa1971241d8f3ea1a5909b463d185a2d5

2021-08-11 06:15 +0000 [13fd0789a2]  Joshua C. Colp <jcolp@sangoma.com>

	* policy: Add deprecation and removal versions to modules.

	  app_meetme is deprecated in 19, to be removed in 21.
	  app_osplookup is deprecated in 19, to be removed in 21.
	  chan_alsa is deprecated in 19, to be removed in 21.
	  chan_mgcp is deprecated in 19, to be removed in 21.
	  chan_skinny is deprecated in 19, to be removed in 21.
	  res_pktccops is deprecated in 19, to be removed in 21.
	  cdr_mysql was deprecated in 1.8, to be removed in 19.
	  app_mysql was deprecated in 1.8, to be removed in 19.
	  app_ices was deprecated in 16, to be removed in 19.
	  app_macro was deprecated in 16, to be removed in 21.
	  app_fax was deprecated in 16, to be removed in 19.
	  app_url was deprecated in 16, to be removed in 19.
	  app_image was deprecated in 16, to be removed in 19.
	  app_nbscat was deprecated in 16, to be removed in 19.
	  app_dahdiras was deprecated in 16, to be removed in 19.
	  cdr_syslog was deprecated in 16, to be removed in 19.
	  chan_oss was deprecated in 16, to be removed in 19.
	  chan_phone was deprecated in 16, to be removed in 19.
	  chan_sip was deprecated in 17, to be removed in 21.
	  chan_nbs was deprecated in 16, to be removed in 19.
	  chan_misdn was deprecated in 16, to be removed in 19.
	  chan_vpb was deprecated in 16, to be removed in 19.
	  res_config_sqlite was deprecated in 16, to be removed in 19.
	  res_monitor was deprecated in 16, to be removed in 21.
	  conf2ael was deprecated in 16, to be removed in 19.
	  muted was deprecated in 16, to be removed in 19.

	  ASTERISK-29548
	  ASTERISK-29549
	  ASTERISK-29550
	  ASTERISK-29551
	  ASTERISK-29552
	  ASTERISK-29553
	  ASTERISK-29554
	  ASTERISK-29555
	  ASTERISK-29557
	  ASTERISK-29558
	  ASTERISK-29559
	  ASTERISK-29560
	  ASTERISK-29561
	  ASTERISK-29562
	  ASTERISK-29563
	  ASTERISK-29564
	  ASTERISK-29565
	  ASTERISK-29566
	  ASTERISK-29567
	  ASTERISK-29568
	  ASTERISK-29569
	  ASTERISK-29570
	  ASTERISK-29571
	  ASTERISK-29572
	  ASTERISK-29573
	  ASTERISK-29574

	  Change-Id: Ic3bee31a10d42c4b3bbc913d893f7b2a28a27131

2021-08-12 11:00 +0000 [288d018fb7]  Asterisk Development Team <asteriskteam@digium.com>

	* Update CHANGES and UPGRADE.txt for 18.6.0
2021-06-16 15:30 +0000 [118d848238]  Naveen Albert <asterisk@phreaknet.org>

	* func_frame_drop: New function

	  Adds function to selectively drop specified frames
	  in the TX or RX direction on a channel, including
	  control frames.

	  ASTERISK-29478

	  Change-Id: I8147c9d55d74e2e48861edba6b22f930920541ec

2021-08-02 12:33 +0000 [0b1a629ecd]  Alexander Traud <pabstraud@compuserve.com>

